/*!
 * /***********************************************************************
 * 
 * A JavaScript tokenizer / parser / beautifier / compressor.
 * https://github.com/mishoo/UglifyJS2
 * 
 * -------------------------------- (C) ---------------------------------
 * 
 *                          Author: Mihai Bazon
 *                        <mihai.bazon@gmail.com>
 *                      http://mihai.bazon.net/blog
 * 
 * Distributed under the BSD license:
 * 
 *   Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
 * 
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 * 
 *       * Redistributions of source code must retain the above
 *         copyright notice, this list of conditions and the following
 *         disclaimer.
 * 
 *       * Redistributions in binary form must reproduce the above
 *         copyright notice, this list of conditions and the following
 *         disclaimer in the documentation and/or other materials
 *         provided with the distribution.
 * 
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
 *   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *   PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
 *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 *   OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 *   TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 *   THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *   SUCH DAMAGE.
 * 
 * *********************************************************************** /
 */
window.uglify=function(e){var n={};function t(r){if(n[r])return n[r].exports;var i=n[r]={i:r,l:!1,exports:{}};return e[r].call(i.exports,i,i.exports,t),i.l=!0,i.exports}return t.m=e,t.c=n,t.d=function(e,n,r){t.o(e,n)||Object.defineProperty(e,n,{enumerable:!0,get:r})},t.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},t.t=function(e,n){if(1&n&&(e=t(e)),8&n)return e;if(4&n&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(t.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&n&&"string"!=typeof e)for(var i in e)t.d(r,i,function(n){return e[n]}.bind(null,i));return r},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,n){return Object.prototype.hasOwnProperty.call(e,n)},t.p="",t(t.s=5)}([function(e,n){n.getArg=function(e,n,t){if(n in e)return e[n];if(3===arguments.length)return t;throw new Error('"'+n+'" is a required argument.')};var t=/^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/,r=/^data:.+\,.+$/;function i(e){var n=e.match(t);return n?{scheme:n[1],auth:n[2],host:n[3],port:n[4],path:n[5]}:null}function o(e){var n="";return e.scheme&&(n+=e.scheme+":"),n+="//",e.auth&&(n+=e.auth+"@"),e.host&&(n+=e.host),e.port&&(n+=":"+e.port),e.path&&(n+=e.path),n}function a(e){var t=e,r=i(e);if(r){if(!r.path)return e;t=r.path}for(var a,s=n.isAbsolute(t),u=t.split(/\/+/),c=0,f=u.length-1;f>=0;f--)"."===(a=u[f])?u.splice(f,1):".."===a?c++:c>0&&(""===a?(u.splice(f+1,c),c=0):(u.splice(f,2),c--));return""===(t=u.join("/"))&&(t=s?"/":"."),r?(r.path=t,o(r)):t}function s(e,n){""===e&&(e="."),""===n&&(n=".");var t=i(n),s=i(e);if(s&&(e=s.path||"/"),t&&!t.scheme)return s&&(t.scheme=s.scheme),o(t);if(t||n.match(r))return n;if(s&&!s.host&&!s.path)return s.host=n,o(s);var u="/"===n.charAt(0)?n:a(e.replace(/\/+$/,"")+"/"+n);return s?(s.path=u,o(s)):u}n.urlParse=i,n.urlGenerate=o,n.normalize=a,n.join=s,n.isAbsolute=function(e){return"/"===e.charAt(0)||t.test(e)},n.relative=function(e,n){""===e&&(e="."),e=e.replace(/\/$/,"");for(var t=0;0!==n.indexOf(e+"/");){var r=e.lastIndexOf("/");if(r<0)return n;if((e=e.slice(0,r)).match(/^([^\/]+:\/)?\/*$/))return n;++t}return Array(t+1).join("../")+n.substr(e.length+1)};var u=!("__proto__"in Object.create(null));function c(e){return e}function f(e){if(!e)return!1;var n=e.length;if(n<9)return!1;if(95!==e.charCodeAt(n-1)||95!==e.charCodeAt(n-2)||111!==e.charCodeAt(n-3)||116!==e.charCodeAt(n-4)||111!==e.charCodeAt(n-5)||114!==e.charCodeAt(n-6)||112!==e.charCodeAt(n-7)||95!==e.charCodeAt(n-8)||95!==e.charCodeAt(n-9))return!1;for(var t=n-10;t>=0;t--)if(36!==e.charCodeAt(t))return!1;return!0}function l(e,n){return e===n?0:null===e?1:null===n?-1:e>n?1:-1}n.toSetString=u?c:function(e){return f(e)?"$"+e:e},n.fromSetString=u?c:function(e){return f(e)?e.slice(1):e},n.compareByOriginalPositions=function(e,n,t){var r=l(e.source,n.source);return 0!==r?r:0!=(r=e.originalLine-n.originalLine)?r:0!=(r=e.originalColumn-n.originalColumn)||t?r:0!=(r=e.generatedColumn-n.generatedColumn)?r:0!=(r=e.generatedLine-n.generatedLine)?r:l(e.name,n.name)},n.compareByGeneratedPositionsDeflated=function(e,n,t){var r=e.generatedLine-n.generatedLine;return 0!==r?r:0!=(r=e.generatedColumn-n.generatedColumn)||t?r:0!==(r=l(e.source,n.source))?r:0!=(r=e.originalLine-n.originalLine)?r:0!=(r=e.originalColumn-n.originalColumn)?r:l(e.name,n.name)},n.compareByGeneratedPositionsInflated=function(e,n){var t=e.generatedLine-n.generatedLine;return 0!==t?t:0!=(t=e.generatedColumn-n.generatedColumn)?t:0!==(t=l(e.source,n.source))?t:0!=(t=e.originalLine-n.originalLine)?t:0!=(t=e.originalColumn-n.originalColumn)?t:l(e.name,n.name)},n.parseSourceMapInput=function(e){return JSON.parse(e.replace(/^\)]}'[^\n]*\n/,""))},n.computeSourceURL=function(e,n,t){if(n=n||"",e&&("/"!==e[e.length-1]&&"/"!==n[0]&&(e+="/"),n=e+n),t){var r=i(t);if(!r)throw new Error("sourceMapURL could not be parsed");if(r.path){var u=r.path.lastIndexOf("/");u>=0&&(r.path=r.path.substring(0,u+1))}n=s(o(r),n)}return a(n)}},function(e,n){var t;t=function(){return this}();try{t=t||Function("return this")()||(0,eval)("this")}catch(e){"object"==typeof window&&(t=window)}e.exports=t},function(e,n,t){var r=t(3),i=t(0),o=t(4).ArraySet,a=t(12).MappingList;function s(e){e||(e={}),this._file=i.getArg(e,"file",null),this._sourceRoot=i.getArg(e,"sourceRoot",null),this._skipValidation=i.getArg(e,"skipValidation",!1),this._sources=new o,this._names=new o,this._mappings=new a,this._sourcesContents=null}s.prototype._version=3,s.fromSourceMap=function(e){var n=e.sourceRoot,t=new s({file:e.file,sourceRoot:n});return e.eachMapping(function(e){var r={generated:{line:e.generatedLine,column:e.generatedColumn}};null!=e.source&&(r.source=e.source,null!=n&&(r.source=i.relative(n,r.source)),r.original={line:e.originalLine,column:e.originalColumn},null!=e.name&&(r.name=e.name)),t.addMapping(r)}),e.sources.forEach(function(r){var o=r;null!==n&&(o=i.relative(n,r)),t._sources.has(o)||t._sources.add(o);var a=e.sourceContentFor(r);null!=a&&t.setSourceContent(r,a)}),t},s.prototype.addMapping=function(e){var n=i.getArg(e,"generated"),t=i.getArg(e,"original",null),r=i.getArg(e,"source",null),o=i.getArg(e,"name",null);this._skipValidation||this._validateMapping(n,t,r,o),null!=r&&(r=String(r),this._sources.has(r)||this._sources.add(r)),null!=o&&(o=String(o),this._names.has(o)||this._names.add(o)),this._mappings.add({generatedLine:n.line,generatedColumn:n.column,originalLine:null!=t&&t.line,originalColumn:null!=t&&t.column,source:r,name:o})},s.prototype.setSourceContent=function(e,n){var t=e;null!=this._sourceRoot&&(t=i.relative(this._sourceRoot,t)),null!=n?(this._sourcesContents||(this._sourcesContents=Object.create(null)),this._sourcesContents[i.toSetString(t)]=n):this._sourcesContents&&(delete this._sourcesContents[i.toSetString(t)],0===Object.keys(this._sourcesContents).length&&(this._sourcesContents=null))},s.prototype.applySourceMap=function(e,n,t){var r=n;if(null==n){if(null==e.file)throw new Error('SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map\'s "file" property. Both were omitted.');r=e.file}var a=this._sourceRoot;null!=a&&(r=i.relative(a,r));var s=new o,u=new o;this._mappings.unsortedForEach(function(n){if(n.source===r&&null!=n.originalLine){var o=e.originalPositionFor({line:n.originalLine,column:n.originalColumn});null!=o.source&&(n.source=o.source,null!=t&&(n.source=i.join(t,n.source)),null!=a&&(n.source=i.relative(a,n.source)),n.originalLine=o.line,n.originalColumn=o.column,null!=o.name&&(n.name=o.name))}var c=n.source;null==c||s.has(c)||s.add(c);var f=n.name;null==f||u.has(f)||u.add(f)},this),this._sources=s,this._names=u,e.sources.forEach(function(n){var r=e.sourceContentFor(n);null!=r&&(null!=t&&(n=i.join(t,n)),null!=a&&(n=i.relative(a,n)),this.setSourceContent(n,r))},this)},s.prototype._validateMapping=function(e,n,t,r){if(n&&"number"!=typeof n.line&&"number"!=typeof n.column)throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");if((!(e&&"line"in e&&"column"in e&&e.line>0&&e.column>=0)||n||t||r)&&!(e&&"line"in e&&"column"in e&&n&&"line"in n&&"column"in n&&e.line>0&&e.column>=0&&n.line>0&&n.column>=0&&t))throw new Error("Invalid mapping: "+JSON.stringify({generated:e,source:t,original:n,name:r}))},s.prototype._serializeMappings=function(){for(var e,n,t,o,a=0,s=1,u=0,c=0,f=0,l=0,p="",h=this._mappings.toArray(),d=0,m=h.length;d<m;d++){if(e="",(n=h[d]).generatedLine!==s)for(a=0;n.generatedLine!==s;)e+=";",s++;else if(d>0){if(!i.compareByGeneratedPositionsInflated(n,h[d-1]))continue;e+=","}e+=r.encode(n.generatedColumn-a),a=n.generatedColumn,null!=n.source&&(o=this._sources.indexOf(n.source),e+=r.encode(o-l),l=o,e+=r.encode(n.originalLine-1-c),c=n.originalLine-1,e+=r.encode(n.originalColumn-u),u=n.originalColumn,null!=n.name&&(t=this._names.indexOf(n.name),e+=r.encode(t-f),f=t)),p+=e}return p},s.prototype._generateSourcesContent=function(e,n){return e.map(function(e){if(!this._sourcesContents)return null;null!=n&&(e=i.relative(n,e));var t=i.toSetString(e);return Object.prototype.hasOwnProperty.call(this._sourcesContents,t)?this._sourcesContents[t]:null},this)},s.prototype.toJSON=function(){var e={version:this._version,sources:this._sources.toArray(),names:this._names.toArray(),mappings:this._serializeMappings()};return null!=this._file&&(e.file=this._file),null!=this._sourceRoot&&(e.sourceRoot=this._sourceRoot),this._sourcesContents&&(e.sourcesContent=this._generateSourcesContent(e.sources,e.sourceRoot)),e},s.prototype.toString=function(){return JSON.stringify(this.toJSON())},n.SourceMapGenerator=s},function(e,n,t){var r=t(11);n.encode=function(e){var n,t="",i=function(e){return e<0?1+(-e<<1):0+(e<<1)}(e);do{n=31&i,(i>>>=5)>0&&(n|=32),t+=r.encode(n)}while(i>0);return t},n.decode=function(e,n,t){var i,o,a=e.length,s=0,u=0;do{if(n>=a)throw new Error("Expected more digits in base 64 VLQ value.");if(-1===(o=r.decode(e.charCodeAt(n++))))throw new Error("Invalid base64 digit: "+e.charAt(n-1));i=!!(32&o),s+=(o&=31)<<u,u+=5}while(i);t.value=function(e){var n=e>>1;return 1==(1&e)?-n:n}(s),t.rest=n}},function(e,n,t){var r=t(0),i=Object.prototype.hasOwnProperty,o="undefined"!=typeof Map;function a(){this._array=[],this._set=o?new Map:Object.create(null)}a.fromArray=function(e,n){for(var t=new a,r=0,i=e.length;r<i;r++)t.add(e[r],n);return t},a.prototype.size=function(){return o?this._set.size:Object.getOwnPropertyNames(this._set).length},a.prototype.add=function(e,n){var t=o?e:r.toSetString(e),a=o?this.has(e):i.call(this._set,t),s=this._array.length;a&&!n||this._array.push(e),a||(o?this._set.set(e,s):this._set[t]=s)},a.prototype.has=function(e){if(o)return this._set.has(e);var n=r.toSetString(e);return i.call(this._set,n)},a.prototype.indexOf=function(e){if(o){var n=this._set.get(e);if(n>=0)return n}else{var t=r.toSetString(e);if(i.call(this._set,t))return this._set[t]}throw new Error('"'+e+'" is not in the set.')},a.prototype.at=function(e){if(e>=0&&e<this._array.length)return this._array[e];throw new Error("No element indexed by "+e)},a.prototype.toArray=function(){return this._array.slice()},n.ArraySet=a},function(e,n,t){(function(e,r){!function(n,t){"use strict";function i(e){return e.split("")}function o(e,n){return n.indexOf(e)>=0}function a(e,n){for(var t=0,r=n.length;t<r;++t)if(e(n[t]))return n[t]}function s(e){Object.defineProperty(e.prototype,"stack",{get:function(){var e=new Error(this.message);e.name=this.name;try{throw e}catch(e){return e.stack}}})}function u(e,n){this.message=e,this.defs=n}function c(e,n,t){!0===e&&(e={});var r=e||{};if(t)for(var i in r)A(r,i)&&!A(n,i)&&u.croak("`"+i+"` is not a supported option",n);for(var i in n)A(n,i)&&(r[i]=e&&A(e,i)?e[i]:n[i]);return r}function f(e,n){var t=0;for(var r in n)A(n,r)&&(e[r]=n[r],t++);return t}function l(){}function p(){return!1}function h(){return!0}function d(){return this}function m(){return null}u.prototype=Object.create(Error.prototype),u.prototype.constructor=u,u.prototype.name="DefaultsError",s(u),u.croak=function(e,n){throw new u(e,n)};var _=function(){function e(e,o,a){var s,u=[],c=[];function f(){var f=o(e[s],s),l=f instanceof i;return l&&(f=f.v),f instanceof t?(f=f.v)instanceof r?c.push.apply(c,a?f.v.slice().reverse():f.v):c.push(f):f!==n&&(f instanceof r?u.push.apply(u,a?f.v.slice().reverse():f.v):u.push(f)),l}if(e instanceof Array)if(a){for(s=e.length;--s>=0&&!f(););u.reverse(),c.reverse()}else for(s=0;s<e.length&&!f();++s);else for(s in e)if(A(e,s)&&f())break;return c.concat(u)}e.at_top=function(e){return new t(e)},e.splice=function(e){return new r(e)},e.last=function(e){return new i(e)};var n=e.skip={};function t(e){this.v=e}function r(e){this.v=e}function i(e){this.v=e}return e}();function g(e,n){e.indexOf(n)<0&&e.push(n)}function v(e,n){return e.replace(/\{(.+?)\}/g,function(e,t){return n&&n[t]})}function D(e,n){for(var t=e.length;--t>=0;)e[t]===n&&e.splice(t,1)}function y(e,n){if(e.length<2)return e.slice();return function e(t){if(t.length<=1)return t;var r=Math.floor(t.length/2),i=t.slice(0,r),o=t.slice(r);return function(e,t){for(var r=[],i=0,o=0,a=0;i<e.length&&o<t.length;)n(e[i],t[o])<=0?r[a++]=e[i++]:r[a++]=t[o++];return i<e.length&&r.push.apply(r,e.slice(i)),o<t.length&&r.push.apply(r,t.slice(o)),r}(i=e(i),o=e(o))}(e)}function b(e){e instanceof Array||(e=e.split(" "));var n="",t=[];e:for(var r=0;r<e.length;++r){for(var i=0;i<t.length;++i)if(t[i][0].length==e[r].length){t[i].push(e[r]);continue e}t.push([e[r]])}function o(e){return JSON.stringify(e).replace(/[\u2028\u2029]/g,function(e){switch(e){case"\u2028":return"\\u2028";case"\u2029":return"\\u2029"}return e})}function a(e){if(1==e.length)return n+="return str === "+o(e[0])+";";n+="switch(str){";for(var t=0;t<e.length;++t)n+="case "+o(e[t])+":";n+="return true}return false;"}if(t.length>3){t.sort(function(e,n){return n.length-e.length}),n+="switch(str.length){";for(r=0;r<t.length;++r){var s=t[r];n+="case "+s[0].length+":",a(s)}n+="}"}else a(e);return new Function("str",n)}function w(e,n){for(var t=e.length;--t>=0;)if(!n(e[t]))return!1;return!0}function E(){this._values=Object.create(null),this._size=0}function A(e,n){return Object.prototype.hasOwnProperty.call(e,n)}function C(e){for(var n,t=e.parent(-1),r=0;n=e.parent(r);r++){if(n instanceof B&&n.body===t)return!0;if(!(n instanceof Se&&n.expressions[0]===t||"Call"==n.TYPE&&n.expression===t||n instanceof Oe&&n.expression===t||n instanceof Me&&n.expression===t||n instanceof ze&&n.condition===t||n instanceof Le&&n.left===t||n instanceof Pe&&n.expression===t))return!1;t=n}}function F(e,n,r,i){arguments.length<4&&(i=k);var o=n=n?n.split(/\s+/):[];i&&i.PROPS&&(n=n.concat(i.PROPS));for(var a="return function AST_"+e+"(props){ if (props) { ",s=n.length;--s>=0;)a+="this."+n[s]+" = props."+n[s]+";";var u=i&&new i;(u&&u.initialize||r&&r.initialize)&&(a+="this.initialize();"),a+="}}";var c=new Function(a)();if(u&&(c.prototype=u,c.BASE=i),i&&i.SUBCLASSES.push(c),c.prototype.CTOR=c,c.PROPS=n||null,c.SELF_PROPS=o,c.SUBCLASSES=[],e&&(c.prototype.TYPE=c.TYPE=e),r)for(s in r)A(r,s)&&(/^\$/.test(s)?c[s.substr(1)]=r[s]:c.prototype[s]=r[s]);return c.DEFMETHOD=function(e,n){this.prototype[e]=n},void 0!==t&&(t["AST_"+e]=c),c}E.prototype={set:function(e,n){return this.has(e)||++this._size,this._values["$"+e]=n,this},add:function(e,n){return this.has(e)?this.get(e).push(n):this.set(e,[n]),this},get:function(e){return this._values["$"+e]},del:function(e){return this.has(e)&&(--this._size,delete this._values["$"+e]),this},has:function(e){return"$"+e in this._values},each:function(e){for(var n in this._values)e(this._values[n],n.substr(1))},size:function(){return this._size},map:function(e){var n=[];for(var t in this._values)n.push(e(this._values[t],t.substr(1)));return n},clone:function(){var e=new E;for(var n in this._values)e._values[n]=this._values[n];return e._size=this._size,e},toObject:function(){return this._values}},E.fromObject=function(e){var n=new E;return n._size=f(n._values,e),n};var x=F("Token","type value line col pos endline endcol endpos nlb comments_before comments_after file raw",{},null),k=F("Node","start end",{_clone:function(e){if(e){var n=this.clone();return n.transform(new yt(function(e){if(e!==n)return e.clone(!0)}))}return new this.CTOR(this)},clone:function(e){return this._clone(e)},$documentation:"Base class of all AST nodes",$propdoc:{start:"[AST_Token] The first token of this node",end:"[AST_Token] The last token of this node"},_walk:function(e){return e._visit(this)},walk:function(e){return this._walk(e)}},null);k.warn_function=null,k.warn=function(e,n){k.warn_function&&k.warn_function(v(e,n))};var B=F("Statement",null,{$documentation:"Base class of all statements"}),S=F("Debugger",null,{$documentation:"Represents a debugger statement"},B),T=F("Directive","value quote",{$documentation:'Represents a directive, like "use strict";',$propdoc:{value:"[string] The value of this directive as a plain string (it's not an AST_String!)",quote:"[string] the original quote character"}},B),O=F("SimpleStatement","body",{$documentation:"A statement consisting of an expression, i.e. a = 1 + 2",$propdoc:{body:"[AST_Node] an expression node (should not be instanceof AST_Statement)"},_walk:function(e){return e._visit(this,function(){this.body._walk(e)})}},B);function M(e,n){var t=e.body;if(t instanceof k)t._walk(n);else for(var r=0,i=t.length;r<i;r++)t[r]._walk(n)}var R=F("Block","body",{$documentation:"A body of statements (usually bracketed)",$propdoc:{body:"[AST_Statement*] an array of statements"},_walk:function(e){return e._visit(this,function(){M(this,e)})}},B),$=F("BlockStatement",null,{$documentation:"A block statement"},R),P=F("EmptyStatement",null,{$documentation:"The empty statement (empty block or simply a semicolon)"},B),L=F("StatementWithBody","body",{$documentation:"Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",$propdoc:{body:"[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"}},B),z=F("LabeledStatement","label",{$documentation:"Statement with a label",$propdoc:{label:"[AST_Label] a label definition"},_walk:function(e){return e._visit(this,function(){this.label._walk(e),this.body._walk(e)})},clone:function(e){var n=this._clone(e);if(e){var t=n.label,r=this.label;n.walk(new Pn(function(e){e instanceof ce&&e.label&&e.label.thedef===r&&(e.label.thedef=t,t.references.push(e))}))}return n}},L),U=F("IterationStatement",null,{$documentation:"Internal class.  All loops inherit from it."},L),q=F("DWLoop","condition",{$documentation:"Base class for do/while statements",$propdoc:{condition:"[AST_Node] the loop condition.  Should not be instanceof AST_Statement"}},U),I=F("Do",null,{$documentation:"A `do` statement",_walk:function(e){return e._visit(this,function(){this.body._walk(e),this.condition._walk(e)})}},q),N=F("While",null,{$documentation:"A `while` statement",_walk:function(e){return e._visit(this,function(){this.condition._walk(e),this.body._walk(e)})}},q),j=F("For","init condition step",{$documentation:"A `for` statement",$propdoc:{init:"[AST_Node?] the `for` initialization code, or null if empty",condition:"[AST_Node?] the `for` termination clause, or null if empty",step:"[AST_Node?] the `for` update clause, or null if empty"},_walk:function(e){return e._visit(this,function(){this.init&&this.init._walk(e),this.condition&&this.condition._walk(e),this.step&&this.step._walk(e),this.body._walk(e)})}},U),H=F("ForIn","init object",{$documentation:"A `for ... in` statement",$propdoc:{init:"[AST_Node] the `for/in` initialization code",object:"[AST_Node] the object that we're looping through"},_walk:function(e){return e._visit(this,function(){this.init._walk(e),this.object._walk(e),this.body._walk(e)})}},U),Y=F("ForOf",null,{$documentation:"A `for ... of` statement"},H),V=F("With","expression",{$documentation:"A `with` statement",$propdoc:{expression:"[AST_Node] the `with` expression"},_walk:function(e){return e._visit(this,function(){this.expression._walk(e),this.body._walk(e)})}},L),G=F("Scope","variables functions uses_with uses_eval parent_scope enclosed cname",{$documentation:"Base class for all statements introducing a lexical scope",$propdoc:{variables:"[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope",functions:"[Object/S] like `variables`, but only lists function declarations",uses_with:"[boolean/S] tells whether this scope uses the `with` statement",uses_eval:"[boolean/S] tells whether this scope contains a direct call to the global `eval`",parent_scope:"[AST_Scope?/S] link to the parent scope",enclosed:"[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",cname:"[integer/S] current index for mangling variables (used internally by the mangler)"},get_defun_scope:function(){for(var e=this;e.is_block_scope();)e=e.parent_scope;return e},clone:function(e){var n=this._clone(e);return this.variables&&(n.variables=this.variables.clone()),this.functions&&(n.functions=this.functions.clone()),this.enclosed&&(n.enclosed=this.enclosed.slice()),n}},R),W=F("Toplevel","globals",{$documentation:"The toplevel scope",$propdoc:{globals:"[Object/S] a map of name -> SymbolDef for all undeclared names"},wrap_commonjs:function(e){var n=this.body,t="(function(exports){'$ORIG';})(typeof "+e+"=='undefined'?("+e+"={}):"+e+");";return t=(t=Dt(t)).transform(new yt(function(e){if(e instanceof T&&"$ORIG"==e.value)return _.splice(n)}))}},G),J=F("Expansion","expression",{$documentation:"An expandible argument, such as ...rest, a splat, such as [1,2,...all], or an expansion in a variable declaration, such as var [first, ...rest] = list",$propdoc:{expression:"[AST_Node] the thing to be expanded"},_walk:function(e){var n=this;return e._visit(this,function(){n.expression.walk(e)})}}),X=F("Lambda","name argnames uses_arguments is_generator async",{$documentation:"Base class for functions",$propdoc:{name:"[AST_SymbolDeclaration?] the name of this function",argnames:"[AST_SymbolFunarg|AST_Destructuring|AST_Expansion|AST_DefaultAssign*] array of function arguments, destructurings, or expanding arguments",uses_arguments:"[boolean/S] tells whether this function accesses the arguments array",is_generator:"[boolean] is this a generator method",async:"[boolean] is this method async"},args_as_names:function(){for(var e=[],n=0;n<this.argnames.length;n++)this.argnames[n]instanceof ne?e=e.concat(this.argnames[n].all_symbols()):e.push(this.argnames[n]);return e},_walk:function(e){return e._visit(this,function(){this.name&&this.name._walk(e);for(var n=this.argnames,t=0,r=n.length;t<r;t++)n[t]._walk(e);M(this,e)})}},G),Z=F("Accessor",null,{$documentation:"A setter/getter function.  The `name` property is always null."},X),Q=F("Function","inlined",{$documentation:"A function expression"},X),K=F("Arrow","inlined",{$documentation:"An ES6 Arrow function ((a) => b)"},X),ee=F("Defun","inlined",{$documentation:"A function definition"},X),ne=F("Destructuring","names is_array",{$documentation:"A destructuring of several names. Used in destructuring assignment and with destructuring function argument names",$propdoc:{names:"[AST_Node*] Array of properties or elements",is_array:"[Boolean] Whether the destructuring represents an object or array"},_walk:function(e){return e._visit(this,function(){this.names.forEach(function(n){n._walk(e)})})},all_symbols:function(){var e=[];return this.walk(new Pn(function(n){n instanceof Ze&&e.push(n),n instanceof J&&e.push(n.expression)})),e}}),te=F("PrefixedTemplateString","template_string prefix",{$documentation:"A templatestring with a prefix, such as String.raw`foobarbaz`",$propdoc:{template_string:"[AST_TemplateString] The template string",prefix:"[AST_SymbolRef|AST_PropAccess] The prefix, which can be a symbol such as `foo` or a dotted expression such as `String.raw`."},_walk:function(e){this.prefix._walk(e),this.template_string._walk(e)}}),re=F("TemplateString","segments",{$documentation:"A template string literal",$propdoc:{segments:"[AST_Node*] One or more segments, starting with AST_TemplateSegment. AST_Node may follow AST_TemplateSegment, but each AST_Node must be followed by AST_TemplateSegment."},_walk:function(e){return e._visit(this,function(){this.segments.forEach(function(n){n._walk(e)})})}}),ie=F("TemplateSegment","value raw",{$documentation:"A segment of a template string literal",$propdoc:{value:"Content of the segment",raw:"Raw content of the segment"}}),oe=F("Jump",null,{$documentation:"Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"},B),ae=F("Exit","value",{$documentation:"Base class for “exits” (`return` and `throw`)",$propdoc:{value:"[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"},_walk:function(e){return e._visit(this,this.value&&function(){this.value._walk(e)})}},oe),se=F("Return",null,{$documentation:"A `return` statement"},ae),ue=F("Throw",null,{$documentation:"A `throw` statement"},ae),ce=F("LoopControl","label",{$documentation:"Base class for loop control statements (`break` and `continue`)",$propdoc:{label:"[AST_LabelRef?] the label, or null if none"},_walk:function(e){return e._visit(this,this.label&&function(){this.label._walk(e)})}},oe),fe=F("Break",null,{$documentation:"A `break` statement"},ce),le=F("Continue",null,{$documentation:"A `continue` statement"},ce),pe=F("If","condition alternative",{$documentation:"A `if` statement",$propdoc:{condition:"[AST_Node] the `if` condition",alternative:"[AST_Statement?] the `else` part, or null if not present"},_walk:function(e){return e._visit(this,function(){this.condition._walk(e),this.body._walk(e),this.alternative&&this.alternative._walk(e)})}},L),he=F("Switch","expression",{$documentation:"A `switch` statement",$propdoc:{expression:"[AST_Node] the `switch` “discriminant”"},_walk:function(e){return e._visit(this,function(){this.expression._walk(e),M(this,e)})}},R),de=F("SwitchBranch",null,{$documentation:"Base class for `switch` branches"},R),me=F("Default",null,{$documentation:"A `default` switch branch"},de),_e=F("Case","expression",{$documentation:"A `case` switch branch",$propdoc:{expression:"[AST_Node] the `case` expression"},_walk:function(e){return e._visit(this,function(){this.expression._walk(e),M(this,e)})}},de),ge=F("Try","bcatch bfinally",{$documentation:"A `try` statement",$propdoc:{bcatch:"[AST_Catch?] the catch block, or null if not present",bfinally:"[AST_Finally?] the finally block, or null if not present"},_walk:function(e){return e._visit(this,function(){M(this,e),this.bcatch&&this.bcatch._walk(e),this.bfinally&&this.bfinally._walk(e)})}},R),ve=F("Catch","argname",{$documentation:"A `catch` node; only makes sense as part of a `try` statement",$propdoc:{argname:"[AST_SymbolCatch|AST_Destructuring|AST_Expansion|AST_DefaultAssign] symbol for the exception"},_walk:function(e){return e._visit(this,function(){this.argname._walk(e),M(this,e)})}},R),De=F("Finally",null,{$documentation:"A `finally` node; only makes sense as part of a `try` statement"},R),ye=F("Definitions","definitions",{$documentation:"Base class for `var` or `const` nodes (variable declarations/initializations)",$propdoc:{definitions:"[AST_VarDef*] array of variable definitions"},_walk:function(e){return e._visit(this,function(){for(var n=this.definitions,t=0,r=n.length;t<r;t++)n[t]._walk(e)})}},B),be=F("Var",null,{$documentation:"A `var` statement"},ye),we=F("Let",null,{$documentation:"A `let` statement"},ye),Ee=F("Const",null,{$documentation:"A `const` statement"},ye),Ae=F("NameMapping","foreign_name name",{$documentation:"The part of the export/import statement that declare names from a module.",$propdoc:{foreign_name:"[AST_SymbolExportForeign|AST_SymbolImportForeign] The name being exported/imported (as specified in the module)",name:"[AST_SymbolExport|AST_SymbolImport] The name as it is visible to this module."},_walk:function(e){return e._visit(this,function(){this.foreign_name._walk(e),this.name._walk(e)})}}),Ce=F("Import","imported_name imported_names module_name",{$documentation:"An `import` statement",$propdoc:{imported_name:"[AST_SymbolImport] The name of the variable holding the module's default export.",imported_names:"[AST_NameMapping*] The names of non-default imported variables",module_name:"[AST_String] String literal describing where this module came from"},_walk:function(e){return e._visit(this,function(){this.imported_name&&this.imported_name._walk(e),this.imported_names&&this.imported_names.forEach(function(n){n._walk(e)}),this.module_name._walk(e)})}}),Fe=F("Export","exported_definition exported_value is_default exported_names module_name",{$documentation:"An `export` statement",$propdoc:{exported_definition:"[AST_Defun|AST_Definitions|AST_DefClass?] An exported definition",exported_value:"[AST_Node?] An exported value",exported_names:"[AST_NameMapping*?] List of exported names",module_name:"[AST_String?] Name of the file to load exports from",is_default:"[Boolean] Whether this is the default exported value of this module"},_walk:function(e){e._visit(this,function(){this.exported_definition&&this.exported_definition._walk(e),this.exported_value&&this.exported_value._walk(e),this.exported_names&&this.exported_names.forEach(function(n){n._walk(e)}),this.module_name&&this.module_name._walk(e)})}},B),xe=F("VarDef","name value",{$documentation:"A variable declaration; only appears in a AST_Definitions node",$propdoc:{name:"[AST_Destructuring|AST_SymbolConst|AST_SymbolLet|AST_SymbolVar] name of the variable",value:"[AST_Node?] initializer, or null of there's no initializer"},_walk:function(e){return e._visit(this,function(){this.name._walk(e),this.value&&this.value._walk(e)})}}),ke=F("Call","expression args",{$documentation:"A function call expression",$propdoc:{expression:"[AST_Node] expression to invoke as function",args:"[AST_Node*] array of arguments"},_walk:function(e){return e._visit(this,function(){for(var n=this.args,t=0,r=n.length;t<r;t++)n[t]._walk(e);this.expression._walk(e)})}}),Be=F("New",null,{$documentation:"An object instantiation.  Derives from a function call since it has exactly the same properties"},ke),Se=F("Sequence","expressions",{$documentation:"A sequence expression (comma-separated expressions)",$propdoc:{expressions:"[AST_Node*] array of expressions (at least two)"},_walk:function(e){return e._visit(this,function(){this.expressions.forEach(function(n){n._walk(e)})})}}),Te=F("PropAccess","expression property",{$documentation:'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',$propdoc:{expression:"[AST_Node] the “container” expression",property:"[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"}}),Oe=F("Dot",null,{$documentation:"A dotted property access expression",_walk:function(e){return e._visit(this,function(){this.expression._walk(e)})}},Te),Me=F("Sub",null,{$documentation:'Index-style property access, i.e. `a["foo"]`',_walk:function(e){return e._visit(this,function(){this.expression._walk(e),this.property._walk(e)})}},Te),Re=F("Unary","operator expression",{$documentation:"Base class for unary expressions",$propdoc:{operator:"[string] the operator",expression:"[AST_Node] expression that this unary operator applies to"},_walk:function(e){return e._visit(this,function(){this.expression._walk(e)})}}),$e=F("UnaryPrefix",null,{$documentation:"Unary prefix expression, i.e. `typeof i` or `++i`"},Re),Pe=F("UnaryPostfix",null,{$documentation:"Unary postfix expression, i.e. `i++`"},Re),Le=F("Binary","operator left right",{$documentation:"Binary expression, i.e. `a + b`",$propdoc:{left:"[AST_Node] left-hand side expression",operator:"[string] the operator",right:"[AST_Node] right-hand side expression"},_walk:function(e){return e._visit(this,function(){this.left._walk(e),this.right._walk(e)})}}),ze=F("Conditional","condition consequent alternative",{$documentation:"Conditional expression using the ternary operator, i.e. `a ? b : c`",$propdoc:{condition:"[AST_Node]",consequent:"[AST_Node]",alternative:"[AST_Node]"},_walk:function(e){return e._visit(this,function(){this.condition._walk(e),this.consequent._walk(e),this.alternative._walk(e)})}}),Ue=F("Assign",null,{$documentation:"An assignment expression — `a = b + 5`"},Le),qe=F("DefaultAssign",null,{$documentation:"A default assignment expression like in `(a = 3) => a`"},Le),Ie=F("Array","elements",{$documentation:"An array literal",$propdoc:{elements:"[AST_Node*] array of elements"},_walk:function(e){return e._visit(this,function(){for(var n=this.elements,t=0,r=n.length;t<r;t++)n[t]._walk(e)})}}),Ne=F("Object","properties",{$documentation:"An object literal",$propdoc:{properties:"[AST_ObjectProperty*] array of properties"},_walk:function(e){return e._visit(this,function(){for(var n=this.properties,t=0,r=n.length;t<r;t++)n[t]._walk(e)})}}),je=F("ObjectProperty","key value",{$documentation:"Base class for literal object properties",$propdoc:{key:"[string|AST_Node] property name. For ObjectKeyVal this is a string. For getters, setters and computed property this is an AST_Node.",value:"[AST_Node] property value.  For getters and setters this is an AST_Accessor."},_walk:function(e){return e._visit(this,function(){this.key instanceof k&&this.key._walk(e),this.value._walk(e)})}}),He=F("ObjectKeyVal","quote",{$documentation:"A key: value object property",$propdoc:{quote:"[string] the original quote character"}},je),Ye=F("ObjectSetter","quote static",{$propdoc:{quote:"[string|undefined] the original quote character, if any",static:"[boolean] whether this is a static setter (classes only)"},$documentation:"An object setter property"},je),Ve=F("ObjectGetter","quote static",{$propdoc:{quote:"[string|undefined] the original quote character, if any",static:"[boolean] whether this is a static getter (classes only)"},$documentation:"An object getter property"},je),Ge=F("ConciseMethod","quote static is_generator async",{$propdoc:{quote:"[string|undefined] the original quote character, if any",static:"[boolean] is this method static (classes only)",is_generator:"[boolean] is this a generator method",async:"[boolean] is this method async"},$documentation:"An ES6 concise method inside an object or class"},je),We=F("Class","name extends properties inlined",{$propdoc:{name:"[AST_SymbolClass|AST_SymbolDefClass?] optional class name.",extends:"[AST_Node]? optional parent class",properties:"[AST_ObjectProperty*] array of properties"},$documentation:"An ES6 class",_walk:function(e){return e._visit(this,function(){this.name&&this.name._walk(e),this.extends&&this.extends._walk(e),this.properties.forEach(function(n){n._walk(e)})})}},G),Je=F("DefClass",null,{$documentation:"A class definition"},We),Xe=F("ClassExpression",null,{$documentation:"A class expression."},We),Ze=F("Symbol","scope name thedef",{$propdoc:{name:"[string] name of this symbol",scope:"[AST_Scope/S] the current scope (not necessarily the definition scope)",thedef:"[SymbolDef/S] the definition of this symbol"},$documentation:"Base class for all symbols"}),Qe=F("NewTarget",null,{$documentation:"A reference to new.target"}),Ke=F("SymbolDeclaration","init",{$documentation:"A declaration symbol (symbol in var/const, function name or argument, symbol in catch)"},Ze),en=F("SymbolVar",null,{$documentation:"Symbol defining a variable"},Ke),nn=F("SymbolBlockDeclaration",null,{$documentation:"Base class for block-scoped declaration symbols"},Ke),tn=F("SymbolConst",null,{$documentation:"A constant declaration"},nn),rn=F("SymbolLet",null,{$documentation:"A block-scoped `let` declaration"},nn),on=F("SymbolFunarg",null,{$documentation:"Symbol naming a function argument"},en),an=F("SymbolDefun",null,{$documentation:"Symbol defining a function"},Ke),sn=F("SymbolMethod",null,{$documentation:"Symbol in an object defining a method"},Ze),un=F("SymbolLambda",null,{$documentation:"Symbol naming a function expression"},Ke),cn=F("SymbolDefClass",null,{$documentation:"Symbol naming a class's name in a class declaration. Lexically scoped to its containing scope, and accessible within the class."},nn),fn=F("SymbolClass",null,{$documentation:"Symbol naming a class's name. Lexically scoped to the class."},Ke),ln=F("SymbolCatch",null,{$documentation:"Symbol naming the exception in catch"},nn),pn=F("SymbolImport",null,{$documentation:"Symbol referring to an imported name"},nn),hn=F("SymbolImportForeign",null,{$documentation:"A symbol imported from a module, but it is defined in the other module, and its real name is irrelevant for this module's purposes"},Ze),dn=F("Label","references",{$documentation:"Symbol naming a label (declaration)",$propdoc:{references:"[AST_LoopControl*] a list of nodes referring to this label"},initialize:function(){this.references=[],this.thedef=this}},Ze),mn=F("SymbolRef",null,{$documentation:"Reference to some symbol (not definition/declaration)"},Ze),_n=F("SymbolExport",null,{$documentation:"Symbol referring to a name to export"},mn),gn=F("SymbolExportForeign",null,{$documentation:"A symbol exported from this module, but it is used in the other module, and its real name is irrelevant for this module's purposes"},Ze),vn=F("LabelRef",null,{$documentation:"Reference to a label symbol"},Ze),Dn=F("This",null,{$documentation:"The `this` symbol"},Ze),yn=F("Super",null,{$documentation:"The `super` symbol"},Dn),bn=F("Constant",null,{$documentation:"Base class for all constants",getValue:function(){return this.value}}),wn=F("String","value quote",{$documentation:"A string literal",$propdoc:{value:"[string] the contents of this string",quote:"[string] the original quote character"}},bn),En=F("Number","value literal",{$documentation:"A number literal",$propdoc:{value:"[number] the numeric value",literal:"[string] numeric value as string (optional)"}},bn),An=F("RegExp","value",{$documentation:"A regexp literal",$propdoc:{value:"[RegExp] the actual regexp"}},bn),Cn=F("Atom",null,{$documentation:"Base class for atoms"},bn),Fn=F("Null",null,{$documentation:"The `null` atom",value:null},Cn),xn=F("NaN",null,{$documentation:"The impossible value",value:NaN},Cn),kn=F("Undefined",null,{$documentation:"The `undefined` value",value:void 0},Cn),Bn=F("Hole",null,{$documentation:"A hole in an array",value:void 0},Cn),Sn=F("Infinity",null,{$documentation:"The `Infinity` value",value:1/0},Cn),Tn=F("Boolean",null,{$documentation:"Base class for booleans"},Cn),On=F("False",null,{$documentation:"The `false` atom",value:!1},Tn),Mn=F("True",null,{$documentation:"The `true` atom",value:!0},Tn),Rn=F("Await","expression",{$documentation:"An `await` statement",$propdoc:{expression:"[AST_Node] the mandatory expression being awaited"},_walk:function(e){return e._visit(this,function(){this.expression._walk(e)})}}),$n=F("Yield","expression is_star",{$documentation:"A `yield` statement",$propdoc:{expression:"[AST_Node?] the value returned or thrown by this statement; could be null (representing undefined) but only when is_star is set to false",is_star:"[Boolean] Whether this is a yield or yield* statement"},_walk:function(e){return e._visit(this,this.expression&&function(){this.expression._walk(e)})}});function Pn(e){this.visit=e,this.stack=[],this.directives=Object.create(null)}Pn.prototype={_visit:function(e,n){this.push(e);var t=this.visit(e,n?function(){n.call(e)}:l);return!t&&n&&n.call(e),this.pop(),t},parent:function(e){return this.stack[this.stack.length-2-(e||0)]},push:function(e){e instanceof X?this.directives=Object.create(this.directives):e instanceof T&&!this.directives[e.value]?this.directives[e.value]=e:e instanceof We&&(this.directives=Object.create(this.directives),this.directives["use strict"]||(this.directives["use strict"]=e)),this.stack.push(e)},pop:function(){var e=this.stack.pop();(e instanceof X||e instanceof We)&&(this.directives=Object.getPrototypeOf(this.directives))},self:function(){return this.stack[this.stack.length-1]},find_parent:function(e){for(var n=this.stack,t=n.length;--t>=0;){var r=n[t];if(r instanceof e)return r}},has_directive:function(e){var n=this.directives[e];if(n)return n;var t=this.stack[this.stack.length-1];if(t instanceof G&&t.body)for(var r=0;r<t.body.length;++r){var i=t.body[r];if(!(i instanceof T))break;if(i.value==e)return i}},loopcontrol_target:function(e){var n=this.stack;if(e.label)for(var t=n.length;--t>=0;){if((r=n[t])instanceof z&&r.label.name==e.label.name)return r.body}else for(t=n.length;--t>=0;){var r;if((r=n[t])instanceof U||e instanceof fe&&r instanceof he)return r}}};var Ln="break case catch class const continue debugger default delete do else export extends finally for function if in instanceof let new return switch throw try typeof var void while with",zn="false null true",Un="enum implements import interface package private protected public static super this "+zn+" "+Ln,qn="return new delete throw else case yield await";Ln=b(Ln),Un=b(Un),qn=b(qn),zn=b(zn);var In=b(i("+-*&%=<>!?|~^")),Nn=/[0-9a-f]/i,jn=/^0x[0-9a-f]+$/i,Hn=/^0[0-7]+$/,Yn=/^0o[0-7]+$/i,Vn=/^0b[01]+$/i,Gn=/^\d*\.?\d*(?:e[+-]?\d*(?:\d\.?|\.?\d)\d*)?$/i,Wn=b(["in","instanceof","typeof","new","void","delete","++","--","+","-","!","~","&","|","^","*","**","/","%",">>","<<",">>>","<",">","<=",">=","==","===","!=","!==","?","=","+=","-=","/=","*=","**=","%=",">>=","<<=",">>>=","|=","^=","&=","&&","||"]),Jn=b(i("  \n\r\t\f\v​           \u2028\u2029  　\ufeff")),Xn=b(i("\n\r\u2028\u2029")),Zn=b(i(";]),:")),Qn=b(i("[{(,;:")),Kn=b(i("[]{}(),;:")),et={ID_Start:/[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,ID_Continue:/[0-9A-Z_a-z\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFC-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C4\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/};function nt(e,n){var t=e.charAt(n);if(tt(t)){var r=e.charAt(n+1);if(rt(r))return t+r}if(rt(t)){var i=e.charAt(n-1);if(tt(i))return i+t}return t}function tt(e){return"string"==typeof e&&(e=e.charCodeAt(0)),e>=55296&&e<=56319}function rt(e){return"string"==typeof e&&(e=e.charCodeAt(0)),e>=56320&&e<=57343}function it(e){return e>=48&&e<=57}function ot(e){return"string"==typeof e&&!Un(e)}function at(e){var n=e.charCodeAt(0);return et.ID_Start.test(e)||36==n||95==n}function st(e){var n=e.charCodeAt(0);return et.ID_Continue.test(e)||36==n||95==n||8204==n||8205==n}function ut(e){return/^[a-z_$][a-z0-9_$]*$/i.test(e)}function ct(e,n,t,r,i){this.message=e,this.filename=n,this.line=t,this.col=r,this.pos=i}function ft(e,n,t,r,i){throw new ct(e,n,t,r,i)}function lt(e,n,t){return e.type==n&&(null==t||e.value==t)}ct.prototype=Object.create(Error.prototype),ct.prototype.constructor=ct,ct.prototype.name="SyntaxError",s(ct);var pt={};function ht(e,n,t,r){var i={text:e,filename:n,pos:0,tokpos:0,line:1,tokline:0,col:0,tokcol:0,newline_before:!1,regex_allowed:!1,brace_counter:0,template_braces:[],comments_before:[],directives:{},directive_stack:[]};function o(){return nt(i.text,i.pos)}function a(e,n){var t=nt(i.text,i.pos++);if(e&&!t)throw pt;return Xn(t)?(i.newline_before=i.newline_before||!n,++i.line,i.col=0,n||"\r"!=t||"\n"!=o()||(++i.pos,t="\n")):(t.length>1&&(++i.pos,++i.col),++i.col),t}function s(e){for(;e-- >0;)a()}function u(e){return i.text.substr(i.pos,e.length)==e}function c(e,n){var t=i.text.indexOf(e,i.pos);if(n&&-1==t)throw pt;return t}function f(){i.tokline=i.line,i.tokcol=i.col,i.tokpos=i.pos}var l=!1;function p(t,r,o){i.regex_allowed="operator"==t&&!mt(r)||"keyword"==t&&qn(r)||"punc"==t&&Qn(r)||"arrow"==t,"punc"==t&&"."==r?l=!0:o||(l=!1);var a={type:t,value:r,line:i.tokline,col:i.tokcol,pos:i.tokpos,endline:i.line,endcol:i.col,endpos:i.pos,nlb:i.newline_before,file:n};return/^(?:num|string|regexp)$/i.test(t)&&(a.raw=e.substring(a.pos,a.endpos)),o||(a.comments_before=i.comments_before,a.comments_after=i.comments_before=[]),i.newline_before=!1,new x(a)}function h(){for(;Jn(o());)a()}function d(e){ft(e,n,i.tokline,i.tokcol,i.tokpos)}function m(e){var n=!1,t=!1,r=!1,i="."==e,s=function(e){for(var n,t="",r=0;(n=o())&&e(n,r++);)t+=a();return t}(function(o,a){switch(o.charCodeAt(0)){case 98:case 66:return r=!0;case 111:case 79:case 120:case 88:return!r&&(r=!0);case 101:case 69:return!!r||!n&&(n=t=!0);case 45:return t||0==a&&!e;case 43:return t;case t=!1,46:return!(i||r||n)&&(i=!0)}return Nn.test(o)});e&&(s=e+s),Hn.test(s)&&B.has_directive("use strict")&&d("Legacy octal literals are not allowed in strict mode");var u=function(e){if(jn.test(e))return parseInt(e.substr(2),16);if(Hn.test(e))return parseInt(e.substr(1),8);if(Yn.test(e))return parseInt(e.substr(2),8);if(Vn.test(e))return parseInt(e.substr(2),2);if(Gn.test(e))return parseFloat(e);var n=parseFloat(e);return n==e?n:void 0}(s);if(!isNaN(u))return p("num",u);d("Invalid syntax: "+s)}function _(e){var n=a(!0,e);switch(n.charCodeAt(0)){case 110:return"\n";case 114:return"\r";case 116:return"\t";case 98:return"\b";case 118:return"\v";case 102:return"\f";case 120:return String.fromCharCode(g(2));case 117:if("{"==o()){for(a(!0),"}"===o()&&d("Expecting hex-character between {}");"0"==o();)a(!0);var t,r=c("}",!0)-i.pos;return(r>6||(t=g(r))>1114111)&&d("Unicode reference out of bounce"),a(!0),function(e){return e>65535?(e-=65536,String.fromCharCode(55296+(e>>10))+String.fromCharCode(e%1024+56320)):String.fromCharCode(e)}(t)}return String.fromCharCode(g(4));case 10:return"";case 13:if("\n"==o())return a(!0,e),""}return n>="0"&&n<="7"?function(e){var n=o();n>="0"&&n<="7"&&(e+=a(!0))[0]<="3"&&(n=o())>="0"&&n<="7"&&(e+=a(!0));if("0"===e)return"\0";e.length>0&&B.has_directive("use strict")&&d("Legacy octal escape sequences are not allowed in strict mode");return String.fromCharCode(parseInt(e,8))}(n):n}function g(e){for(var n=0;e>0;--e){var t=parseInt(a(!0),16);isNaN(t)&&d("Invalid hex-character pattern in string"),n=n<<4|t}return n}var v=k("Unterminated string constant",function(e){for(var n=a(),t="";;){var r=a(!0,!0);if("\\"==r)r=_(!0);else if(Xn(r))d("Unterminated string constant");else if(r==n)break;t+=r}var i=p("string",t);return i.quote=e,i}),D=k("Unterminated template",function(e){e&&i.template_braces.push(i.brace_counter);var n,t,r="",s="";for(a(!0,!0);"`"!=(n=a(!0,!0));){if("\r"==n)"\n"==o()&&++i.pos,n="\n";else if("$"==n&&"{"==o())return a(!0,!0),i.brace_counter++,(t=p(e?"template_head":"template_substitution",r)).begin=e,t.raw=s,t.end=!1,t;if(s+=n,"\\"==n){var u=i.pos;n=_(),s+=i.text.substr(u,i.pos-u)}r+=n}return i.template_braces.pop(),(t=p(e?"template_head":"template_substitution",r)).begin=e,t.raw=s,t.end=!0,t});function y(e){var n,t=i.regex_allowed,r=function(){for(var e=i.text,n=i.pos,t=i.text.length;n<t;++n){var r=e[n];if(Xn(r))return n}return-1}();return-1==r?(n=i.text.substr(i.pos),i.pos=i.text.length):(n=i.text.substring(i.pos,r),i.pos=r),i.col=i.tokcol+(i.pos-i.tokpos),i.comments_before.push(p(e,n,!0)),i.regex_allowed=t,B}var b=k("Unterminated multiline comment",function(){var e=i.regex_allowed,n=c("*/",!0),t=i.text.substring(i.pos,n).replace(/\r\n|\r|\u2028|\u2029/g,"\n");return s(function(e){for(var n=0,t=0;t<e.length;t++)tt(e.charCodeAt(t))&&rt(e.charCodeAt(t+1))&&(n++,t++);return e.length-n}(t)+2),i.comments_before.push(p("comment2",t,!0)),i.newline_before=i.newline_before||t.indexOf("\n")>=0,i.regex_allowed=e,B}),w=k("Unterminated identifier name",function(){var e,n="",t=!1,r=function(){return t=!0,a(),"u"!==o()&&d("Expecting UnicodeEscapeSequence -- uXXXX or u{XXXX}"),_()};if("\\"===(n=o()))at(n=r())||d("First identifier char is an invalid identifier char");else{if(!at(n))return"";a()}for(;null!=(e=o());){if("\\"===(e=o()))st(e=r())||d("Invalid escaped identifier char");else{if(!st(e))break;a()}n+=e}return Un(n)&&t&&d("Escaped characters are not allowed in keywords"),n}),E=k("Unterminated regular expression",function(e){for(var n,t=!1,r=!1;n=a(!0);)if(Xn(n))d("Unexpected line terminator");else if(t)e+="\\"+n,t=!1;else if("["==n)r=!0,e+=n;else if("]"==n&&r)r=!1,e+=n;else{if("/"==n&&!r)break;"\\"==n?t=!0:e+=n}var i=w();try{var o=new RegExp(e,i);return o.raw_source=e,p("regexp",o)}catch(e){d(e.message)}});function A(e){return p("operator",function e(n){if(!o())return n;var t=n+o();return Wn(t)?(a(),e(t)):n}(e||a()))}function C(){switch(a(),o()){case"/":return a(),y("comment1");case"*":return a(),b()}return i.regex_allowed?E(""):A("/")}function F(){var e=w();return l?p("name",e):zn(e)?p("atom",e):Ln(e)?Wn(e)?p("operator",e):p("keyword",e):p("name",e)}function k(e,n){return function(t){try{return n(t)}catch(n){if(n!==pt)throw n;d(e)}}}function B(e){if(null!=e)return E(e);for(r&&0==i.pos&&u("#!")&&(f(),s(2),y("comment5"));;){if(h(),f(),t){if(u("\x3c!--")){s(4),y("comment3");continue}if(u("--\x3e")&&i.newline_before){s(3),y("comment4");continue}}var n=o();if(!n)return p("eof");var c=n.charCodeAt(0);switch(c){case 34:case 39:return v(n);case 46:return a(),it(o().charCodeAt(0))?m("."):"."===o()?(a(),a(),p("expand","...")):p("punc",".");case 47:var l=C();if(l===B)continue;return l;case 61:return a(),">"===o()?(a(),p("arrow","=>")):A("=");case 96:return D(!0);case 123:i.brace_counter++;break;case 125:if(i.brace_counter--,i.template_braces.length>0&&i.template_braces[i.template_braces.length-1]===i.brace_counter)return D(!1)}if(it(c))return m();if(Kn(n))return p("punc",a());if(In(n))return A();if(92==c||at(n))return F();break}d("Unexpected character '"+n+"'")}return B.next=a,B.peek=o,B.context=function(e){return e&&(i=e),i},B.add_directive=function(e){i.directive_stack[i.directive_stack.length-1].push(e),void 0===i.directives[e]?i.directives[e]=1:i.directives[e]++},B.push_directives_stack=function(){i.directive_stack.push([])},B.pop_directives_stack=function(){for(var e=i.directive_stack[i.directive_stack.length-1],n=0;n<e.length;n++)i.directives[e[n]]--;i.directive_stack.pop()},B.has_directive=function(e){return i.directives[e]>0},B}var dt=b(["typeof","void","delete","--","++","!","~","-","+"]),mt=b(["--","++"]),_t=b(["=","+=","-=","/=","*=","**=","%=",">>=","<<=",">>>=","|=","^=","&="]),gt=function(e,n){for(var t=0;t<e.length;++t)for(var r=e[t],i=0;i<r.length;++i)n[r[i]]=t+1;return n}([["||"],["&&"],["|"],["^"],["&"],["==","===","!=","!=="],["<",">","<=",">=","in","instanceof"],[">>","<<",">>>"],["+","-"],["*","/","%"],["**"]],{}),vt=b(["atom","num","string","regexp","name"]);function Dt(e,n){n=c(n,{bare_returns:!1,ecma:8,expression:!1,filename:null,html5_comments:!0,shebang:!0,strict:!1,toplevel:null},!0);var t={input:"string"==typeof e?ht(e,n.filename,n.html5_comments,n.shebang):e,token:null,prev:null,peeked:null,in_function:0,in_async:-1,in_generator:-1,in_directives:!0,in_loop:0,labels:[]};function r(e,n){return lt(t.token,e,n)}function i(){return t.peeked||(t.peeked=t.input())}function o(){return t.prev=t.token,t.peeked?(t.token=t.peeked,t.peeked=null):t.token=t.input(),t.in_directives=t.in_directives&&("string"==t.token.type||r("punc",";")),t.token}function s(){return t.prev}function u(e,n,r,i){var o=t.input.context();ft(e,o.filename,null!=n?n:o.tokline,null!=r?r:o.tokcol,null!=i?i:o.tokpos)}function f(e,n){u(n,e.line,e.col)}function l(e){null==e&&(e=t.token),f(e,"Unexpected token: "+e.type+" ("+e.value+")")}function p(e,n){if(r(e,n))return o();f(t.token,"Unexpected token "+t.token.type+" «"+t.token.value+"», expected "+e+" «"+n+"»")}function h(e){return p("punc",e)}function d(e){return e.nlb||!w(e.comments_before,function(e){return!e.nlb})}function m(){return!n.strict&&(r("eof")||r("punc","}")||d(t.token))}function _(){return t.in_generator===t.in_function}function g(){return t.in_async===t.in_function}function v(e){r("punc",";")?o():e||m()||l()}function D(){h("(");var e=nt(!0);return h(")"),e}function y(e){return function(){var n=t.token,r=e.apply(null,arguments),i=s();return r.start=n,r.end=i,r}}function b(){(r("operator","/")||r("operator","/="))&&(t.peeked=null,t.token=t.input(t.token.value.substr(1)))}t.token=o();var E=y(function(e){switch(b(),t.token.type){case"string":if(t.in_directives){var c=i();-1==t.token.raw.indexOf("\\")&&(lt(c,"punc",";")||lt(c,"punc","}")||d(c)||lt(c,"eof"))?t.input.add_directive(t.token.value):t.in_directives=!1}var _=t.in_directives,y=C();return _?new T(y.body):y;case"template_head":case"num":case"regexp":case"operator":case"atom":return C();case"name":if("async"==t.token.value&&lt(i(),"keyword","function"))return o(),o(),B(ee,!1,!0,e);if("import"==t.token.value&&!lt(i(),"punc","(")){o();var w=function(){var e,n,i=s();r("name")&&(e=jn(pn));r("punc",",")&&o();((n=zn(!0))||e)&&p("name","from");var a=t.token;"string"!==a.type&&l();return o(),new Ce({start:i,imported_name:e,imported_names:n,module_name:new wn({start:a,value:a.value,quote:a.quote,end:a}),end:t.token})}();return v(),w}return lt(i(),"punc",":")?function(){var e=jn(dn);"await"===e.name&&g()&&f(t.prev,"await cannot be used as label inside async function");a(function(n){return n.name==e.name},t.labels)&&u("Label "+e.name+" defined twice");h(":"),t.labels.push(e);var n=E();t.labels.pop(),n instanceof U||e.references.forEach(function(n){n instanceof le&&(n=n.label.start,u("Continue label `"+e.name+"` refers to non-IterationStatement.",n.line,n.col,n.pos))});return new z({body:n,label:e})}():C();case"punc":switch(t.token.value){case"{":return new $({start:t.token,body:G(),end:s()});case"[":case"(":return C();case";":return t.in_directives=!1,o(),new P;default:l()}case"keyword":switch(t.token.value){case"break":return o(),F(fe);case"continue":return o(),F(le);case"debugger":return o(),v(),new S;case"do":o();var A=tt(E);p("keyword","while");var x=D();return v(!0),new I({body:A,condition:x});case"while":return o(),new N({condition:D(),body:tt(E)});case"for":return o(),function(){h("(");var e=null;if(!r("punc",";")){e=r("keyword","var")?(o(),ce(!0)):r("keyword","let")?(o(),de(!0)):r("keyword","const")?(o(),Re(!0)):nt(!0,!0);var n=r("operator","in"),t=r("name","of");if(n||t)return e instanceof ye?e.definitions.length>1&&u("Only one variable declaration allowed in for..in loop",e.start.line,e.start.col,e.start.pos):Qn(e)||(e=Kn(e))instanceof ne||u("Invalid left-hand side in for..in loop",e.start.line,e.start.col,e.start.pos),o(),n?function(e){var n=nt(!0);return h(")"),new H({init:e,object:n,body:tt(E)})}(e):function(e){var n=e instanceof ye?e.definitions[0].name:null,t=nt(!0);return h(")"),new Y({init:e,name:n,object:t,body:tt(E)})}(e)}return function(e){h(";");var n=r("punc",";")?null:nt(!0);h(";");var t=r("punc",")")?null:nt(!0);return h(")"),new j({init:e,condition:n,step:t,body:tt(E)})}(e)}();case"class":return o(),Tn(Je);case"function":return o(),B(ee,!1,!1,e);case"if":return o(),function(){var e=D(),n=E(),t=null;r("keyword","else")&&(o(),t=E());return new pe({condition:e,body:n,alternative:t})}();case"return":0!=t.in_function||n.bare_returns||u("'return' outside of function"),o();var k=null;return r("punc",";")?o():m()||(k=nt(!0),v()),new se({value:k});case"switch":return o(),new he({expression:D(),body:tt(oe)});case"throw":o(),d(t.token)&&u("Illegal newline after 'throw'");k=nt(!0);return v(),new ue({value:k});case"try":return o(),function(){var e=G(),n=null,i=null;if(r("keyword","catch")){var a=t.token;o(),h("(");var c=R(void 0,ln);h(")"),n=new ve({start:a,argname:c,body:G(),end:s()})}if(r("keyword","finally")){var a=t.token;o(),i=new De({start:a,body:G(),end:s()})}n||i||u("Missing catch/finally blocks");return new ge({body:e,bcatch:n,bfinally:i})}();case"var":o();w=ce();return v(),w;case"let":o();w=de();return v(),w;case"const":o();w=Re();return v(),w;case"with":return t.input.has_directive("use strict")&&u("Strict mode may not include a with statement"),o(),new V({expression:D(),body:E()});case"export":if(!lt(i(),"punc","("))return o(),function(){var e,n,a,u,c,f=t.token;if(r("keyword","default"))e=!0,o();else if(n=zn(!1)){if(r("name","from")){o();var p=t.token;return"string"!==p.type&&l(),o(),new Fe({start:f,is_default:e,exported_names:n,module_name:new wn({start:p,value:p.value,quote:p.quote,end:p}),end:s()})}return new Fe({start:f,is_default:e,exported_names:n,end:s()})}r("punc","{")||e&&(r("keyword","class")||r("keyword","function"))&&lt(i(),"punc")?(u=nt(!1),v()):(a=E(e))instanceof ye&&e?l(a.start):a instanceof ye||a instanceof X||a instanceof Je?c=a:a instanceof O?u=a.body:l(a.start);return new Fe({start:f,is_default:e,exported_value:u,exported_definition:c,end:s()})}()}}l()});function C(e){return new O({body:(e=nt(!0),v(),e)})}function F(e){var n,r=null;m()||(r=jn(vn,!0)),null!=r?((n=a(function(e){return e.name==r.name},t.labels))||u("Undefined label "+r.name),r.thedef=n):0==t.in_loop&&u(e.TYPE+" not inside a loop or switch"),v();var i=new e({label:r});return n&&n.references.push(i),i}var x=function(e,n,i){d(t.token)&&u("Unexpected newline before arrow (=>)"),p("arrow","=>");var o=q(r("punc","{"),!1,i);return new K({start:e,end:o.end,async:i,argnames:n,body:o})},B=function(e,n,i,a){n&&i&&u("generators cannot be async");t.token;var c=e===ee,f=r("operator","*");f&&o();var p=r("name")?jn(c?an:un):null;c&&!p&&(a?e=Q:l()),!p||e===Z||p instanceof Ke||l(s());var h=[],d=q(!0,f||n,i,p,h);return new e({start:h.start,end:d.end,is_generator:f,async:i,name:p,argnames:h,body:d})};function M(e,n){var t={},r=!1,i=!1,o=!1,a=!!n,s={add_parameter:function(n){if(void 0!==t["$"+n.value])!1===r&&(r=n),s.check_strict();else if(t["$"+n.value]=!0,e)switch(n.value){case"arguments":case"eval":case"yield":a&&f(n,"Unexpected "+n.value+" identifier as parameter inside strict mode");break;default:Un(n.value)&&l()}},mark_default_assignment:function(e){!1===i&&(i=e)},mark_spread:function(e){!1===o&&(o=e)},mark_strict_mode:function(){a=!0},is_strict:function(){return!1!==i||!1!==o||a},check_strict:function(){s.is_strict()&&!1!==r&&f(r,"Parameter "+r.value+" was used already")}};return s}function R(e,n){var i,a=!1;return void 0===e&&(e=M(!0,t.input.has_directive("use strict"))),r("expand","...")&&(a=t.token,e.mark_spread(t.token),o()),i=L(e,n),r("operator","=")&&!1===a&&(e.mark_default_assignment(t.token),o(),i=new qe({start:i.start,left:i,operator:"=",right:nt(!1),end:t.token})),!1!==a&&(r("punc",")")||l(),i=new J({start:a,expression:i,end:a})),e.check_strict(),i}function L(e,n){var a,c=[],f=!0,p=!1,d=t.token;if(void 0===e&&(e=M(!1,t.input.has_directive("use strict"))),n=void 0===n?on:n,r("punc","[")){for(o();!r("punc","]");){if(f?f=!1:h(","),r("expand","...")&&(p=!0,a=t.token,e.mark_spread(t.token),o()),r("punc"))switch(t.token.value){case",":c.push(new Bn({start:t.token,end:t.token}));continue;case"]":break;case"[":case"{":c.push(L(e,n));break;default:l()}else r("name")?(e.add_parameter(t.token),c.push(jn(n))):u("Invalid function parameter");r("operator","=")&&!1===p&&(e.mark_default_assignment(t.token),o(),c[c.length-1]=new qe({start:c[c.length-1].start,left:c[c.length-1],operator:"=",right:nt(!1),end:t.token})),p&&(r("punc","]")||u("Rest element must be last element"),c[c.length-1]=new J({start:a,expression:c[c.length-1],end:a}))}return h("]"),e.check_strict(),new ne({start:d,names:c,is_array:!0,end:s()})}if(r("punc","{")){for(o();!r("punc","}");){if(f?f=!1:h(","),r("expand","...")&&(p=!0,a=t.token,e.mark_spread(t.token),o()),r("name")&&(lt(i(),"punc")||lt(i(),"operator"))&&-1!==[",","}","="].indexOf(i().value)){e.add_parameter(t.token);var m=s(),_=jn(n);p?c.push(new J({start:a,expression:_,end:_.end})):c.push(new He({start:m,key:_.name,value:_,end:_.end}))}else{if(r("punc","}"))continue;var g=t.token,v=qn();null===v?l(s()):"name"!==s().type||r("punc",":")?(h(":"),c.push(new He({start:g,quote:g.quote,key:v,value:L(e,n),end:s()}))):c.push(new He({start:s(),key:v,value:new n({start:s(),name:v,end:s()}),end:s()}))}p?r("punc","}")||u("Rest element must be last element"):r("operator","=")&&(e.mark_default_assignment(t.token),o(),c[c.length-1].value=new qe({start:c[c.length-1].value.start,left:c[c.length-1].value,operator:"=",right:nt(!1),end:t.token}))}return h("}"),e.check_strict(),new ne({start:d,names:c,is_array:!1,end:s()})}if(r("name"))return e.add_parameter(t.token),jn(n);u("Invalid function parameter")}function q(e,i,a,s,u){var c=t.in_loop,f=t.labels,p=t.in_generator,d=t.in_async;if(++t.in_function,i&&(t.in_generator=t.in_function),a&&(t.in_async=t.in_function),u&&function(e){t.token;var i=M(!0,t.input.has_directive("use strict"));for(h("(");!r("punc",")");){var a=R(i);if(e.push(a),r("punc",")")||(h(","),r("punc",")")&&n.ecma<8&&l()),a instanceof J)break}o()}(u),e&&(t.in_directives=!0),t.in_loop=0,t.labels=[],e){t.input.push_directives_stack();var m=G();s&&Nn(s),u&&u.forEach(Nn),t.input.pop_directives_stack()}else m=nt(!1);return--t.in_function,t.in_loop=c,t.labels=f,t.in_generator=p,t.in_async=d,m}function G(){h("{");for(var e=[];!r("punc","}");)r("eof")&&l(),e.push(E());return o(),e}function oe(){h("{");for(var e,n=[],i=null,a=null;!r("punc","}");)r("eof")&&l(),r("keyword","case")?(a&&(a.end=s()),i=[],a=new _e({start:(e=t.token,o(),e),expression:nt(!0),body:i}),n.push(a),h(":")):r("keyword","default")?(a&&(a.end=s()),i=[],a=new me({start:(e=t.token,o(),h(":"),e),body:i}),n.push(a)):(i||l(),i.push(E()));return a&&(a.end=s()),o(),n}function ae(e,n){for(var i,a=[];;){var c="var"===n?en:"const"===n?tn:"let"===n?rn:null;if(r("punc","{")||r("punc","[")?i=new xe({start:t.token,name:L(void 0,c),value:r("operator","=")?(p("operator","="),nt(!1,e)):null,end:s()}):"import"==(i=new xe({start:t.token,name:jn(c),value:r("operator","=")?(o(),nt(!1,e)):e||"const"!==n?null:u("Missing initializer in const declaration"),end:s()})).name.name&&u("Unexpected token: import"),a.push(i),!r("punc",","))break;o()}return a}var ce=function(e){return new be({start:s(),definitions:ae(e,"var"),end:s()})},de=function(e){return new we({start:s(),definitions:ae(e,"let"),end:s()})},Re=function(e){return new Ee({start:s(),definitions:ae(e,"const"),end:s()})};function We(){var e,n=t.token;switch(n.type){case"name":e=In(mn);break;case"num":e=new En({start:n,end:n,value:n.value});break;case"string":e=new wn({start:n,end:n,value:n.value,quote:n.quote});break;case"regexp":e=new An({start:n,end:n,value:n.value});break;case"atom":switch(n.value){case"false":e=new On({start:n,end:n});break;case"true":e=new Mn({start:n,end:n});break;case"null":e=new Fn({start:n,end:n})}}return o(),e}function Ze(e,n,t,r){var i=function(e,n){return n?new qe({start:e.start,left:e,operator:"=",right:n,end:n.end}):e};return e instanceof Ne?i(new ne({start:e.start,end:e.end,is_array:!1,names:e.properties.map(Ze)}),r):e instanceof He?(e.value=Ze(e.value,0,[e.key]),i(e,r)):e instanceof Bn?e:e instanceof ne?(e.names=e.names.map(Ze),i(e,r)):e instanceof mn?i(new on({name:e.name,start:e.start,end:e.end}),r):e instanceof J?(e.expression=Ze(e.expression),i(e,r)):e instanceof Ie?i(new ne({start:e.start,end:e.end,is_array:!0,names:e.elements.map(Ze)}),r):e instanceof Ue?i(Ze(e.left,void 0,void 0,e.right),r):e instanceof qe?(e.left=Ze(e.left,0,[e.left]),e):void u("Invalid function parameter",e.start.line,e.start.col)}var nn=function(e,a){if(r("operator","new"))return function(e){var i=t.token;if(p("operator","new"),r("punc","."))return o(),p("name","target"),Yn(new Qe({start:i,end:s()}),e);var a,u=nn(!1);r("punc","(")?(o(),a=Cn(")",n.ecma>=8)):a=[];var c=new Be({start:i,expression:u,args:a,end:s()});return Hn(c),Yn(c,e)}(e);var u=t.token,c=r("name","async")&&We();if(r("punc")){switch(t.token.value){case"(":if(c&&!e)break;var f=function(e,i){var a,u,c,f=[];for(h("(");!r("punc",")");)a&&l(a),r("expand","...")?(a=t.token,i&&(u=t.token),o(),f.push(new J({start:s(),expression:nt(),end:t.token}))):f.push(nt()),r("punc",")")||(h(","),r("punc",")")&&(n.ecma<8&&l(),c=s(),i&&(u=c)));return h(")"),e&&r("arrow","=>")?a&&c&&l(c):u&&l(u),f}(a,!c);if(a&&r("arrow","=>"))return x(u,f.map(Ze),!!c);var d=c?new ke({expression:c,args:f}):1==f.length?f[0]:new Se({expressions:f});if(d.start){var m=u.comments_before.length;if([].unshift.apply(d.start.comments_before,u.comments_before),u.comments_before=d.start.comments_before,u.comments_before_length=m,0==m&&u.comments_before.length>0){var _=u.comments_before[0];_.nlb||(_.nlb=u.nlb,u.nlb=!1)}u.comments_after=d.start.comments_after}d.start=u;var g=s();return d.end&&(g.comments_before=d.end.comments_before,[].push.apply(d.end.comments_after,g.comments_after),g.comments_after=d.end.comments_after),d.end=g,d instanceof ke&&Hn(d),Yn(d,e);case"[":return Yn(xn(),e);case"{":return Yn(Sn(),e)}c||l()}if(a&&r("name")&&lt(i(),"arrow")){var v=new on({name:t.token.value,start:u,end:u});return o(),x(u,[v],!!c)}if(r("keyword","function")){o();var D=B(Q,!1,!!c);return D.start=u,D.end=s(),Yn(D,e)}if(c)return Yn(c,e);if(r("keyword","class")){o();var y=Tn(Xe);return y.start=u,y.end=s(),Yn(y,e)}return r("template_head")?Yn(bn(),e):vt(t.token.type)?Yn(We(),e):void l()};function bn(){var e=[],n=t.token;for(e.push(new ie({start:t.token,raw:t.token.raw,value:t.token.value,end:t.token}));!1===t.token.end;)o(),b(),e.push(nt(!0)),lt("template_substitution")||l(),e.push(new ie({start:t.token,raw:t.token.raw,value:t.token.value,end:t.token}));return o(),new re({start:n,segments:e,end:t.token})}function Cn(e,n,i){for(var a=!0,u=[];!r("punc",e)&&(a?a=!1:h(","),!n||!r("punc",e));)r("punc",",")&&i?u.push(new Bn({start:t.token,end:t.token})):r("expand","...")?(o(),u.push(new J({start:s(),expression:nt(),end:t.token}))):u.push(nt(!1));return o(),u}var xn=y(function(){return h("["),new Ie({elements:Cn("]",!n.strict,!0)})}),kn=y(function(e,n){return B(Z,e,n)}),Sn=y(function(){var e=t.token,i=!0,a=[];for(h("{");!r("punc","}")&&(i?i=!1:h(","),n.strict||!r("punc","}"));)if("expand"!=(e=t.token).type){var u,c=qn();if(r("punc",":"))null===c?l(s()):(o(),u=nt(!1));else{var f=Pn(c,e);if(f){a.push(f);continue}u=new mn({start:s(),name:c,end:s()})}r("operator","=")&&(o(),u=new Ue({start:e,left:u,operator:"=",right:nt(!1),end:s()})),a.push(new He({start:e,quote:e.quote,key:c instanceof k?c:""+c,value:u,end:s()}))}else o(),a.push(new J({start:e,expression:nt(!1),end:s()}));return o(),new Ne({properties:a})});function Tn(e){var n,i,a,u,c=[];for(t.input.push_directives_stack(),t.input.add_directive("use strict"),"name"==t.token.type&&"extends"!=t.token.value&&(a=jn(e===Je?cn:fn)),e!==Je||a||l(),"extends"==t.token.value&&(o(),u=nt(!0)),h("{"),r("punc",";")&&o();!r("punc","}");)n=t.token,(i=Pn(qn(),n,!0))||l(),c.push(i),r("punc",";")&&o();return t.input.pop_directives_stack(),o(),new e({start:n,name:a,extends:u,properties:c,end:s()})}function Pn(e,n,i){var o=function(e,n){return"string"==typeof e||"number"==typeof e?new sn({start:n,name:""+e,end:s()}):(null===e&&l(),e)},a=!1,u=!1,c=!1,f=n;if(i&&"static"===e&&!r("punc","(")&&(u=!0,f=t.token,e=qn()),"async"!==e||r("punc","(")||r("punc",",")||r("punc","}")||(a=!0,f=t.token,e=qn()),null===e&&(c=!0,f=t.token,null===(e=qn())&&l()),r("punc","("))return e=o(e,n),new Ge({start:n,static:u,is_generator:c,async:a,key:e,quote:e instanceof sn?f.quote:void 0,value:kn(c,a),end:s()});if(f=t.token,"get"==e){if(!r("punc")||r("punc","["))return e=o(qn(),n),new Ve({start:n,static:u,key:e,quote:e instanceof sn?f.quote:void 0,value:kn(),end:s()})}else if("set"==e&&(!r("punc")||r("punc","[")))return e=o(qn(),n),new Ye({start:n,static:u,key:e,quote:e instanceof sn?f.quote:void 0,value:kn(),end:s()})}function Ln(e){function n(e){return new e({name:qn(),start:s(),end:s()})}var i,a,u=e?hn:gn,c=e?pn:_n,f=t.token;return e?i=n(u):a=n(c),r("name","as")?(o(),e?a=n(c):i=n(u)):e?a=new c(i):i=new u(a),new Ae({start:f,foreign_name:i,name:a,end:s()})}function zn(e){var n;if(r("punc","{")){for(o(),n=[];!r("punc","}");)n.push(Ln(e)),r("punc",",")&&o();o()}else if(r("operator","*")){var i;o(),e&&r("name","as")&&(o(),i=jn(hn)),n=[function(e,n){var r,i=e?hn:gn,o=e?pn:_n,a=t.token,u=s();return n=n||new o({name:"*",start:a,end:u}),r=new i({name:"*",start:a,end:u}),new Ae({start:a,foreign_name:r,name:n,end:u})}(e,i)]}return n}function qn(){var e=t.token;switch(e.type){case"punc":if("["===e.value){o();var n=nt(!1);return h("]"),n}l(e);case"operator":if("*"===e.value)return o(),null;-1===["delete","in","instanceof","new","typeof","void"].indexOf(e.value)&&l(e);case"name":"yield"==e.value&&(_()?f(e,"Yield cannot be used as identifier inside generators"):lt(i(),"punc",":")||lt(i(),"punc","(")||!t.input.has_directive("use strict")||f(e,"Unexpected yield identifier inside strict mode"));case"string":case"num":case"keyword":case"atom":return o(),e.value;default:l(e)}}function In(e){var n=t.token.value;return new("this"==n?Dn:"super"==n?yn:e)({name:String(n),start:t.token,end:t.token})}function Nn(e){var n=e.name;_()&&"yield"==n&&f(e.start,"Yield cannot be used as identifier inside generators"),t.input.has_directive("use strict")&&("yield"==n&&f(e.start,"Unexpected yield identifier inside strict mode"),e instanceof Ke&&("arguments"==n||"eval"==n)&&f(e.start,"Unexpected "+n+" in strict mode"))}function jn(e,n){if(!r("name"))return n||u("Name expected"),null;var t=In(e);return Nn(t),o(),t}function Hn(e){for(var n=e.start,t=n.comments_before,r=A(n,"comments_before_length")?n.comments_before_length:t.length;--r>=0;){var i=t[r];if(/[@#]__PURE__/.test(i.value)){e.pure=i;break}}}var Yn=function(e,n){var i=e.start;if(r("punc","."))return o(),Yn(new Oe({start:i,expression:e,property:function(){var e=t.token;return"name"!=e.type&&l(),o(),e.value}(),end:s()}),n);if(r("punc","[")){o();var a=nt(!0);return h("]"),Yn(new Me({start:i,expression:e,property:a,end:s()}),n)}if(n&&r("punc","(")){o();var u=new ke({start:i,expression:e,args:Vn(),end:s()});return Hn(u),Yn(u,!0)}return r("template_head")?Yn(new te({start:i,prefix:e,template_string:bn()}),n):e},Vn=y(function(){for(var e=[];!r("punc",")");)r("expand","...")?(o(),e.push(new J({start:s(),expression:nt(!1)}))):e.push(nt(!1)),r("punc",")")||(h(","),r("punc",")")&&n.ecma<8&&l());return o(),e}),Gn=function(e,n){var i=t.token;if("name"==i.type&&"await"==i.value){if(g())return o(),g()||u("Unexpected await expression outside async function",t.prev.line,t.prev.col,t.prev.pos),new Rn({expression:Gn(!0)});t.input.has_directive("use strict")&&f(t.token,"Unexpected await identifier inside strict mode")}if(r("operator")&&dt(i.value)){o(),b();var a=Wn($e,i,Gn(e));return a.start=i,a.end=s(),a}for(var c=nn(e,n);r("operator")&&mt(t.token.value)&&!d(t.token);)c instanceof K&&l(),(c=Wn(Pe,t.token,c)).start=i,c.end=t.token,o();return c};function Wn(e,n,r){var i=n.value;switch(i){case"++":case"--":Qn(r)||u("Invalid use of "+i+" operator",n.line,n.col,n.pos);break;case"delete":r instanceof mn&&t.input.has_directive("use strict")&&u("Calling delete on expression not allowed in strict mode",r.start.line,r.start.col,r.start.pos)}return new e({operator:i,expression:r})}var Jn=function(e,n,i){var a=r("operator")?t.token.value:null;"in"==a&&i&&(a=null),"**"==a&&e instanceof $e&&!lt(e.start,"punc","(")&&"--"!==e.operator&&"++"!==e.operator&&l(e.start);var s=null!=a?gt[a]:null;if(null!=s&&(s>n||"**"===a&&n===s)){o();var u=Jn(Gn(!0),s,i);return Jn(new Le({start:e.start,left:e,operator:a,right:u,end:u.end}),n,i)}return e};var Xn=function(e){var n=t.token,i=function(e){return Jn(Gn(!0,!0),0,e)}(e);if(r("operator","?")){o();var a=nt(!1);return h(":"),new ze({start:n,condition:i,consequent:a,alternative:nt(!1,e),end:s()})}return i};function Qn(e){return e instanceof Te||e instanceof mn}function Kn(e){if(e instanceof Ne)e=new ne({start:e.start,names:e.properties.map(Kn),is_array:!1,end:e.end});else if(e instanceof Ie){for(var n=[],t=0;t<e.elements.length;t++)e.elements[t]instanceof J&&(t+1!==e.elements.length&&f(e.elements[t].start,"Spread must the be last element in destructuring array"),e.elements[t].expression=Kn(e.elements[t].expression)),n.push(Kn(e.elements[t]));e=new ne({start:e.start,names:n,is_array:!0,end:e.end})}else e instanceof je?e.value=Kn(e.value):e instanceof Ue&&(e=new qe({start:e.start,left:e.left,operator:"=",right:e.right,end:e.end}));return e}var et=function(e){var n=t.token;if("name"==n.type&&"yield"==n.value){if(_())return o(),function(){_()||u("Unexpected yield expression outside generator function",t.prev.line,t.prev.col,t.prev.pos);var e=!1,n=!0;return m()||r("punc")&&Zn(t.token.value)?n=!1:r("operator","*")&&(e=!0,o()),new $n({is_star:e,expression:n?nt():null})}();t.input.has_directive("use strict")&&f(t.token,"Unexpected yield identifier inside strict mode")}var i=Xn(e),a=t.token.value;if(r("operator")&&_t(a)){if(Qn(i)||(i=Kn(i))instanceof ne)return o(),new Ue({start:n,left:i,operator:a,right:et(e),end:s()});u("Invalid assignment")}return i},nt=function(e,n){for(var a=t.token,s=[];s.push(et(n)),e&&r("punc",",");)o(),e=!0;return 1==s.length?s[0]:new Se({start:a,expressions:s,end:i()})};function tt(e){++t.in_loop;var n=e();return--t.in_loop,n}return n.expression?nt(!0):function(){var e=t.token,i=[];for(t.input.push_directives_stack();!r("eof");)i.push(E());t.input.pop_directives_stack();var o=s(),a=n.toplevel;return a?(a.body=a.body.concat(i),a.end=o):a=new W({start:e,body:i,end:o}),a}()}function yt(e,n){Pn.call(this),this.before=e,this.after=n}function bt(e,n,t){this.name=n.name,this.orig=[n],this.init=t,this.eliminated=0,this.scope=e,this.references=[],this.replaced=0,this.global=!1,this.export=!1,this.mangled_name=null,this.undeclared=!1,this.id=bt.next_id++}function wt(e,n){var t=e.enclosed;e:for(;;){var r=Et(++e.cname);if(ot(r)&&!o(r,n.reserved)){for(var i=t.length;--i>=0;){var a=t[i];if(r==(a.mangled_name||a.unmangleable(n)&&a.name))continue e}return r}}}yt.prototype=new Pn,function(e){function n(n,t){n.DEFMETHOD("transform",function(n,r){var i,o;return n.push(this),n.before&&(i=n.before(this,t,r)),i===e&&(t(i=this,n),n.after&&(o=n.after(i,r))!==e&&(i=o)),n.pop(),i})}function t(e,n){return _(e,function(e){return e.transform(n,!0)})}n(k,l),n(z,function(e,n){e.label=e.label.transform(n),e.body=e.body.transform(n)}),n(O,function(e,n){e.body=e.body.transform(n)}),n(R,function(e,n){e.body=t(e.body,n)}),n(q,function(e,n){e.condition=e.condition.transform(n),e.body=e.body.transform(n)}),n(j,function(e,n){e.init&&(e.init=e.init.transform(n)),e.condition&&(e.condition=e.condition.transform(n)),e.step&&(e.step=e.step.transform(n)),e.body=e.body.transform(n)}),n(H,function(e,n){e.init=e.init.transform(n),e.object=e.object.transform(n),e.body=e.body.transform(n)}),n(V,function(e,n){e.expression=e.expression.transform(n),e.body=e.body.transform(n)}),n(ae,function(e,n){e.value&&(e.value=e.value.transform(n))}),n(ce,function(e,n){e.label&&(e.label=e.label.transform(n))}),n(pe,function(e,n){e.condition=e.condition.transform(n),e.body=e.body.transform(n),e.alternative&&(e.alternative=e.alternative.transform(n))}),n(he,function(e,n){e.expression=e.expression.transform(n),e.body=t(e.body,n)}),n(_e,function(e,n){e.expression=e.expression.transform(n),e.body=t(e.body,n)}),n(ge,function(e,n){e.body=t(e.body,n),e.bcatch&&(e.bcatch=e.bcatch.transform(n)),e.bfinally&&(e.bfinally=e.bfinally.transform(n))}),n(ve,function(e,n){e.argname=e.argname.transform(n),e.body=t(e.body,n)}),n(ye,function(e,n){e.definitions=t(e.definitions,n)}),n(xe,function(e,n){e.name=e.name.transform(n),e.value&&(e.value=e.value.transform(n))}),n(ne,function(e,n){e.names=t(e.names,n)}),n(X,function(e,n){e.name&&(e.name=e.name.transform(n)),e.argnames=t(e.argnames,n),e.body instanceof k?e.body=e.body.transform(n):e.body=t(e.body,n)}),n(ke,function(e,n){e.expression=e.expression.transform(n),e.args=t(e.args,n)}),n(Se,function(e,n){e.expressions=t(e.expressions,n)}),n(Oe,function(e,n){e.expression=e.expression.transform(n)}),n(Me,function(e,n){e.expression=e.expression.transform(n),e.property=e.property.transform(n)}),n($n,function(e,n){e.expression&&(e.expression=e.expression.transform(n))}),n(Rn,function(e,n){e.expression=e.expression.transform(n)}),n(Re,function(e,n){e.expression=e.expression.transform(n)}),n(Le,function(e,n){e.left=e.left.transform(n),e.right=e.right.transform(n)}),n(ze,function(e,n){e.condition=e.condition.transform(n),e.consequent=e.consequent.transform(n),e.alternative=e.alternative.transform(n)}),n(Ie,function(e,n){e.elements=t(e.elements,n)}),n(Ne,function(e,n){e.properties=t(e.properties,n)}),n(je,function(e,n){e.key instanceof k&&(e.key=e.key.transform(n)),e.value=e.value.transform(n)}),n(We,function(e,n){e.name&&(e.name=e.name.transform(n)),e.extends&&(e.extends=e.extends.transform(n)),e.properties=t(e.properties,n)}),n(J,function(e,n){e.expression=e.expression.transform(n)}),n(Ae,function(e,n){e.foreign_name=e.foreign_name.transform(n),e.name=e.name.transform(n)}),n(Ce,function(e,n){e.imported_name&&(e.imported_name=e.imported_name.transform(n)),e.imported_names&&t(e.imported_names,n),e.module_name=e.module_name.transform(n)}),n(Fe,function(e,n){e.exported_definition&&(e.exported_definition=e.exported_definition.transform(n)),e.exported_value&&(e.exported_value=e.exported_value.transform(n)),e.exported_names&&t(e.exported_names,n),e.module_name&&(e.module_name=e.module_name.transform(n))}),n(re,function(e,n){e.segments=t(e.segments,n)}),n(te,function(e,n){e.template_string=e.template_string.transform(n)})}(),bt.next_id=1,bt.prototype={unmangleable:function(e){return e||(e={}),this.global&&!e.toplevel||this.export||this.undeclared||!e.eval&&(this.scope.uses_eval||this.scope.uses_with)||e.keep_fnames&&(this.orig[0]instanceof un||this.orig[0]instanceof an)||this.orig[0]instanceof sn||e.keep_classnames&&(this.orig[0]instanceof fn||this.orig[0]instanceof cn)},mangle:function(e){var n=e.cache&&e.cache.props;if(this.global&&n&&n.has(this.name))this.mangled_name=n.get(this.name);else if(!this.mangled_name&&!this.unmangleable(e)){var t,r=this.scope,i=this.orig[0];e.ie8&&i instanceof un&&(r=r.parent_scope),(t=this.redefined())?this.mangled_name=t.mangled_name||t.name:this.mangled_name=r.next_mangled(e,this),this.global&&n&&n.set(this.name,this.mangled_name)}},redefined:function(){return this.defun&&this.defun.variables.get(this.name)}},W.DEFMETHOD("figure_out_scope",function(e){e=c(e,{cache:null,ie8:!1,safari10:!1});var n=this,t=n.parent_scope=null,r=new E,i=null,o=null,a=[],s=new Pn(function(n,u){if(n.is_block_scope()){var c=t;return n.block_scope=t=new G(n),t.init_scope_vars(c),n instanceof G||(t.uses_with=c.uses_with,t.uses_eval=c.uses_eval,t.directives=c.directives),e.safari10&&(n instanceof j||n instanceof H)&&a.push(t),u(),t=c,!0}if(n instanceof ne)return o=n,u(),o=null,!0;if(n instanceof G){n.init_scope_vars(t);c=t;var f=i,l=r;return i=t=n,r=new E,u(),t=c,i=f,r=l,!0}if(n instanceof z){var p=n.label;if(r.has(p.name))throw new Error(v("Label {name} defined twice",p));return r.set(p.name,p),u(),r.del(p.name),!0}if(n instanceof V)for(var h=t;h;h=h.parent_scope)h.uses_with=!0;else{if(n instanceof Ze&&(n.scope=t),n instanceof dn&&(n.thedef=n,n.references=[]),n instanceof un)i.def_function(n,"arguments"==n.name?void 0:i);else if(n instanceof an)_((n.scope=i.parent_scope.get_defun_scope()).def_function(n,i),1);else if(n instanceof fn)_(i.def_variable(n,i),1);else if(n instanceof pn)t.def_variable(n);else if(n instanceof cn)_((n.scope=i.parent_scope).def_function(n,i),1);else if(n instanceof en||n instanceof rn||n instanceof tn){if(w((d=n instanceof nn?t.def_variable(n,null):i.def_variable(n,"SymbolVar"==n.TYPE?null:void 0)).orig,function(e){return e===n||(n instanceof nn?e instanceof un:!(e instanceof rn||e instanceof tn))})||ft(n.name+" redeclared",n.start.file,n.start.line,n.start.col,n.start.pos),n instanceof on||_(d,2),d.destructuring=o,i!==t){n.mark_enclosed(e);var d=t.find_variable(n);n.thedef!==d&&(n.thedef=d,n.reference(e))}}else if(n instanceof ln)t.def_variable(n).defun=i;else if(n instanceof vn){var m=r.get(n.name);if(!m)throw new Error(v("Undefined label {name} [{line},{col}]",{name:n.name,line:n.start.line,col:n.start.col}));n.thedef=m}t instanceof W||!(n instanceof Fe||n instanceof Ce)||ft(n.TYPE+" statement may only appear at top level",n.start.file,n.start.line,n.start.col,n.start.pos)}function _(e,n){if(o){var t=0;do{n++}while(s.parent(t++)!==o)}var r=s.parent(n);e.export=r instanceof Fe}});n.walk(s),n.globals=new E;s=new Pn(function(t,r){if(t instanceof ce&&t.label)return t.label.thedef.references.push(t),!0;if(t instanceof mn){var i,o=t.name;if("eval"==o&&s.parent()instanceof ke)for(var a=t.scope;a&&!a.uses_eval;a=a.parent_scope)a.uses_eval=!0;return s.parent()instanceof Ae&&s.parent(1).module_name||!(i=t.scope.find_variable(o))?i=n.def_global(t):i.scope instanceof X&&"arguments"==o&&(i.scope.uses_arguments=!0),t.thedef=i,t.reference(e),!t.scope.is_block_scope()||i.orig[0]instanceof nn||(t.scope=t.scope.get_defun_scope()),!0}var u;if(t instanceof ln&&(u=t.definition().redefined()))for(a=t.scope;a&&(g(a.enclosed,u),a!==u.scope);)a=a.parent_scope});if(n.walk(s),e.ie8&&n.walk(new Pn(function(t,r){if(t instanceof ln){var i=t.name,o=t.thedef.references,a=t.thedef.defun,s=a.find_variable(i)||n.globals.get(i)||a.def_variable(t);return o.forEach(function(n){n.thedef=s,n.reference(e)}),t.thedef=s,t.reference(e),!0}})),e.safari10)for(var u=0;u<a.length;u++){(t=a[u]).parent_scope.variables.each(function(e){g(t.enclosed,e)})}}),W.DEFMETHOD("def_global",function(e){var n=this.globals,t=e.name;if(n.has(t))return n.get(t);var r=new bt(this,e);return r.undeclared=!0,r.global=!0,n.set(t,r),r}),G.DEFMETHOD("init_scope_vars",function(e){this.variables=new E,this.functions=new E,this.uses_with=!1,this.uses_eval=!1,this.parent_scope=e,this.enclosed=[],this.cname=-1}),k.DEFMETHOD("is_block_scope",p),We.DEFMETHOD("is_block_scope",p),X.DEFMETHOD("is_block_scope",p),W.DEFMETHOD("is_block_scope",p),de.DEFMETHOD("is_block_scope",p),R.DEFMETHOD("is_block_scope",h),U.DEFMETHOD("is_block_scope",h),X.DEFMETHOD("init_scope_vars",function(){G.prototype.init_scope_vars.apply(this,arguments),this.uses_arguments=!1,this.def_variable(new on({name:"arguments",start:this.start,end:this.end}))}),Ze.DEFMETHOD("mark_enclosed",function(e){for(var n=this.definition(),t=this.scope;t&&(g(t.enclosed,n),e.keep_fnames&&t.functions.each(function(e){g(n.scope.enclosed,e)}),t!==n.scope);)t=t.parent_scope}),Ze.DEFMETHOD("reference",function(e){this.definition().references.push(this),this.mark_enclosed(e)}),G.DEFMETHOD("find_variable",function(e){return e instanceof Ze&&(e=e.name),this.variables.get(e)||this.parent_scope&&this.parent_scope.find_variable(e)}),G.DEFMETHOD("def_function",function(e,n){var t=this.def_variable(e,n);return(!t.init||t.init instanceof ee)&&(t.init=n),this.functions.set(e.name,t),t}),G.DEFMETHOD("def_variable",function(e,n){var t=this.variables.get(e.name);return t?(t.orig.push(e),t.init&&(t.scope!==e.scope||t.init instanceof Q)&&(t.init=n)):(t=new bt(this,e,n),this.variables.set(e.name,t),t.global=!this.parent_scope),e.thedef=t}),G.DEFMETHOD("next_mangled",function(e){return wt(this,e)}),W.DEFMETHOD("next_mangled",function(e){var n;do{n=wt(this,e)}while(o(n,this.mangled_names));return n}),Q.DEFMETHOD("next_mangled",function(e,n){for(var t=n.orig[0]instanceof on&&this.name&&this.name.definition(),r=t?t.mangled_name||t.name:null;;){var i=wt(this,e);if(!r||r!=i)return i}}),Ze.DEFMETHOD("unmangleable",function(e){var n=this.definition();return!n||n.unmangleable(e)}),dn.DEFMETHOD("unmangleable",p),Ze.DEFMETHOD("unreferenced",function(){return 0==this.definition().references.length&&!(this.scope.uses_eval||this.scope.uses_with)}),Ze.DEFMETHOD("definition",function(){return this.thedef}),Ze.DEFMETHOD("global",function(){return this.definition().global}),W.DEFMETHOD("_default_mangler_options",function(e){return e=c(e,{eval:!1,ie8:!1,keep_classnames:!1,keep_fnames:!1,reserved:[],toplevel:!1}),Array.isArray(e.reserved)||(e.reserved=[]),g(e.reserved,"arguments"),e}),W.DEFMETHOD("mangle_names",function(e){e=this._default_mangler_options(e);var n=-1,t=[],r=this.mangled_names=[];e.cache&&(this.globals.each(a),e.cache.props&&e.cache.props.each(function(e){g(r,e)}));var i=new Pn(function(r,i){if(r instanceof z){var o=n;return i(),n=o,!0}if(r instanceof G)r.variables.each(a);else if(r.is_block_scope())r.block_scope.variables.each(a);else{if(r instanceof dn){var s;do{s=Et(++n)}while(!ot(s));return r.mangled_name=s,!0}!e.ie8&&r instanceof ln&&t.push(r.definition())}});function a(n){o(n.name,e.reserved)||t.push(n)}this.walk(i),t.forEach(function(n){n.mangle(e)})}),W.DEFMETHOD("find_colliding_names",function(e){var n=e.cache&&e.cache.props,t=Object.create(null);return e.reserved.forEach(r),this.globals.each(i),this.walk(new Pn(function(e){e instanceof G&&e.variables.each(i),e instanceof ln&&i(e.definition())})),t;function r(e){t[e]=!0}function i(t){var i=t.name;if(t.global&&n&&n.has(i))i=n.get(i);else if(!t.unmangleable(e))return;r(i)}}),W.DEFMETHOD("expand_names",function(e){Et.reset(),Et.sort(),e=this._default_mangler_options(e);var n=this.find_colliding_names(e),t=0;function r(r){if(!(r.global&&e.cache||r.unmangleable(e)||o(r.name,e.reserved))){var i=r.redefined();r.name=i?i.name:function(){var e;do{e=Et(t++)}while(n[e]||!ot(e));return e}(),r.orig.forEach(function(e){e.name=r.name}),r.references.forEach(function(e){e.name=r.name})}}this.globals.each(r),this.walk(new Pn(function(e){e instanceof G&&e.variables.each(r),e instanceof ln&&r(e.definition())}))}),k.DEFMETHOD("tail_node",d),Se.DEFMETHOD("tail_node",function(){return this.expressions[this.expressions.length-1]}),W.DEFMETHOD("compute_char_frequency",function(e){e=this._default_mangler_options(e);try{k.prototype.print=function(n,t){this._print(n,t),this instanceof Ze&&!this.unmangleable(e)?Et.consider(this.name,-1):e.properties&&(this instanceof Oe?Et.consider(this.property,-1):this instanceof Me&&function e(n){n instanceof wn?Et.consider(n.value,-1):n instanceof ze?(e(n.consequent),e(n.alternative)):n instanceof Se&&e(n.tail_node())}(this.property))},Et.consider(this.print_to_string(),1)}finally{k.prototype.print=k.prototype._print}Et.sort()});var Et=function(){var e,n,t="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".split(""),r="0123456789".split("");function i(){n=Object.create(null),t.forEach(function(e){n[e]=0}),r.forEach(function(e){n[e]=0})}function o(e,t){return n[t]-n[e]}function a(n){var t="",r=54;n++;do{t+=e[--n%r],n=Math.floor(n/r),r=64}while(n>0);return t}return a.consider=function(e,t){for(var r=e.length;--r>=0;)n[e[r]]+=t},a.sort=function(){e=y(t,o).concat(y(r,o))},a.reset=i,i(),a}(),At=/^$|[;{][\s\n]*$/;function Ct(e){return"comment2"==e.type&&/@preserve|@license|@cc_on/i.test(e.value)}function Ft(e){var n=!e;void 0===(e=c(e,{ascii_only:!1,beautify:!1,bracketize:!1,comments:!1,ecma:5,ie8:!1,indent_level:4,indent_start:0,inline_script:!0,keep_quoted_props:!1,max_line_len:!1,preamble:null,preserve_line:!1,quote_keys:!1,quote_style:0,safari10:!1,semicolons:!0,shebang:!0,shorthand:void 0,source_map:null,webkit:!1,width:80,wrap_iife:!1},!0)).shorthand&&(e.shorthand=e.ecma>5);var t=p;if(e.comments){var r=e.comments;if("string"==typeof e.comments&&/^\/.*\/[a-zA-Z]*$/.test(e.comments)){var i=e.comments.lastIndexOf("/");r=new RegExp(e.comments.substr(1,i-1),e.comments.substr(i+1))}t=r instanceof RegExp?function(e){return"comment5"!=e.type&&r.test(e.value)}:"function"==typeof r?function(e){return"comment5"!=e.type&&r(this,e)}:"some"===r?Ct:h}var o=0,a=0,s=1,u=0,f="",d=e.ascii_only?function(n,t){return e.ecma>=6&&(n=n.replace(/[\ud800-\udbff][\udc00-\udfff]/g,function(e){return"\\u{"+function(e,n){return tt(e.charAt(n))?65536+(e.charCodeAt(n)-55296<<10)+e.charCodeAt(n+1)-56320:e.charCodeAt(n)}(e,0).toString(16)+"}"})),n.replace(/[\u0000-\u001f\u007f-\uffff]/g,function(e){var n=e.charCodeAt(0).toString(16);if(n.length<=2&&!t){for(;n.length<2;)n="0"+n;return"\\x"+n}for(;n.length<4;)n="0"+n;return"\\u"+n})}:function(e){for(var n="",t=0,r=e.length;t<r;t++)tt(e[t])&&!rt(e[t+1])||rt(e[t])&&!tt(e[t-1])?n+="\\u"+e.charCodeAt(t).toString(16):n+=e[t];return n};function m(n,t){var r=function(n,t){var r=0,i=0;function o(){return"'"+n.replace(/\x27/g,"\\'")+"'"}function a(){return'"'+n.replace(/\x22/g,'\\"')+'"'}if(n=n.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g,function(t,o){switch(t){case'"':return++r,'"';case"'":return++i,"'";case"\\":return"\\\\";case"\n":return"\\n";case"\r":return"\\r";case"\t":return"\\t";case"\b":return"\\b";case"\f":return"\\f";case"\v":return e.ie8?"\\x0B":"\\v";case"\u2028":return"\\u2028";case"\u2029":return"\\u2029";case"\ufeff":return"\\ufeff";case"\0":return/[0-9]/.test(nt(n,o+1))?"\\x00":"\\0"}return t}),n=d(n),"`"===t)return"`"+n.replace(/`/g,"\\`")+"`";switch(e.quote_style){case 1:return o();case 2:return a();case 3:return"'"==t?o():a();default:return r>i?o():a()}}(n,t);return e.inline_script&&(r=(r=(r=r.replace(/<\x2fscript([>\/\t\n\f\r ])/gi,"<\\/script$1")).replace(/\x3c!--/g,"\\x3c!--")).replace(/--\x3e/g,"--\\x3e")),r}function _(n){return function e(n,t){if(t<=0)return"";if(1==t)return n;var r=e(n,t>>1);return r+=r,1&t&&(r+=n),r}(" ",e.indent_start+o-n*e.indent_level)}var g,v,D=!1,y=!1,E=0,A=!1,C=!1,F=-1,x="",S=e.source_map&&[],T=S?function(){S.forEach(function(n){try{e.source_map.add(n.token.file,n.line,n.col,n.token.line,n.token.col,n.name||"name"!=n.token.type?n.name:n.token.value)}catch(e){k.warn("Couldn't figure out mapping for {file}:{line},{col} → {cline},{ccol} [{name}]",{file:n.token.file,line:n.token.line,col:n.token.col,cline:n.line,ccol:n.col,name:n.name||""})}}),S=[]}:l,O=e.max_line_len?function(){if(a>e.max_line_len){if(E){var n=f.slice(0,E),t=f.slice(E);if(S){var r=t.length-a;S.forEach(function(e){e.line++,e.col+=r})}f=n+"\n"+t,s++,u++,a=t.length}a>e.max_line_len&&k.warn("Output exceeds {max_line_len} characters",e)}E&&(E=0,T())}:l,M=b("( [ + * / - , . `");function R(n){var t=nt(n=String(n),0),r=nt(x,x.length-1);A&&t&&(A=!1,"\n"!=t&&(R("\n"),P())),C&&t&&(C=!1,/[\s;})]/.test(t)||$()),F=-1;r=x.charAt(x.length-1);if(y&&(y=!1,(":"==r&&"}"==t||(!t||";}".indexOf(t)<0)&&";"!=r)&&(e.semicolons||M(t)?(f+=";",a++,u++):(O(),f+="\n",u++,s++,a=0,/^\s+$/.test(n)&&(y=!0)),e.beautify||(D=!1))),!e.beautify&&e.preserve_line&&H[H.length-1])for(var i=H[H.length-1].start.line;s<i;)O(),f+="\n",u++,s++,a=0,D=!1;D&&((st(r)&&(st(t)||"\\"==t)||"/"==t&&t==r||("+"==t||"-"==t)&&t==x)&&(f+=" ",a++,u++),D=!1),g&&(S.push({token:g,name:v,line:s,col:a}),g=!1,E||T()),f+=n,u+=n.length;var o=n.split(/\r?\n/),c=o.length-1;s+=c,a+=o[0].length,c>0&&(O(),a=o[c].length),x=n}var $=e.beautify?function(){R(" ")}:function(){D=!0},P=e.beautify?function(n){e.beautify&&R(_(n?.5:0))}:l,L=e.beautify?function(e,n){!0===e&&(e=I());var t=o;o=e;var r=n();return o=t,r}:function(e,n){return n()},z=e.beautify?function(){if(F<0)return R("\n");"\n"!=f[F]&&(f=f.slice(0,F)+"\n"+f.slice(F),u++,s++),F++}:e.max_line_len?function(){O(),E=f.length}:l,U=e.beautify?function(){R(";")}:function(){y=!0};function q(){y=!1,R(";")}function I(){return o+e.indent_level}function N(){return E&&O(),f}function j(){var e=f.lastIndexOf("\n");return/^ *$/.test(f.slice(e+1))}var H=[];return{get:N,toString:N,indent:P,indentation:function(){return o},current_width:function(){return a-o},should_break:function(){return e.width&&this.current_width()>=e.width},newline:z,print:R,star:function(){R("*")},space:$,comma:function(){R(","),$()},colon:function(){R(":"),$()},last:function(){return x},semicolon:U,force_semicolon:q,to_utf8:d,print_name:function(e){R(function(e){return e=e.toString(),e=d(e,!0)}(e))},print_string:function(e,n,t){var r=m(e,n);!0===t&&-1===r.indexOf("\\")&&(At.test(f)||q(),q()),R(r)},print_template_string_chars:function(e){var n=m(e,"`").replace(/\${/g,"\\${");return R(n.substr(1,n.length-2))},encode_string:m,next_indent:I,with_indent:L,with_block:function(e){var n;return R("{"),z(),L(I(),function(){n=e()}),P(),R("}"),n},with_parens:function(e){R("(");var n=e();return R(")"),n},with_square:function(e){R("[");var n=e();return R("]"),n},add_mapping:S?function(e,n){g=e,v=n}:l,option:function(n){return e[n]},prepend_comments:n?l:function(n){var r=this,i=n.start;if(i&&(!i.comments_before||i.comments_before._dumped!==r)){var o=i.comments_before;if(o||(o=i.comments_before=[]),o._dumped=r,n instanceof ae&&n.value){var a=new Pn(function(e){var n=a.parent();if(!(n instanceof ae||n instanceof Le&&n.left===e||"Call"==n.TYPE&&n.expression===e||n instanceof ze&&n.condition===e||n instanceof Oe&&n.expression===e||n instanceof Se&&n.expressions[0]===e||n instanceof Me&&n.expression===e||n instanceof Pe))return!0;if(e.start){var t=e.start.comments_before;t&&t._dumped!==r&&(t._dumped=r,o=o.concat(t))}});a.push(n),n.value.walk(a)}if(0==u){o.length>0&&e.shebang&&"comment5"==o[0].type&&(R("#!"+o.shift().value+"\n"),P());var s=e.preamble;s&&R(s.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g,"\n"))}if(0!=(o=o.filter(t,n)).length){var c=j();o.forEach(function(e,n){c||(e.nlb?(R("\n"),P(),c=!0):n>0&&$()),/comment[134]/.test(e.type)?(R("//"+e.value.replace(/[@#]__PURE__/g," ")+"\n"),P(),c=!0):"comment2"==e.type&&(R("/*"+e.value.replace(/[@#]__PURE__/g," ")+"*/"),c=!1)}),c||(i.nlb?(R("\n"),P()):$())}}},append_comments:n||t===p?l:function(e,n){var r=e.end;if(r){var i=r[n?"comments_before":"comments_after"];if(i&&i._dumped!==this&&(e instanceof B||w(i,function(e){return!/comment[134]/.test(e.type)}))){i._dumped=this;var o=f.length;i.filter(t,e).forEach(function(e,t){C=!1,A?(R("\n"),P(),A=!1):e.nlb&&(t>0||!j())?(R("\n"),P()):(t>0||!n)&&$(),/comment[134]/.test(e.type)?(R("//"+e.value.replace(/[@#]__PURE__/g," ")),A=!0):"comment2"==e.type&&(R("/*"+e.value.replace(/[@#]__PURE__/g," ")+"*/"),C=!0)}),f.length>o&&(F=o)}}},line:function(){return s},col:function(){return a},pos:function(){return u},push_node:function(e){H.push(e)},pop_node:function(){return H.pop()},parent:function(e){return H[H.length-2-(e||0)]}}}function xt(e,n){if(!(this instanceof xt))return new xt(e,n);yt.call(this,this.before,this.after),this.options=c(e,{arrows:!n,booleans:!n,collapse_vars:!n,comparisons:!n,computed_props:!n,conditionals:!n,dead_code:!n,drop_console:!1,drop_debugger:!n,ecma:5,evaluate:!n,expression:!1,global_defs:{},hoist_funs:!1,hoist_props:!n,hoist_vars:!1,ie8:!1,if_return:!n,inline:!n,join_vars:!n,keep_classnames:!1,keep_fargs:!0,keep_fnames:!1,keep_infinity:!1,loops:!n,negate_iife:!n,passes:1,properties:!n,pure_getters:!n&&"strict",pure_funcs:null,reduce_funcs:!n,reduce_vars:!n,sequences:!n,side_effects:!n,switches:!n,top_retain:null,toplevel:!(!e||!e.top_retain),typeofs:!n,unsafe:!1,unsafe_arrows:!1,unsafe_comps:!1,unsafe_Function:!1,unsafe_math:!1,unsafe_methods:!1,unsafe_proto:!1,unsafe_regexp:!1,unsafe_undefined:!1,unused:!n,warnings:!1},!0);var t=this.options.global_defs;if("object"==typeof t)for(var r in t)/^@/.test(r)&&A(t,r)&&(t[r.slice(1)]=Dt(t[r],{expression:!0}));!0===this.options.inline&&(this.options.inline=3);var i=this.options.pure_funcs;this.pure_funcs="function"==typeof i?i:i?function(e){return i.indexOf(e.expression.print_to_string())<0}:h;var o=this.options.top_retain;o instanceof RegExp?this.top_retain=function(e){return o.test(e.name)}:"function"==typeof o?this.top_retain=o:o&&("string"==typeof o&&(o=o.split(/,/)),this.top_retain=function(e){return o.indexOf(e.name)>=0});var a=this.options.toplevel;this.toplevel="string"==typeof a?{funcs:/funcs/.test(a),vars:/vars/.test(a)}:{funcs:a,vars:a};var s=this.options.sequences;this.sequences_limit=1==s?800:0|s,this.warnings_produced={}}function kt(e,n){e.walk(new Pn(function(e){return e instanceof Se?kt(e.tail_node(),n):e instanceof wn?n(e.value):e instanceof ze&&(kt(e.consequent,n),kt(e.alternative,n)),!0}))}function Bt(n,t){var r=(t=c(t,{builtins:!1,cache:null,debug:!1,keep_quoted:!1,only_cache:!1,regex:null,reserved:null},!0)).reserved;Array.isArray(r)||(r=[]),t.builtins||function(n){var t={},r="object"==typeof e?e:self;function i(e){g(n,e)}["Symbol","Map","Promise","Proxy","Reflect","Set","WeakMap","WeakSet"].forEach(function(e){t[e]=r[e]||new Function}),["null","true","false","Infinity","-Infinity","undefined"].forEach(i),[Object,Array,Function,Number,String,Boolean,Error,Math,Date,RegExp,t.Symbol,ArrayBuffer,DataView,decodeURI,decodeURIComponent,encodeURI,encodeURIComponent,eval,EvalError,Float32Array,Float64Array,Int8Array,Int16Array,Int32Array,isFinite,isNaN,JSON,t.Map,parseFloat,parseInt,t.Promise,t.Proxy,RangeError,ReferenceError,t.Reflect,t.Set,SyntaxError,TypeError,Uint8Array,Uint8ClampedArray,Uint16Array,Uint32Array,URIError,t.WeakMap,t.WeakSet].forEach(function(e){Object.getOwnPropertyNames(e).map(i),e.prototype&&Object.getOwnPropertyNames(e.prototype).map(i)})}(r);var i,o=-1;t.cache?(i=t.cache.props).each(function(e){g(r,e)}):i=new E;var a,s=t.regex,u=!1!==t.debug;u&&(a=!0===t.debug?"":t.debug);var f=[],l=[];return n.walk(new Pn(function(e){e instanceof He?d(e.key):e instanceof je?d(e.key.name):e instanceof Oe?d(e.property):e instanceof Me&&kt(e.property,d)})),n.transform(new yt(function(e){e instanceof He?e.key=m(e.key):e instanceof je?e.key.name=m(e.key.name):e instanceof Oe?e.property=m(e.property):!t.keep_quoted&&e instanceof Me&&(e.property=function e(n){return n.transform(new yt(function(n){if(n instanceof Se){var t=n.expressions.length-1;n.expressions[t]=e(n.expressions[t])}else n instanceof wn?n.value=m(n.value):n instanceof ze&&(n.consequent=e(n.consequent),n.alternative=e(n.alternative));return n}))}(e.property))}));function p(e){return!(l.indexOf(e)>=0)&&(!(r.indexOf(e)>=0)&&(t.only_cache?i.has(e):!/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)))}function h(e){return!(s&&!s.test(e))&&(!(r.indexOf(e)>=0)&&(i.has(e)||f.indexOf(e)>=0))}function d(e){p(e)&&g(f,e),h(e)||g(l,e)}function m(e){if(!h(e))return e;var n=i.get(e);if(!n){if(u){var t="_$"+e+"$"+a+"_";p(t)&&(n=t)}if(!n)do{n=Et(++o)}while(!p(n));i.set(e,n)}return n}}!function(){function e(e,n){e.DEFMETHOD("_codegen",n)}var n=!1,t=null,r=null;function i(e,n){Array.isArray(e)?e.forEach(function(e){i(e,n)}):e.DEFMETHOD("needs_parens",n)}function o(e,t,r,i){var o=e.length-1;n=i,e.forEach(function(e,i){!0!==n||e instanceof T||e instanceof P||e instanceof O&&e.body instanceof wn||(n=!1),e instanceof P||(r.indent(),e.print(r),i==o&&t||(r.newline(),t&&r.newline())),!0===n&&e instanceof O&&e.body instanceof wn&&(n=!1)}),n=!1}function a(e,n,t){e.body.length>0?n.with_block(function(){o(e.body,!1,n,t)}):(n.print("{"),n.with_indent(n.next_indent(),function(){n.append_comments(e,!0)}),n.print("}"))}function s(e,n,t){var r=!1;t&&e.walk(new Pn(function(e){return!!(r||e instanceof G)||(e instanceof Le&&"in"==e.operator?(r=!0,!0):void 0)})),e.print(n,r)}function u(e,n,t){t.option("quote_keys")?t.print_string(e):""+ +e==e&&e>=0?t.print(h(e)):(Un(e)?!t.option("ie8"):ut(e))?n&&t.option("keep_quoted_props")?t.print_string(e,n):t.print_name(e):t.print_string(e,n)}function c(e,n){n.option("bracketize")?d(e,n):!e||e instanceof P?n.force_semicolon():e.print(n)}function f(e,n){return e.args.length>0||n.option("beautify")}function h(e){var n,t=e.toString(10),r=[t.replace(/^0\./,".").replace("e+","e")];return Math.floor(e)===e?(e>=0?r.push("0x"+e.toString(16).toLowerCase(),"0"+e.toString(8)):r.push("-0x"+(-e).toString(16).toLowerCase(),"-0"+(-e).toString(8)),(n=/^(.*?)(0+)$/.exec(e))&&r.push(n[1]+"e"+n[2].length)):(n=/^0?\.(0+)(.*)$/.exec(e))&&r.push(n[2]+"e-"+(n[1].length+n[2].length),t.substr(t.indexOf("."))),function(e){for(var n=e[0],t=n.length,r=1;r<e.length;++r)e[r].length<t&&(t=(n=e[r]).length);return n}(r)}function d(e,n){!e||e instanceof P?n.print("{}"):e instanceof $?e.print(n):n.with_block(function(){n.indent(),e.print(n),n.newline()})}function m(e,n){e.DEFMETHOD("add_source_map",function(e){n(this,e)})}function _(e,n){n.add_mapping(e.start)}k.DEFMETHOD("print",function(e,n){var i=this,o=i._codegen;function a(){e.prepend_comments(i),i.add_source_map(e),o(i,e),e.append_comments(i)}i instanceof G?t=i:!r&&i instanceof T&&"use asm"==i.value&&(r=t),e.push_node(i),n||i.needs_parens(e)?e.with_parens(a):a(),e.pop_node(),i===r&&(r=null)}),k.DEFMETHOD("_print",k.prototype.print),k.DEFMETHOD("print_to_string",function(e){var n=Ft(e);return this.print(n),n.get()}),i(k,p),i(Q,function(e){if(C(e))return!0;var n;if(e.option("webkit")&&((n=e.parent())instanceof Te&&n.expression===this))return!0;return!!e.option("wrap_iife")&&((n=e.parent())instanceof ke&&n.expression===this)}),i(K,function(e){var n=e.parent();return n instanceof Te&&n.expression===this}),i([Xe,Ne],C),i(Re,function(e){var n=e.parent();return n instanceof Te&&n.expression===this||n instanceof ke&&n.expression===this||n instanceof Le&&"**"===n.operator&&this instanceof $e&&n.left===this&&"++"!==this.operator&&"--"!==this.operator}),i(Rn,function(e){var n=e.parent();return n instanceof Te&&n.expression===this||n instanceof ke&&n.expression===this||e.option("safari10")&&n instanceof $e}),i(Se,function(e){var n=e.parent();return n instanceof ke||n instanceof Re||n instanceof Le||n instanceof xe||n instanceof Te||n instanceof Ie||n instanceof je||n instanceof ze||n instanceof K||n instanceof qe||n instanceof J||n instanceof Y&&this===n.object||n instanceof $n}),i(Le,function(e){var n=e.parent();if(n instanceof ke&&n.expression===this)return!0;if(n instanceof Re)return!0;if(n instanceof Te&&n.expression===this)return!0;if(n instanceof Le){var t=n.operator,r=gt[t],i=this.operator,o=gt[i];if(r>o||r==o&&this===n.right)return!0}}),i($n,function(e){var n=e.parent();return n instanceof Le&&"="!==n.operator||(n instanceof ke&&n.expression===this||(n instanceof ze&&n.condition===this||(n instanceof Re||(n instanceof Te&&n.expression===this||void 0))))}),i(Te,function(e){var n=e.parent();if(n instanceof Be&&n.expression===this){var t=!1;return this.walk(new Pn(function(e){return!!(t||e instanceof G)||(e instanceof ke?(t=!0,!0):void 0)})),t}}),i(ke,function(e){var n,t=e.parent();return t instanceof Be&&t.expression===this||this.expression instanceof Q&&t instanceof Te&&t.expression===this&&(n=e.parent(1))instanceof Ue&&n.left===t}),i(Be,function(e){var n=e.parent();if(!f(this,e)&&(n instanceof Te||n instanceof ke&&n.expression===this))return!0}),i(En,function(e){var n=e.parent();if(n instanceof Te&&n.expression===this){var t=this.getValue();if(t<0||/^0/.test(h(t)))return!0}}),i([Ue,ze],function(e){var n=e.parent();return n instanceof Re||(n instanceof Le&&!(n instanceof Ue)||(n instanceof ke&&n.expression===this||(n instanceof ze&&n.condition===this||(n instanceof Te&&n.expression===this||(this instanceof Ue&&this.left instanceof ne&&!1===this.left.is_array||void 0)))))}),e(T,function(e,n){n.print_string(e.value,e.quote),n.semicolon()}),e(J,function(e,n){n.print("..."),e.expression.print(n)}),e(ne,function(e,n){n.print(e.is_array?"[":"{");var t=e.names.length;e.names.forEach(function(e,r){r>0&&n.comma(),e.print(n),r==t-1&&e instanceof Bn&&n.comma()}),n.print(e.is_array?"]":"}")}),e(S,function(e,n){n.print("debugger"),n.semicolon()}),L.DEFMETHOD("_do_print_body",function(e){c(this.body,e)}),e(B,function(e,n){e.body.print(n),n.semicolon()}),e(W,function(e,n){o(e.body,!0,n,!0),n.print("")}),e(z,function(e,n){e.label.print(n),n.colon(),e.body.print(n)}),e(O,function(e,n){e.body.print(n),n.semicolon()}),e($,function(e,n){a(e,n)}),e(P,function(e,n){n.semicolon()}),e(I,function(e,n){n.print("do"),n.space(),d(e.body,n),n.space(),n.print("while"),n.space(),n.with_parens(function(){e.condition.print(n)}),n.semicolon()}),e(N,function(e,n){n.print("while"),n.space(),n.with_parens(function(){e.condition.print(n)}),n.space(),e._do_print_body(n)}),e(j,function(e,n){n.print("for"),n.space(),n.with_parens(function(){e.init?(e.init instanceof ye?e.init.print(n):s(e.init,n,!0),n.print(";"),n.space()):n.print(";"),e.condition?(e.condition.print(n),n.print(";"),n.space()):n.print(";"),e.step&&e.step.print(n)}),n.space(),e._do_print_body(n)}),e(H,function(e,n){n.print("for"),n.space(),n.with_parens(function(){e.init.print(n),n.space(),n.print(e instanceof Y?"of":"in"),n.space(),e.object.print(n)}),n.space(),e._do_print_body(n)}),e(V,function(e,n){n.print("with"),n.space(),n.with_parens(function(){e.expression.print(n)}),n.space(),e._do_print_body(n)}),X.DEFMETHOD("_do_print",function(e,n){var t=this;n||(t.async&&(e.print("async"),e.space()),e.print("function"),t.is_generator&&e.star(),t.name&&e.space()),t.name instanceof Ze?t.name.print(e):n&&t.name instanceof k&&e.with_square(function(){t.name.print(e)}),e.with_parens(function(){t.argnames.forEach(function(n,t){t&&e.comma(),n.print(e)})}),e.space(),a(t,e,!0)}),e(X,function(e,n){e._do_print(n)}),e(te,function(e,n){e.prefix.print(n),e.template_string.print(n)}),e(re,function(e,n){var t=n.parent()instanceof te;n.print("`");for(var r=0;r<e.segments.length;r++)e.segments[r]instanceof ie?t?n.print(e.segments[r].raw):n.print_template_string_chars(e.segments[r].value):(n.print("${"),e.segments[r].print(n),n.print("}"));n.print("`")}),K.DEFMETHOD("_do_print",function(e){var n=this,t=e.parent(),r=t instanceof Le||t instanceof Re||t instanceof ke&&n===t.expression;r&&e.print("("),n.async&&(e.print("async"),e.space()),1===n.argnames.length&&n.argnames[0]instanceof Ze?n.argnames[0].print(e):e.with_parens(function(){n.argnames.forEach(function(n,t){t&&e.comma(),n.print(e)})}),e.space(),e.print("=>"),e.space(),n.body instanceof k?n.body.print(e):a(n,e),r&&e.print(")")}),ae.DEFMETHOD("_do_print",function(e,n){e.print(n),this.value&&(e.space(),this.value.print(e)),e.semicolon()}),e(se,function(e,n){e._do_print(n,"return")}),e(ue,function(e,n){e._do_print(n,"throw")}),e($n,function(e,n){var t=e.is_star?"*":"";n.print("yield"+t),e.expression&&(n.space(),e.expression.print(n))}),e(Rn,function(e,n){n.print("await"),n.space();var t=e.expression,r=!(t instanceof ke||t instanceof mn||t instanceof Te||t instanceof Re||t instanceof bn);r&&n.print("("),e.expression.print(n),r&&n.print(")")}),ce.DEFMETHOD("_do_print",function(e,n){e.print(n),this.label&&(e.space(),this.label.print(e)),e.semicolon()}),e(fe,function(e,n){e._do_print(n,"break")}),e(le,function(e,n){e._do_print(n,"continue")}),e(pe,function(e,n){n.print("if"),n.space(),n.with_parens(function(){e.condition.print(n)}),n.space(),e.alternative?(!function(e,n){var t=e.body;if(n.option("bracketize")||n.option("ie8")&&t instanceof I)return d(t,n);if(!t)return n.force_semicolon();for(;;)if(t instanceof pe){if(!t.alternative)return void d(e.body,n);t=t.alternative}else{if(!(t instanceof L))break;t=t.body}c(e.body,n)}(e,n),n.space(),n.print("else"),n.space(),e.alternative instanceof pe?e.alternative.print(n):c(e.alternative,n)):e._do_print_body(n)}),e(he,function(e,n){n.print("switch"),n.space(),n.with_parens(function(){e.expression.print(n)}),n.space();var t=e.body.length-1;t<0?n.print("{}"):n.with_block(function(){e.body.forEach(function(e,r){n.indent(!0),e.print(n),r<t&&e.body.length>0&&n.newline()})})}),de.DEFMETHOD("_do_print_body",function(e){e.newline(),this.body.forEach(function(n){e.indent(),n.print(e),e.newline()})}),e(me,function(e,n){n.print("default:"),e._do_print_body(n)}),e(_e,function(e,n){n.print("case"),n.space(),e.expression.print(n),n.print(":"),e._do_print_body(n)}),e(ge,function(e,n){n.print("try"),n.space(),a(e,n),e.bcatch&&(n.space(),e.bcatch.print(n)),e.bfinally&&(n.space(),e.bfinally.print(n))}),e(ve,function(e,n){n.print("catch"),n.space(),n.with_parens(function(){e.argname.print(n)}),n.space(),a(e,n)}),e(De,function(e,n){n.print("finally"),n.space(),a(e,n)}),ye.DEFMETHOD("_do_print",function(e,n){e.print(n),e.space(),this.definitions.forEach(function(n,t){t&&e.comma(),n.print(e)});var t=e.parent();(t instanceof j||t instanceof H)&&t.init===this||e.semicolon()}),e(we,function(e,n){e._do_print(n,"let")}),e(be,function(e,n){e._do_print(n,"var")}),e(Ee,function(e,n){e._do_print(n,"const")}),e(Ce,function(e,n){n.print("import"),n.space(),e.imported_name&&e.imported_name.print(n),e.imported_name&&e.imported_names&&(n.print(","),n.space()),e.imported_names&&(1===e.imported_names.length&&"*"===e.imported_names[0].foreign_name.name?e.imported_names[0].print(n):(n.print("{"),e.imported_names.forEach(function(t,r){n.space(),t.print(n),r<e.imported_names.length-1&&n.print(",")}),n.space(),n.print("}"))),(e.imported_name||e.imported_names)&&(n.space(),n.print("from"),n.space()),e.module_name.print(n),n.semicolon()}),e(Ae,function(e,n){var t=n.parent()instanceof Ce,r=e.name.definition();(r&&r.mangled_name||e.name.name)!==e.foreign_name.name?(t?n.print(e.foreign_name.name):e.name.print(n),n.space(),n.print("as"),n.space(),t?e.name.print(n):n.print(e.foreign_name.name)):e.name.print(n)}),e(Fe,function(e,n){if(n.print("export"),n.space(),e.is_default&&(n.print("default"),n.space()),e.exported_names)1===e.exported_names.length&&"*"===e.exported_names[0].name.name?e.exported_names[0].print(n):(n.print("{"),e.exported_names.forEach(function(t,r){n.space(),t.print(n),r<e.exported_names.length-1&&n.print(",")}),n.space(),n.print("}"));else if(e.exported_value)e.exported_value.print(n);else if(e.exported_definition&&(e.exported_definition.print(n),e.exported_definition instanceof ye))return;e.module_name&&(n.space(),n.print("from"),n.space(),e.module_name.print(n)),n.semicolon()}),e(xe,function(e,n){if(e.name.print(n),e.value){n.space(),n.print("="),n.space();var t=n.parent(1),r=t instanceof j||t instanceof H;s(e.value,n,r)}}),e(ke,function(e,n){e.expression.print(n),e instanceof Be&&!f(e,n)||((e.expression instanceof ke||e.expression instanceof X)&&n.add_mapping(e.start),n.with_parens(function(){e.args.forEach(function(e,t){t&&n.comma(),e.print(n)})}))}),e(Be,function(e,n){n.print("new"),n.space(),ke.prototype._codegen(e,n)}),Se.DEFMETHOD("_do_print",function(e){this.expressions.forEach(function(n,t){t>0&&(e.comma(),e.should_break()&&(e.newline(),e.indent())),n.print(e)})}),e(Se,function(e,n){e._do_print(n)}),e(Oe,function(e,n){var t=e.expression;t.print(n);var r=e.property;n.option("ie8")&&Un(r)?(n.print("["),n.add_mapping(e.end),n.print_string(r),n.print("]")):(t instanceof En&&t.getValue()>=0&&(/[xa-f.)]/i.test(n.last())||n.print(".")),n.print("."),n.add_mapping(e.end),n.print_name(r))}),e(Me,function(e,n){e.expression.print(n),n.print("["),e.property.print(n),n.print("]")}),e($e,function(e,n){var t=e.operator;n.print(t),(/^[a-z]/i.test(t)||/[+-]$/.test(t)&&e.expression instanceof $e&&/^[+-]/.test(e.expression.operator))&&n.space(),e.expression.print(n)}),e(Pe,function(e,n){e.expression.print(n),n.print(e.operator)}),e(Le,function(e,n){var t=e.operator;e.left.print(n),">"==t[0]&&e.left instanceof Pe&&"--"==e.left.operator?n.print(" "):n.space(),n.print(t),("<"==t||"<<"==t)&&e.right instanceof $e&&"!"==e.right.operator&&e.right.expression instanceof $e&&"--"==e.right.expression.operator?n.print(" "):n.space(),e.right.print(n)}),e(ze,function(e,n){e.condition.print(n),n.space(),n.print("?"),n.space(),e.consequent.print(n),n.space(),n.colon(),e.alternative.print(n)}),e(Ie,function(e,n){n.with_square(function(){var t=e.elements,r=t.length;r>0&&n.space(),t.forEach(function(e,t){t&&n.comma(),e.print(n),t===r-1&&e instanceof Bn&&n.comma()}),r>0&&n.space()})}),e(Ne,function(e,n){e.properties.length>0?n.with_block(function(){e.properties.forEach(function(e,t){t&&(n.print(","),n.newline()),n.indent(),e.print(n)}),n.newline()}):n.print("{}")}),e(We,function(e,n){if(n.print("class"),n.space(),e.name&&(e.name.print(n),n.space()),e.extends){var t=!(e.extends instanceof mn||e.extends instanceof Te||e.extends instanceof Xe||e.extends instanceof Q);n.print("extends"),t?n.print("("):n.space(),e.extends.print(n),t?n.print(")"):n.space()}e.properties.length>0?n.with_block(function(){e.properties.forEach(function(e,t){t&&n.newline(),n.indent(),e.print(n)}),n.newline()}):n.print("{}")}),e(Qe,function(e,n){n.print("new.target")}),e(He,function(e,n){function t(e){var n=e.definition();return n?n.mangled_name||n.name:e.name}var r=n.option("shorthand");r&&e.value instanceof Ze&&ut(e.key)&&t(e.value)===e.key&&ot(e.key)?u(e.key,e.quote,n):r&&e.value instanceof qe&&e.value.left instanceof Ze&&ut(e.key)&&t(e.value.left)===e.key?(u(e.key,e.quote,n),n.space(),n.print("="),n.space(),e.value.right.print(n)):(e.key instanceof k?n.with_square(function(){e.key.print(n)}):u(e.key,e.quote,n),n.colon(),e.value.print(n))}),je.DEFMETHOD("_print_getter_setter",function(e,n){var t=this;t.static&&(n.print("static"),n.space()),e&&(n.print(e),n.space()),t.key instanceof sn?u(t.key.name,t.quote,n):n.with_square(function(){t.key.print(n)}),t.value._do_print(n,!0)}),e(Ye,function(e,n){e._print_getter_setter("set",n)}),e(Ve,function(e,n){e._print_getter_setter("get",n)}),e(Ge,function(e,n){e._print_getter_setter(e.is_generator?"*":e.async&&"async",n)}),Ze.DEFMETHOD("_do_print",function(e){var n=this.definition();e.print_name(n?n.mangled_name||n.name:this.name)}),e(Ze,function(e,n){e._do_print(n)}),e(Bn,l),e(Dn,function(e,n){n.print("this")}),e(yn,function(e,n){n.print("super")}),e(bn,function(e,n){n.print(e.getValue())}),e(wn,function(e,t){t.print_string(e.getValue(),e.quote,n)}),e(En,function(e,n){r&&e.start&&null!=e.start.raw?n.print(e.start.raw):n.print(h(e.getValue()))}),e(An,function(e,n){var t=e.getValue(),r=t.toString();t.raw_source&&(r="/"+t.raw_source+r.slice(r.lastIndexOf("/"))),r=n.to_utf8(r),n.print(r);var i=n.parent();i instanceof Le&&/^in/.test(i.operator)&&i.left===e&&n.print(" ")}),m(k,l),m(T,_),m(S,_),m(Ze,_),m(oe,_),m(L,_),m(z,l),m(X,_),m(he,_),m(de,_),m($,_),m(W,l),m(Be,_),m(ge,_),m(ve,_),m(De,_),m(ye,_),m(bn,_),m(Ye,function(e,n){n.add_mapping(e.start,e.key.name)}),m(Ve,function(e,n){n.add_mapping(e.start,e.key.name)}),m(je,function(e,n){n.add_mapping(e.start,e.key)})}(),xt.prototype=new yt,f(xt.prototype,{option:function(e){return this.options[e]},exposed:function(e){if(e.export)return!0;if(e.global)for(var n=0,t=e.orig.length;n<t;n++)if(!this.toplevel[e.orig[n]instanceof an?"funcs":"vars"])return!0;return!1},in_boolean_context:function(){if(!this.option("booleans"))return!1;for(var e,n=this.self(),t=0;e=this.parent(t);t++){if(e instanceof O||e instanceof ze&&e.condition===n||e instanceof q&&e.condition===n||e instanceof j&&e.condition===n||e instanceof pe&&e.condition===n||e instanceof $e&&"!"==e.operator&&e.expression===n)return!0;if(!(e instanceof Le&&("&&"==e.operator||"||"==e.operator)||e instanceof ze||e.tail_node()===n))return!1;n=e}},compress:function(e){this.option("expression")&&e.process_expression(!0);for(var n=+this.options.passes||1,t=1/0,r=!1,i={ie8:this.option("ie8")},o=0;o<n;o++)if(e.figure_out_scope(i),(o>0||this.option("reduce_vars"))&&e.reset_opt_flags(this),e=e.transform(this),n>1){var a=0;if(e.walk(new Pn(function(){a++})),this.info("pass "+o+": last_count: "+t+", count: "+a),a<t)t=a,r=!1;else{if(r)break;r=!0}}return this.option("expression")&&e.process_expression(!1),e},info:function(){"verbose"==this.options.warnings&&k.warn.apply(k,arguments)},warn:function(e,n){if(this.options.warnings){var t=v(e,n);t in this.warnings_produced||(this.warnings_produced[t]=!0,k.warn.apply(k,arguments))}},clear_warnings:function(){this.warnings_produced={}},before:function(e,n,t){if(e._squeezed)return e;var r=!1;e instanceof G&&(e=(e=e.hoist_properties(this)).hoist_declarations(this),r=!0),n(e,this),n(e,this);var i=e.optimize(this);return r&&i instanceof G&&(i.drop_unused(this),n(i,this)),i===e&&(i._squeezed=!0),i}}),function(){function e(e,n){e.DEFMETHOD("optimize",function(e){if(this._optimized)return this;if(e.has_directive("use asm"))return this;var t=n(this,e);return t._optimized=!0,t})}function n(e){return e instanceof K||e instanceof Q}function t(e){if(e instanceof Dn)return!0;if(e instanceof mn)return e.definition().orig[0]instanceof un;if(e instanceof Te){if((e=e.expression)instanceof mn){if(e.is_immutable())return!1;e=e.fixed_value()}return!e||!(e instanceof An)&&(e instanceof bn||t(e))}return!1}function r(e,n){if(!(e instanceof mn))return!1;for(var t=e.definition().orig,r=t.length;--r>=0;)if(t[r]instanceof n)return!0}function i(e,n){for(var t,r=0;(t=e.parent(r++))&&!(t instanceof G);)if(t instanceof ve){t=t.argname.definition().scope;break}return t.find_variable(n)}function s(e,n,t){return t||(t={}),n&&(t.start||(t.start=n.start),t.end||(t.end=n.end)),new e(t)}function u(e,n){return 1==n.length?n[0]:s(Se,e,{expressions:n.reduce(g,[])})}function c(e,n){switch(typeof e){case"string":return s(wn,n,{value:e});case"number":return isNaN(e)?s(xn,n):isFinite(e)?1/e<0?s($e,n,{operator:"-",expression:s(En,n,{value:-e})}):s(En,n,{value:e}):e<0?s($e,n,{operator:"-",expression:s(Sn,n)}):s(Sn,n);case"boolean":return s(e?Mn:On,n);case"undefined":return s(kn,n);default:if(null===e)return s(Fn,n,{value:null});if(e instanceof RegExp)return s(An,n,{value:e});throw new Error(v("Can't handle constant of type: {type}",{type:typeof e}))}}function f(e,n,t){return e instanceof $e&&"delete"==e.operator||e instanceof ke&&e.expression===n&&(t instanceof Te||t instanceof mn&&"eval"==t.name)?u(n,[s(En,n,{value:0}),t]):t}function g(e,n){return n instanceof Se?e.push.apply(e,n.expressions):e.push(n),e}function y(e){if(null===e)return[];if(e instanceof $)return e.body;if(e instanceof P)return[];if(e instanceof B)return[e];throw new Error("Can't convert thing to statement array")}function F(e){return null===e||(e instanceof P||e instanceof $&&0==e.body.length)}function x(e){return!(e instanceof Je||e instanceof ee||e instanceof we||e instanceof Ee||e instanceof Fe||e instanceof Ce)}function L(e){return e instanceof U&&e.body instanceof $?e.body:e}function Y(e){return"Call"==e.TYPE&&(e.expression instanceof Q||Y(e.expression))}function De(e){return e instanceof mn&&e.definition().undeclared}e(k,function(e,n){return e}),k.DEFMETHOD("equivalent_to",function(e){return this.TYPE==e.TYPE&&this.print_to_string()==e.print_to_string()}),G.DEFMETHOD("process_expression",function(e,n){var t=this,r=new yt(function(i){if(e&&i instanceof O)return s(se,i,{value:i.body});if(!e&&i instanceof se){if(n){var o=i.value&&i.value.drop_side_effect_free(n,!0);return o?s(O,i,{body:o}):s(P,i)}return s(O,i,{body:i.value||s($e,i,{operator:"void",expression:s(En,i,{value:0})})})}if(i instanceof We||i instanceof X&&i!==t)return i;if(i instanceof R){var a=i.body.length-1;a>=0&&(i.body[a]=i.body[a].transform(r))}else i instanceof pe?(i.body=i.body.transform(r),i.alternative&&(i.alternative=i.alternative.transform(r))):i instanceof V&&(i.body=i.body.transform(r));return i});t.transform(r)}),function(e){function n(e,n){n.assignments=0,n.direct_access=!1,n.escaped=!1,n.scope.uses_eval||n.scope.uses_with?n.fixed=!1:n.orig[0]instanceof tn||!e.exposed(n)?n.fixed=n.init:n.fixed=!1,n.recursive_refs=0,n.references=[],n.should_replace=void 0,n.single_use=void 0}function t(e,t,r){r.variables.each(function(r){n(t,r),null===r.fixed?(r.safe_ids=e.safe_ids,a(e,r,!0)):r.fixed&&(e.loop_ids[r.id]=e.in_loop,a(e,r,!0))})}function r(e,t){t.block_scope&&t.block_scope.variables.each(function(t){n(e,t)})}function i(e){e.safe_ids=Object.create(e.safe_ids)}function o(e){e.safe_ids=Object.getPrototypeOf(e.safe_ids)}function a(e,n,t){e.safe_ids[n.id]=t}function u(e,n){if(e.safe_ids[n.id]){if(null==n.fixed){var t=n.orig[0];if(t instanceof on||"arguments"==t.name)return!1;n.fixed=s(kn,t)}return!0}return n.fixed instanceof ee}function f(e,n,t){return void 0===n.fixed||(null===n.fixed&&n.safe_ids?(n.safe_ids[n.id]=!1,delete n.safe_ids,!0):!!A(e.safe_ids,n.id)&&(!!u(e,n)&&(!1!==n.fixed&&(!(null!=n.fixed&&(!t||n.references.length>n.assignments))&&w(n.orig,function(e){return!(e instanceof tn||e instanceof an||e instanceof un)})))))}function p(e,n){if(!((n=fn(n))instanceof k)){var t;if(e instanceof Ie){var r=e.elements;if("length"==n)return c(r.length,e);"number"==typeof n&&n in r&&(t=r[n])}else if(e instanceof Ne){n=""+n;for(var i=e.properties,o=i.length;--o>=0;){if(!(i[o]instanceof He))return;t||i[o].key!==n||(t=i[o].value)}}return t instanceof mn&&t.fixed_value()||t}}e(k,l);var h=new Pn(function(e){if(e instanceof Ze){var n=e.definition();n&&(e instanceof mn&&n.references.push(e),n.fixed=!1)}});function d(e,n,r){this.inlined=!1;var i=e.safe_ids;return e.safe_ids=Object.create(null),t(e,r,this),n(),e.safe_ids=i,!0}function m(e,n,r){var u,c=this;return c.inlined=!1,i(e),t(e,r,c),!c.name&&(u=e.parent())instanceof ke&&u.expression===c&&c.argnames.forEach(function(n,t){if(n.definition){var r=n.definition();c.uses_arguments||void 0!==r.fixed?r.fixed=!1:(r.fixed=function(){return u.args[t]||s(kn,u)},e.loop_ids[r.id]=e.in_loop,a(e,r,!0))}}),n(),o(e),!0}e(Z,function(e,n,r){return i(e),t(e,r,this),n(),o(e),!0}),e(K,m),e(Ue,function(e){var n=this;if(n.left instanceof ne)n.left.walk(h);else if("="==n.operator&&n.left instanceof mn){var t=n.left.definition();return f(e,t,n.right)?(t.references.push(n.left),t.assignments++,t.fixed=function(){return n.right},a(e,t,!1),n.right.walk(e),a(e,t,!0),!0):void 0}}),e(Le,function(e){if(hn(this.operator))return this.left.walk(e),i(e),this.right.walk(e),o(e),!0}),e(R,function(e,n,t){r(t,this)}),e(Xe,function(e,n){return this.inlined=!1,i(e),n(),o(e),!0}),e(ze,function(e){return this.condition.walk(e),i(e),this.consequent.walk(e),o(e),i(e),this.alternative.walk(e),o(e),!0}),e(Je,d),e(ee,d),e(I,function(e,n,t){r(t,this);var a=e.in_loop;return e.in_loop=this,i(e),this.body.walk(e),this.condition.walk(e),o(e),e.in_loop=a,!0}),e(j,function(e,n,t){r(t,this),this.init&&this.init.walk(e);var a=e.in_loop;return e.in_loop=this,this.condition&&(i(e),this.condition.walk(e),o(e)),i(e),this.body.walk(e),o(e),this.step&&(i(e),this.step.walk(e),o(e)),e.in_loop=a,!0}),e(H,function(e,n,t){r(t,this),this.init.walk(h),this.object.walk(e);var a=e.in_loop;return e.in_loop=this,i(e),this.body.walk(e),o(e),e.in_loop=a,!0}),e(Q,m),e(pe,function(e){return this.condition.walk(e),i(e),this.body.walk(e),o(e),this.alternative&&(i(e),this.alternative.walk(e),o(e)),!0}),e(z,function(e){return i(e),this.body.walk(e),o(e),!0}),e(de,function(e,n){return i(e),n(),o(e),!0}),e(ln,function(){this.definition().fixed=!1}),e(mn,function(e,n,t){var r,i=this.definition();i.references.push(this),1==i.references.length&&!i.fixed&&i.orig[0]instanceof an&&(e.loop_ids[i.id]=e.in_loop),void 0!==i.fixed&&u(e,i)&&"m"!=i.single_use?i.fixed&&((r=this.fixed_value())instanceof X&&jn(e,i)?i.recursive_refs++:r&&!t.exposed(i)&&function(e,n,t){return n.option("unused")&&!t.scope.uses_eval&&!t.scope.uses_with&&t.references.length-t.recursive_refs==1&&e.loop_ids[t.id]===e.in_loop}(e,t,i)?i.single_use=r instanceof X||r instanceof We||i.scope===this.scope&&r.is_constant_expression():i.single_use=!1,function e(n,t,r,i,o){var a=n.parent(i);if(gn(t,a)||!(o||!(a instanceof ke)||a.expression!==t||r instanceof K||r instanceof We||r instanceof Q&&(a instanceof Be||!r.contains_this())))return!0;if(a instanceof Ie)return e(n,a,a,i+1);if(a instanceof He&&t===a.value){var s=n.parent(i+1);return e(n,s,s,i+2)}return a instanceof Te&&a.expression===t?!o&&e(n,a,p(r,a.property),i+1):void 0}(e,this,r,0,function(e){return!!e&&(e.is_constant()||e instanceof X||e instanceof Dn)}(r))&&(i.single_use?i.single_use="m":i.fixed=!1)):i.fixed=!1,function e(n,t,r,i,o,a,s){var u=n.parent(a);if(o){if(o.is_constant())return;if(o instanceof Xe)return}if(u instanceof Ue&&"="==u.operator&&i===u.right||u instanceof ke&&i!==u.expression||u instanceof ae&&i===u.value&&i.scope!==t.scope||u instanceof xe&&i===u.value||u instanceof $n&&i===u.value&&i.scope!==t.scope)return!(s>1)||o&&o.is_constant_expression(r)||(s=1),void((!t.escaped||t.escaped>s)&&(t.escaped=s));if(u instanceof Ie||u instanceof Rn||u instanceof Le&&hn(u.operator)||u instanceof ze&&i!==u.condition||u instanceof J||u instanceof Se&&i===u.tail_node())e(n,t,r,u,u,a+1,s);else if(u instanceof He&&i===u.value){var c=n.parent(a+1);e(n,t,r,c,c,a+2,s)}else if(u instanceof Te&&i===u.expression&&(e(n,t,r,u,o=p(o,u.property),a+1,s+1),o))return;0==a&&(t.direct_access=!0)}(e,i,this.scope,this,r,0,1)}),e(W,function(e,r,i){this.globals.each(function(e){n(i,e)}),t(e,i,this)}),e(ge,function(e,n,t){return r(t,this),i(e),M(this,e),o(e),this.bcatch&&(i(e),this.bcatch.walk(e),o(e)),this.bfinally&&this.bfinally.walk(e),!0}),e(xe,function(e,n){var t=this;if(t.name instanceof ne)t.name.walk(h);else{var r=t.name.definition();if(f(e,r,t.value))return t.value&&(r.fixed=function(){return t.value},e.loop_ids[r.id]=e.in_loop,a(e,r,!1),n()),a(e,r,!0),!0;t.value&&(r.fixed=!1)}}),e(N,function(e,n,t){r(t,this);var a=e.in_loop;return e.in_loop=this,i(e),this.condition.walk(e),this.body.walk(e),o(e),e.in_loop=a,!0})}(function(e,n){e.DEFMETHOD("reduce_vars",n)}),W.DEFMETHOD("reset_opt_flags",function(e){var n=e.option("reduce_vars"),t=new Pn(function(r,i){if(r._squeezed=!1,r._optimized=!1,n)return r.reduce_vars(t,i,e)});t.safe_ids=Object.create(null),t.in_loop=null,t.loop_ids=Object.create(null),this.walk(t)}),Ze.DEFMETHOD("fixed_value",function(){var e=this.definition().fixed;return!e||e instanceof k?e:e()}),mn.DEFMETHOD("is_immutable",function(){var e=this.definition().orig;return 1==e.length&&e[0]instanceof un});var Ae=b("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");mn.DEFMETHOD("is_declared",function(e){return!this.definition().undeclared||e.option("unsafe")&&Ae(this.name)});var Ye=b("Infinity NaN undefined");function Qe(e){return e instanceof Sn||e instanceof xn||e instanceof kn}function rn(e,i){var a,c=i.find_parent(G).get_defun_scope(),l=10;do{a=!1,h(e),i.option("dead_code")&&m(e,i),i.option("if_return")&&d(e,i),i.sequences_limit>0&&(b(e,i),A(e,i)),i.option("join_vars")&&F(e),i.option("collapse_vars")&&p(e,i)}while(a&&l-- >0);function p(e,i){if(c.uses_eval||c.uses_with)return e;for(var u,l=[],p=i.self()instanceof ge,h=e.length,d=new yt(function(e,n){if(T)return e;if(e instanceof he){if(!B){if(e!==g[v])return e;v++}e.expression=e.expression.transform(d);for(var t=0,r=e.body.length;!T&&t<r;t++){var o=e.body[t];if(o instanceof _e){if(!B){if(o!==g[v])continue;v++}if(o.expression=o.expression.transform(d),F||!C)break}}return T=!0,e}if(!B){if(e!==g[v])return e;if(++v<g.length)return;return B=!0,(b=function e(n,t){var r=d.parent(t);if(r instanceof Le)return n;if(r instanceof ke)return n;if(r instanceof _e)return n;if(r instanceof ze)return n;if(r instanceof ye)return e(r,t+1);if(r instanceof ae)return n;if(r instanceof pe)return n;if(r instanceof U)return n;if(r instanceof Se)return e(r,t+1);if(r instanceof O)return e(r,t+1);if(r instanceof he)return n;if(r instanceof xe)return n;return null}(e,0))===e&&(T=!0),e}var u,l=d.parent();if(e instanceof Ue&&"="!=e.operator&&E.equivalent_to(e.left)||e instanceof Rn||e instanceof ke&&E instanceof Te&&E.equivalent_to(e.expression)||e instanceof S||e instanceof ne||e instanceof U&&!(e instanceof j)||e instanceof ge||e instanceof V||l instanceof j&&e!==l.init||(F||!C)&&e instanceof mn&&!e.is_declared(i))return T=!0,e;if($&&!(e instanceof Ke)&&E.equivalent_to(e)){if(gn(e,l))return y&&M++,e;if(a=T=!0,M++,i.info("Collapsing {name} [{file}:{line},{col}]",{name:e.print_to_string(),file:e.start.file,line:e.start.line,col:e.start.col}),D instanceof Pe)return s($e,D,D);if(D instanceof xe){if(y)return T=!1,e;var h=D.name.definition(),m=D.value;return h.references.length-h.replaced!=1||i.exposed(h)?s(Ue,D,{operator:"=",left:s(mn,D.name,D.name),right:m}):(h.replaced++,k&&Qe(m)?m.transform(i):f(l,e,m))}return D.write_only=!1,D}return(e instanceof ke||e instanceof ae||e instanceof Te&&(F||e.expression.may_throw_on_access(i))||e instanceof mn&&(A[e.name]||F&&!function(e){return 1==e.orig.length&&e.orig[0]instanceof an||e.scope.get_defun_scope()===c&&e.references.every(function(e){return e.scope.get_defun_scope()===c})}(e.definition()))||(u=function(e){return e instanceof xe?e.value&&e.name:gn(e.left,e)}(e))&&(u instanceof Te||u.name in A)||x&&(p?e.has_side_effects(i):function e(n,t){if(n instanceof Ue)return e(n.left,!0)||e(n.right);if(n instanceof ye)return!1;if(n instanceof Re)return e(n.expression,!0);if(n instanceof xe)return n.value&&e(n.value);if(t){if(n instanceof Oe)return e(n.expression,!0);if(n instanceof Me)return e(n.expression,!0)||e(n.property);if(n instanceof mn)return n.definition().scope!==c}return n.has_side_effects(i)}(e))||(F||!C)&&(l instanceof Le&&hn(l.operator)||l instanceof ze||l instanceof pe))&&(b=e,e instanceof G&&(T=!0)),e instanceof G?e:void 0},function(e){T||b!==e||(T=!0)}),m=new yt(function(e){if(T)return e;if(!B){if(e!==g[v])return e;if(++v<g.length)return;return B=!0,e}return e instanceof mn&&e.name==z.name?(--M||(T=!0),gn(e,m.parent())?e:(z.replaced++,y.replaced--,D.value)):e instanceof me||e instanceof G?e:void 0});--h>=0;){0==h&&i.option("unused")&&N();var g=[];for(Y(e[h]);l.length>0;){var v=0,D=(g=l.pop())[g.length-1],y=null,b=null,E=W(D);if(E&&!t(E)&&!E.has_side_effects(i)){var A=Z(D);E instanceof mn&&(A[E.name]=!1);var C=y;if(!C&&E instanceof mn)(z=E.definition()).references.length-z.replaced==(D instanceof xe?1:2)&&(C=!0);var F=ee(D),x=D.may_throw(i),k=D.name instanceof on,B=k,T=!1,M=0,$=!u||!B;if(!$){for(var P=i.self().argnames.lastIndexOf(D.name)+1;!T&&P<u.length;P++)u[P].transform(d);$=!0}for(var L=h;!T&&L<e.length;L++)e[L].transform(d);if(y){var z=D.name.definition();if(T&&z.references.length-z.replaced>M)M=!1;else{T=!1,v=0,B=k;for(L=h;!T&&L<e.length;L++)e[L].transform(m);y.single_use=!1}}M&&!Q(D)&&e.splice(h,1)}}}function I(e,n,t){var r=!1,i=!(e instanceof K);return n.walk(new Pn(function(n,o){if(r)return!0;if(n instanceof mn&&e.variables.has(n.name)){var a=n.definition().scope;if(a!==c)for(;a=a.parent_scope;)if(a===c)return!0;return r=!0}if((t||i)&&n instanceof Dn)return r=!0;if(n instanceof G&&!(n instanceof K)){var s=i;return i=!1,o(),i=s,!0}})),r}function N(){var e,t=i.self();if(n(t)&&!t.name&&!t.uses_arguments&&!t.uses_eval&&(e=i.parent())instanceof ke&&e.expression===t&&w(e.args,function(e){return!(e instanceof J)})){var r=i.has_directive("use strict");r&&!o(r,t.body)&&(r=!1);var a=t.argnames.length;u=e.args.slice(a);for(var c=Object.create(null),f=a;--f>=0;){var p=t.argnames[f],h=e.args[f];if(u.unshift(s(xe,p,{name:p,value:h})),!(p.name in c))if(c[p.name]=!0,p instanceof J){var d=e.args.slice(f);w(d,function(e){return!I(t,e,r)})&&l.unshift([s(xe,p,{name:p.expression,value:s(Ie,e,{elements:d})})])}else h?I(t,h,r)&&(h=null):h=s(kn,p).transform(i),h&&l.unshift([s(xe,p,{name:p,value:h})])}}}function Y(e){g.push(e),e instanceof Ue?(e.left.has_side_effects(i)||l.push(g.slice()),Y(e.right)):e instanceof Le?(Y(e.left),Y(e.right)):e instanceof ke?(Y(e.expression),e.args.forEach(Y)):e instanceof _e?Y(e.expression):e instanceof ze?(Y(e.condition),Y(e.consequent),Y(e.alternative)):!(e instanceof ye)||!i.option("unused")&&e instanceof Ee?e instanceof q?(Y(e.condition),e.body instanceof R||Y(e.body)):e instanceof ae?e.value&&Y(e.value):e instanceof j?(e.init&&Y(e.init),e.condition&&Y(e.condition),e.step&&Y(e.step),e.body instanceof R||Y(e.body)):e instanceof H?(Y(e.object),e.body instanceof R||Y(e.body)):e instanceof pe?(Y(e.condition),e.body instanceof R||Y(e.body),!e.alternative||e.alternative instanceof R||Y(e.alternative)):e instanceof Se?e.expressions.forEach(Y):e instanceof O?Y(e.body):e instanceof he?(Y(e.expression),e.body.forEach(Y)):e instanceof Re?"++"!=e.operator&&"--"!=e.operator||l.push(g.slice()):e instanceof xe&&e.value&&(l.push(g.slice()),Y(e.value)):e.definitions.forEach(Y),g.pop()}function W(e){if(!(e instanceof xe&&e.name instanceof Ke)){var n=e[e instanceof Ue?"left":"expression"];return!r(n,tn)&&n}var t=e.name.definition();if(o(e.name,t.orig)){var a=t.orig.length-t.eliminated,u=t.references.length-t.replaced;return a>1&&!(e.name instanceof on)||(u>1?function(e){var n=e.value;if(n instanceof mn&&"arguments"!=n.name){var t=n.definition();if(!t.undeclared)return y=t}}(e):!i.exposed(t))?s(mn,e.name,e.name):void 0}}function X(e){return e[e instanceof Ue?"right":"value"]}function Z(e){var n=Object.create(null);if(e instanceof Re)return n;var t=new Pn(function(e,r){for(var i=e;i instanceof Te;)i=i.expression;(i instanceof mn||i instanceof Dn)&&(n[i.name]=n[i.name]||gn(e,t.parent()))});return X(e).walk(t),n}function Q(n){if(n.name instanceof on){var t=i.parent(),r=i.self().argnames,o=r.indexOf(n.name);if(o<0)t.args.length=Math.min(t.args.length,r.length-1);else{var a=t.args;a[o]&&(a[o]=s(En,a[o],{value:0}))}return!0}var u=!1;return e[h].transform(new yt(function(e,t,r){return u?e:e===n||e.body===n?(u=!0,e instanceof xe?(e.value=null,e):r?_.skip:null):void 0},function(e){if(e instanceof Se)switch(e.expressions.length){case 0:return null;case 1:return e.expressions[0]}}))}function ee(e){return!(e instanceof Re)&&X(e).has_side_effects(i)}}function h(e){for(var n=[],t=0;t<e.length;){var r=e[t];r instanceof $&&w(r.body,x)?(a=!0,h(r.body),[].splice.apply(e,[t,1].concat(r.body)),t+=r.body.length):r instanceof P?(a=!0,e.splice(t,1)):r instanceof T?n.indexOf(r.value)<0?(t++,n.push(r.value)):(a=!0,e.splice(t,1)):t++}}function d(e,n){for(var t=n.self(),r=function(e){for(var n=0,t=e.length;--t>=0;){var r=e[t];if(r instanceof pe&&r.body instanceof se&&++n>1)return!0}return!1}(e),i=t instanceof X,o=e.length;--o>=0;){var u=e[o],c=b(o),f=e[c];if(i&&!f&&u instanceof se){if(!u.value){a=!0,e.splice(o,1);continue}if(u.value instanceof $e&&"void"==u.value.operator){a=!0,e[o]=s(O,u,{body:u.value.expression});continue}}if(u instanceof pe){var l;if(m(l=In(u.body))){l.label&&D(l.label.thedef.references,l),a=!0,(u=u.clone()).condition=u.condition.negate(n);var p=g(u.body,l);u.body=s($,u,{body:y(u.alternative).concat(_())}),u.alternative=s($,u,{body:p}),e[o]=u.transform(n);continue}if(m(l=In(u.alternative))){l.label&&D(l.label.thedef.references,l),a=!0,(u=u.clone()).body=s($,u.body,{body:y(u.body).concat(_())});p=g(u.alternative,l);u.alternative=s($,u.alternative,{body:p}),e[o]=u.transform(n);continue}}if(u instanceof pe&&u.body instanceof se){var h=u.body.value;if(!h&&!u.alternative&&(i&&!f||f instanceof se&&!f.value)){a=!0,e[o]=s(O,u.condition,{body:u.condition});continue}if(h&&!u.alternative&&f instanceof se&&f.value){a=!0,(u=u.clone()).alternative=f,e.splice(o,1,u.transform(n)),e.splice(c,1);continue}if(h&&!u.alternative&&(!f&&i&&r||f instanceof se)){a=!0,(u=u.clone()).alternative=f||s(se,u,{value:null}),e.splice(o,1,u.transform(n)),f&&e.splice(c,1);continue}var d=e[w(o)];if(n.option("sequences")&&i&&!u.alternative&&d instanceof pe&&d.body instanceof se&&b(c)==e.length&&f instanceof O){a=!0,(u=u.clone()).alternative=s($,f,{body:[f,s(se,f,{value:null})]}),e.splice(o,1,u.transform(n)),e.splice(c,1);continue}}}function m(r){if(!r)return!1;for(var a=o+1,s=e.length;a<s;a++){var u=e[a];if(u instanceof Ee||u instanceof we)return!1}var c=r instanceof ce?n.loopcontrol_target(r):null;return r instanceof se&&i&&function(e){return!e||e instanceof $e&&"void"==e.operator}(r.value)||r instanceof le&&t===L(c)||r instanceof fe&&c instanceof $&&t===c}function _(){var n=e.slice(o+1);return e.length=o+1,n.filter(function(n){return!(n instanceof ee)||(e.push(n),!1)})}function g(e,n){var t=y(e).slice(0,-1);return n.value&&t.push(s(O,n.value,{body:n.value.expression})),t}function b(n){for(var t=n+1,r=e.length;t<r;t++){var i=e[t];if(!(i instanceof be&&v(i)))break}return t}function w(n){for(var t=n;--t>=0;){var r=e[t];if(!(r instanceof be&&v(r)))break}return t}}function m(e,n){for(var t,r=n.self(),i=0,o=0,s=e.length;i<s;i++){var u=e[i];if(u instanceof ce){var c=n.loopcontrol_target(u);u instanceof fe&&!(c instanceof U)&&L(c)===r||u instanceof le&&L(c)===r?u.label&&D(u.label.thedef.references,u):e[o++]=u}else e[o++]=u;if(In(u)){t=e.slice(i+1);break}}e.length=o,a=o!=s,t&&t.forEach(function(t){cn(n,t,e)})}function v(e){return w(e.definitions,function(e){return!e.value})}function b(e,n){if(!(e.length<2)){for(var t=[],r=0,i=0,o=e.length;i<o;i++){var c=e[i];if(c instanceof O){t.length>=n.sequences_limit&&l();var f=c.body;t.length>0&&(f=f.drop_side_effect_free(n)),f&&g(t,f)}else c instanceof ye&&v(c)||c instanceof ee?e[r++]=c:(l(),e[r++]=c)}l(),e.length=r,r!=o&&(a=!0)}function l(){if(t.length){var n=u(t[0],t);e[r++]=s(O,n,{body:n}),t=[]}}}function E(e,n){if(!(e instanceof $))return e;for(var t=null,r=0,i=e.body.length;r<i;r++){var o=e.body[r];if(o instanceof be&&v(o))n.push(o);else{if(t)return!1;t=o}}return t}function A(e,n){function t(e){i--,a=!0;var t=r.body;return u(t,[t,e]).transform(n)}for(var r,i=0,o=0;o<e.length;o++){var c=e[o];if(r)if(c instanceof ae)c.value=t(c.value||s(kn,c).transform(n));else if(c instanceof j){if(!(c.init instanceof ye)){var f=!1;r.body.walk(new Pn(function(e){return!!(f||e instanceof G)||(e instanceof Le&&"in"==e.operator?(f=!0,!0):void 0)})),f||(c.init?c.init=t(c.init):(c.init=r.body,i--,a=!0))}}else c instanceof H?c.init instanceof Ee||c.init instanceof we||(c.object=t(c.object)):c instanceof pe?c.condition=t(c.condition):c instanceof he?c.expression=t(c.expression):c instanceof V&&(c.expression=t(c.expression));if(n.option("conditionals")&&c instanceof pe){var l=[],p=E(c.body,l),h=E(c.alternative,l);if(!1!==p&&!1!==h&&l.length>0){var d=l.length;l.push(s(pe,c,{condition:c.condition,body:p||s(P,c.body),alternative:h})),l.unshift(i,1),[].splice.apply(e,l),o+=d,i+=d+1,r=null,a=!0;continue}}e[i++]=c,r=c instanceof O?c:null}e.length=i}function C(e,n){if(e instanceof ye){var t,r=e.definitions[e.definitions.length-1];if(r.value instanceof Ne)if(n instanceof Ue?t=[n]:n instanceof Se&&(t=n.expressions.slice()),t){var o=!1;do{var a=t[0];if(!(a instanceof Ue))break;if("="!=a.operator)break;if(!(a.left instanceof Te))break;var u=a.left.expression;if(!(u instanceof mn))break;if(r.name.name!=u.name)break;if(!a.right.is_constant_expression(c))break;var f=a.left.property;if(f instanceof k&&(f=f.evaluate(i)),f instanceof k)break;if(f=""+f,i.option("ecma")<6&&i.has_directive("use strict")&&!w(r.value.properties,function(e){return e.key!=f&&e.key.name!=f}))break;r.value.properties.push(s(He,a,{key:f,value:a.right})),t.shift(),o=!0}while(t.length);return o&&t}}}function F(e){for(var n,t=0,r=-1,i=e.length;t<i;t++){var o=e[t],s=e[r];if(o instanceof ye)s&&s.TYPE==o.TYPE?(s.definitions=s.definitions.concat(o.definitions),a=!0):n&&n.TYPE==o.TYPE&&v(o)?(n.definitions=n.definitions.concat(o.definitions),a=!0):(e[++r]=o,n=o);else if(o instanceof ae)o.value=f(o.value);else if(o instanceof j){(c=C(s,o.init))?(a=!0,o.init=c.length?u(o.init,c):null,e[++r]=o):s instanceof be&&(!o.init||o.init.TYPE==s.TYPE)?(o.init&&(s.definitions=s.definitions.concat(o.init.definitions)),o.init=s,e[r]=o,a=!0):n&&o.init&&n.TYPE==o.init.TYPE&&v(o.init)?(n.definitions=n.definitions.concat(o.init.definitions),o.init=null,e[++r]=o,a=!0):e[++r]=o}else if(o instanceof H)o.object=f(o.object);else if(o instanceof pe)o.condition=f(o.condition);else if(o instanceof O){var c;if(c=C(s,o.body)){if(a=!0,!c.length)continue;o.body=u(o.body,c)}e[++r]=o}else o instanceof he?o.expression=f(o.expression):o instanceof V?o.expression=f(o.expression):e[++r]=o}function f(n){e[++r]=o;var t=C(s,n);return t?(a=!0,t.length?u(n,t):n instanceof Se?n.tail_node().left:n.left):n}e.length=r+1}}function cn(e,n,t){n instanceof ee||e.warn("Dropping unreachable code [{file}:{line},{col}]",n.start),n.walk(new Pn(function(r){return r instanceof be?(e.warn("Declarations in unreachable code! [{file}:{line},{col}]",r.start),r.remove_initializers(),t.push(r),!0):r instanceof ee&&(r===n||!e.has_directive("use strict"))?(t.push(r===n?r:s(be,r,{definitions:[s(xe,r,{name:s(en,r.name,r.name),value:null})]})),!0):r instanceof G||void 0}))}function fn(e){return e instanceof bn?e.getValue():e instanceof $e&&"void"==e.operator&&e.expression instanceof bn?void 0:e}function pn(e,n){return e.is_undefined||e instanceof kn||e instanceof $e&&"void"==e.operator&&!e.expression.has_side_effects(n)}!function(e){function n(e){return/strict/.test(e.option("pure_getters"))}k.DEFMETHOD("may_throw_on_access",function(e){return!e.option("pure_getters")||this._dot_throw(e)}),e(k,n),e(Fn,h),e(kn,h),e(bn,p),e(Ie,p),e(Ne,function(e){if(!n(e))return!1;for(var t=this.properties.length;--t>=0;)if(this.properties[t]._dot_throw(e))return!0;return!1}),e(je,p),e(Ve,h),e(J,function(e){return this.expression._dot_throw(e)}),e(Q,p),e(K,p),e(Pe,p),e($e,function(){return"void"==this.operator}),e(Le,function(e){return("&&"==this.operator||"||"==this.operator)&&(this.left._dot_throw(e)||this.right._dot_throw(e))}),e(Ue,function(e){return"="==this.operator&&this.right._dot_throw(e)}),e(ze,function(e){return this.consequent._dot_throw(e)||this.alternative._dot_throw(e)}),e(Oe,function(e){return!!n(e)&&!(this.expression instanceof Q&&"prototype"==this.property)}),e(Se,function(e){return this.tail_node()._dot_throw(e)}),e(mn,function(e){if(this.is_undefined)return!0;if(!n(e))return!1;if(De(this)&&this.is_declared(e))return!1;if(this.is_immutable())return!1;var t=this.fixed_value();return!t||t._dot_throw(e)})}(function(e,n){e.DEFMETHOD("_dot_throw",n)}),function(e){var n=["!","delete"],t=["in","instanceof","==","!=","===","!==","<","<=",">=",">"];e(k,p),e($e,function(){return o(this.operator,n)}),e(Le,function(){return o(this.operator,t)||hn(this.operator)&&this.left.is_boolean()&&this.right.is_boolean()}),e(ze,function(){return this.consequent.is_boolean()&&this.alternative.is_boolean()}),e(Ue,function(){return"="==this.operator&&this.right.is_boolean()}),e(Se,function(){return this.tail_node().is_boolean()}),e(Mn,h),e(On,h)}(function(e,n){e.DEFMETHOD("is_boolean",n)}),function(e){e(k,p),e(En,h);var n=b("+ - ~ ++ --");e(Re,function(){return n(this.operator)});var t=b("- * / % & | ^ << >> >>>");e(Le,function(e){return t(this.operator)||"+"==this.operator&&this.left.is_number(e)&&this.right.is_number(e)}),e(Ue,function(e){return t(this.operator.slice(0,-1))||"="==this.operator&&this.right.is_number(e)}),e(Se,function(e){return this.tail_node().is_number(e)}),e(ze,function(e){return this.consequent.is_number(e)&&this.alternative.is_number(e)})}(function(e,n){e.DEFMETHOD("is_number",n)}),function(e){e(k,p),e(wn,h),e(re,function(){return 1===this.segments.length}),e($e,function(){return"typeof"==this.operator}),e(Le,function(e){return"+"==this.operator&&(this.left.is_string(e)||this.right.is_string(e))}),e(Ue,function(e){return("="==this.operator||"+="==this.operator)&&this.right.is_string(e)}),e(Se,function(e){return this.tail_node().is_string(e)}),e(ze,function(e){return this.consequent.is_string(e)&&this.alternative.is_string(e)})}(function(e,n){e.DEFMETHOD("is_string",n)});var hn=b("&& ||"),dn=b("delete ++ --");function gn(e,n){return n instanceof Re&&dn(n.operator)?n.expression:n instanceof Ue&&n.left===e?e:void 0}function vn(e,n){return e.print_to_string().length>n.print_to_string().length?n:e}function yn(e,n,t){return(C(e)?function(e,n){return vn(s(O,e,{body:e}),s(O,n,{body:n})).body}:vn)(n,t)}function Cn(e){for(var n in e)e[n]=b(e[n])}!function(e){k.DEFMETHOD("resolve_defines",function(e){if(e.option("global_defs")){var n=this._find_defs(e,"");if(n){var t,r=this,i=0;do{t=r,r=e.parent(i++)}while(r instanceof Te&&r.expression===t);if(!gn(t,r))return n;e.warn("global_defs "+this.print_to_string()+" redefined [{file}:{line},{col}]",this.start)}}}),e(k,l),e(Oe,function(e,n){return this.expression._find_defs(e,"."+this.property+n)}),e(mn,function(e,n){if(this.global()){var t,r=e.option("global_defs");if(r&&A(r,t=this.name+n)){var i=function e(n,t){if(n instanceof k)return s(n.CTOR,t,n);if(Array.isArray(n))return s(Ie,t,{elements:n.map(function(n){return e(n,t)})});if(n&&"object"==typeof n){var r=[];for(var i in n)A(n,i)&&r.push(s(He,t,{key:i,value:e(n[i],t)}));return s(Ne,t,{properties:r})}return c(n,t)}(r[t],this),o=e.find_parent(W);return i.walk(new Pn(function(e){e instanceof mn&&(e.scope=o,e.thedef=o.def_global(e))})),i}}})}(function(e,n){e.DEFMETHOD("_find_defs",n)});var Ln=["constructor","toString","valueOf"],zn={Array:["indexOf","join","lastIndexOf","slice"].concat(Ln),Boolean:Ln,Number:["toExponential","toFixed","toPrecision"].concat(Ln),Object:Ln,RegExp:["test"].concat(Ln),String:["charAt","charCodeAt","concat","indexOf","italics","lastIndexOf","match","replace","search","slice","split","substr","substring","trim"].concat(Ln)};Cn(zn);var Un={Array:["isArray"],Math:["abs","acos","asin","atan","ceil","cos","exp","floor","log","round","sin","sqrt","tan","atan2","pow","max","min"],Number:["isFinite","isNaN"],Object:["create","getOwnPropertyDescriptor","getOwnPropertyNames","getPrototypeOf","isExtensible","isFrozen","isSealed","keys"],String:["fromCharCode"]};Cn(Un),function(e){k.DEFMETHOD("evaluate",function(e){if(!e.option("evaluate"))return this;var n=this._eval(e,1);return!n||n instanceof RegExp||"object"!=typeof n?n:this});var n=b("! ~ - + void");k.DEFMETHOD("is_constant",function(){return this instanceof bn?!(this instanceof An):this instanceof $e&&this.expression instanceof bn&&n(this.operator)}),e(B,function(){throw new Error(v("Cannot evaluate a statement [{file}:{line},{col}]",this.start))}),e(X,d),e(We,d),e(k,d),e(bn,function(){return this.getValue()}),e(re,function(){return 1!==this.segments.length?this:this.segments[0].value}),e(Ie,function(e,n){if(e.option("unsafe")){for(var t=[],r=0,i=this.elements.length;r<i;r++){var o=this.elements[r];if(o instanceof Q)t.push(o);else{var a=o._eval(e,n);if(o===a)return this;t.push(a)}}return t}return this}),e(Ne,function(e,n){if(e.option("unsafe")){for(var t={},r=0,i=this.properties.length;r<i;r++){var o=this.properties[r];if(o instanceof J)return this;var a=o.key;if(a instanceof Ze)a=a.name;else if(a instanceof k&&(a=a._eval(e,n))===o.key)return this;if("function"==typeof Object.prototype[a])return this;if(!(o.value instanceof Q)&&(t[a]=o.value._eval(e,n),t[a]===o.value))return this}return t}return this}),e($e,function(e,n){var t=this.expression;if(e.option("typeofs")&&"typeof"==this.operator&&(t instanceof X||t instanceof mn&&t.fixed_value()instanceof X))return"function";if((t=t._eval(e,n))===this.expression)return this;switch(this.operator){case"!":return!t;case"typeof":return t instanceof RegExp?this:typeof t;case"void":return;case"~":return~t;case"-":return-t;case"+":return+t}return this}),e(Le,function(e,n){var t=this.left._eval(e,n);if(t===this.left)return this;var r,i=this.right._eval(e,n);if(i===this.right)return this;switch(this.operator){case"&&":r=t&&i;break;case"||":r=t||i;break;case"|":r=t|i;break;case"&":r=t&i;break;case"^":r=t^i;break;case"+":r=t+i;break;case"*":r=t*i;break;case"**":r=Math.pow(t,i);break;case"/":r=t/i;break;case"%":r=t%i;break;case"-":r=t-i;break;case"<<":r=t<<i;break;case">>":r=t>>i;break;case">>>":r=t>>>i;break;case"==":r=t==i;break;case"===":r=t===i;break;case"!=":r=t!=i;break;case"!==":r=t!==i;break;case"<":r=t<i;break;case"<=":r=t<=i;break;case">":r=t>i;break;case">=":r=t>=i;break;default:return this}return isNaN(r)&&e.find_parent(V)?this:r}),e(ze,function(e,n){var t=this.condition._eval(e,n);if(t===this.condition)return this;var r=t?this.consequent:this.alternative,i=r._eval(e,n);return i===r?this:i}),e(mn,function(e,n){var t,r=this.fixed_value();if(!r)return this;if(A(r,"_eval"))t=r._eval();else{if(this._eval=d,t=r._eval(e,n),delete this._eval,t===r)return this;r._eval=function(){return t}}if(t&&"object"==typeof t){var i=this.definition().escaped;if(i&&n>i)return this}return t});var t={Array:Array,Math:Math,Number:Number,Object:Object,String:String},r={Math:["E","LN10","LN2","LOG2E","LOG10E","PI","SQRT1_2","SQRT2"],Number:["MAX_VALUE","MIN_VALUE","NaN","NEGATIVE_INFINITY","POSITIVE_INFINITY"]};Cn(r),e(Te,function(e,n){if(e.option("unsafe")){var i=this.property;if(i instanceof k&&(i=i._eval(e,n))===this.property)return this;var o,a=this.expression;if(De(a)){if(!(r[a.name]||p)(i))return this;o=t[a.name]}else if(!(o=a._eval(e,n+1))||o===a||!A(o,i))return this;return o[i]}return this}),e(ke,function(e,n){var r=this.expression;if(e.option("unsafe")&&r instanceof Te){var i,o=r.property;if(o instanceof k&&(o=o._eval(e,n))===r.property)return this;var a=r.expression;if(De(a)){if(!(Un[a.name]||p)(o))return this;i=t[a.name]}else if((i=a._eval(e,n+1))===a||!(i&&zn[i.constructor.name]||p)(o))return this;for(var s=[],u=0,c=this.args.length;u<c;u++){var f=this.args[u],l=f._eval(e,n);if(f===l)return this;s.push(l)}try{return i[o].apply(i,s)}catch(n){e.warn("Error evaluating {code} [{file}:{line},{col}]",{code:this.print_to_string(),file:this.start.file,line:this.start.line,col:this.start.col})}}return this}),e(Be,d)}(function(e,n){e.DEFMETHOD("_eval",n)}),function(e){function n(e){return s($e,e,{operator:"!",expression:e})}function t(e,t,r){var i=n(e);if(r){var o=s(O,t,{body:t});return vn(i,o)===o?t:i}return vn(i,t)}e(k,function(){return n(this)}),e(B,function(){throw new Error("Cannot negate a statement")}),e(Q,function(){return n(this)}),e(K,function(){return n(this)}),e($e,function(){return"!"==this.operator?this.expression:n(this)}),e(Se,function(e){var n=this.expressions.slice();return n.push(n.pop().negate(e)),u(this,n)}),e(ze,function(e,n){var r=this.clone();return r.consequent=r.consequent.negate(e),r.alternative=r.alternative.negate(e),t(this,r,n)}),e(Le,function(e,r){var i=this.clone(),o=this.operator;if(e.option("unsafe_comps"))switch(o){case"<=":return i.operator=">",i;case"<":return i.operator=">=",i;case">=":return i.operator="<",i;case">":return i.operator="<=",i}switch(o){case"==":return i.operator="!=",i;case"!=":return i.operator="==",i;case"===":return i.operator="!==",i;case"!==":return i.operator="===",i;case"&&":return i.operator="||",i.left=i.left.negate(e,r),i.right=i.right.negate(e),t(this,i,r);case"||":return i.operator="&&",i.left=i.left.negate(e,r),i.right=i.right.negate(e),t(this,i,r)}return n(this)})}(function(e,n){e.DEFMETHOD("negate",function(e,t){return n.call(this,e,t)})});var qn=b("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");function In(e){return e&&e.aborts()}ke.DEFMETHOD("is_expr_pure",function(e){if(e.option("unsafe")){var n=this.expression;if(De(n)&&qn(n.name))return!0;if(n instanceof Oe&&De(n.expression)&&(Un[n.expression.name]||p)(n.property))return!0}return this.pure||!e.pure_funcs(this)}),k.DEFMETHOD("is_call_pure",p),Oe.DEFMETHOD("is_call_pure",function(e){if(e.option("unsafe")){var n=this.expression,t=p;return n instanceof Ie?t=zn.Array:n.is_boolean()?t=zn.Boolean:n.is_number(e)?t=zn.Number:n instanceof An?t=zn.RegExp:n.is_string(e)?t=zn.String:this.may_throw_on_access(e)||(t=zn.Object),t(this.property)}}),function(e){function n(e,n){for(var t=e.length;--t>=0;)if(e[t].has_side_effects(n))return!0;return!1}e(k,h),e(P,p),e(bn,p),e(Dn,p),e(R,function(e){return n(this.body,e)}),e(ke,function(e){return!(this.is_expr_pure(e)||this.expression.is_call_pure(e)&&!this.expression.has_side_effects(e))||n(this.args,e)}),e(he,function(e){return this.expression.has_side_effects(e)||n(this.body,e)}),e(_e,function(e){return this.expression.has_side_effects(e)||n(this.body,e)}),e(ge,function(e){return n(this.body,e)||this.bcatch&&this.bcatch.has_side_effects(e)||this.bfinally&&this.bfinally.has_side_effects(e)}),e(pe,function(e){return this.condition.has_side_effects(e)||this.body&&this.body.has_side_effects(e)||this.alternative&&this.alternative.has_side_effects(e)}),e(z,function(e){return this.body.has_side_effects(e)}),e(O,function(e){return this.body.has_side_effects(e)}),e(X,p),e(We,p),e(Je,h),e(Le,function(e){return this.left.has_side_effects(e)||this.right.has_side_effects(e)}),e(Ue,h),e(ze,function(e){return this.condition.has_side_effects(e)||this.consequent.has_side_effects(e)||this.alternative.has_side_effects(e)}),e(Re,function(e){return dn(this.operator)||this.expression.has_side_effects(e)}),e(mn,function(e){return!this.is_declared(e)}),e(Ke,p),e(Ne,function(e){return n(this.properties,e)}),e(je,function(e){return!!(this.key instanceof He&&this.key.has_side_effects(e))||this.value.has_side_effects(e)}),e(Ie,function(e){return n(this.elements,e)}),e(Oe,function(e){return this.expression.may_throw_on_access(e)||this.expression.has_side_effects(e)}),e(Me,function(e){return this.expression.may_throw_on_access(e)||this.expression.has_side_effects(e)||this.property.has_side_effects(e)}),e(Se,function(e){return n(this.expressions,e)}),e(ye,function(e){return n(this.definitions,e)}),e(xe,function(e){return this.value}),e(ie,p),e(re,function(e){return n(this.segments,e)})}(function(e,n){e.DEFMETHOD("has_side_effects",n)}),function(e){function n(e,n){for(var t=e.length;--t>=0;)if(e[t].may_throw(n))return!0;return!1}e(k,h),e(We,p),e(bn,p),e(P,p),e(X,p),e(Ke,p),e(Dn,p),e(Ie,function(e){return n(this.elements,e)}),e(Ue,function(e){return"="!=this.operator&&this.left.may_throw(e)||this.right.may_throw(e)}),e(Le,function(e){return this.left.may_throw(e)||this.right.may_throw(e)}),e(R,function(e){return n(this.body,e)}),e(ke,function(e){return!!n(this.args,e)||!this.is_expr_pure(e)&&(!!this.expression.may_throw(e)||(!(this.expression instanceof X)||n(this.expression.body,e)))}),e(_e,function(e){return this.expression.may_throw(e)||n(this.body,e)}),e(ze,function(e){return this.condition.may_throw(e)||this.consequent.may_throw(e)||this.alternative.may_throw(e)}),e(ye,function(e){return n(this.definitions,e)}),e(Oe,function(e){return this.expression.may_throw_on_access(e)||this.expression.may_throw(e)}),e(pe,function(e){return this.condition.may_throw(e)||this.body&&this.body.may_throw(e)||this.alternative&&this.alternative.may_throw(e)}),e(z,function(e){return this.body.may_throw(e)}),e(Ne,function(e){return n(this.properties,e)}),e(je,function(e){return this.value.may_throw(e)}),e(Se,function(e){return n(this.expressions,e)}),e(O,function(e){return this.body.may_throw(e)}),e(Me,function(e){return this.expression.may_throw_on_access(e)||this.expression.may_throw(e)||this.property.may_throw(e)}),e(he,function(e){return this.expression.may_throw(e)||n(this.body,e)}),e(mn,function(e){return!this.is_declared(e)}),e(ge,function(e){return n(this.body,e)||this.bcatch&&this.bcatch.may_throw(e)||this.bfinally&&this.bfinally.may_throw(e)}),e(Re,function(e){return!("typeof"==this.operator&&this.expression instanceof mn)&&this.expression.may_throw(e)}),e(xe,function(e){return!!this.value&&this.value.may_throw(e)})}(function(e,n){e.DEFMETHOD("may_throw",n)}),function(e){function n(e){for(var n=e.length;--n>=0;)if(!e[n].is_constant_expression())return!1;return!0}function t(e){var n=this,t=!0;return n.walk(new Pn(function(r){if(!t)return!0;if(r instanceof mn){if(n.inlined)return t=!1,!0;var i=r.definition();if(o(i,n.enclosed)&&!n.variables.has(i.name)){if(e){var a=e.find_variable(r);if(i.undeclared?!a:a===i)return t="f",!0}t=!1}return!0}return r instanceof Dn&&n instanceof K?(t=!1,!0):void 0})),t}e(k,p),e(bn,h),e(We,t),e(X,t),e(Re,function(){return this.expression.is_constant_expression()}),e(Le,function(){return this.left.is_constant_expression()&&this.right.is_constant_expression()}),e(Ie,function(){return n(this.elements)}),e(Ne,function(){return n(this.properties)}),e(je,function(){return!(this.key instanceof k)&&this.value.is_constant_expression()})}(function(e,n){e.DEFMETHOD("is_constant_expression",n)}),function(e){function n(){var e=this.body.length;return e>0&&In(this.body[e-1])}e(B,m),e(oe,d),e(Ce,function(){return null}),e($,n),e(de,n),e(pe,function(){return this.alternative&&In(this.body)&&In(this.alternative)&&this})}(function(e,n){e.DEFMETHOD("aborts",n)}),e(T,function(e,n){return n.has_directive(e.value)!==e?s(P,e):e}),e(S,function(e,n){return n.option("drop_debugger")?s(P,e):e}),e(z,function(e,n){return e.body instanceof fe&&n.loopcontrol_target(e.body)===e.body?s(P,e):0==e.label.references.length?e.body:e}),e(R,function(e,n){return rn(e.body,n),e}),e($,function(e,n){switch(rn(e.body,n),e.body.length){case 1:if(!n.has_directive("use strict")&&n.parent()instanceof pe||x(e.body[0]))return e.body[0];break;case 0:return s(P,e)}return e}),G.DEFMETHOD("drop_unused",function(e){if(e.option("unused")&&!e.has_directive("use asm")){var n=this;if(!n.uses_eval&&!n.uses_with){var t=!(n instanceof W)||e.toplevel.funcs,i=!(n instanceof W)||e.toplevel.vars,o=/keep_assign/.test(e.option("unused"))?p:function(e){return e instanceof Ue&&(e.write_only||"="==e.operator)?e.left:e instanceof Re&&e.write_only?e.expression:void 0},a=[],c=Object.create(null),l=Object.create(null);n instanceof W&&e.top_retain&&n.variables.each(function(n){!e.top_retain(n)||n.id in c||(c[n.id]=!0,a.push(n))});var h=new E,d=new E,m=null,g=this,v=new Pn(function(r,o){if(r!==n){if(r instanceof ee||r instanceof Je){var s=r.name.definition();return((u=v.parent()instanceof Fe)||!t&&g===n)&&(!s.global||s.id in c||(c[s.id]=!0,a.push(s))),d.add(s.id,r),!0}if(r instanceof on&&g===n&&h.add(r.definition().id,r),r instanceof ye&&g===n){var u=v.parent()instanceof Fe;return r.definitions.forEach(function(n){if(n.name instanceof en&&h.add(n.name.definition().id,n),!u&&i||n.name.walk(new Pn(function(e){if(e instanceof Ke){var n=e.definition();!u&&!n.global||n.id in c||(c[n.id]=!0,a.push(n))}})),n.value){if(n.name instanceof ne){var t=m;m=n.value,n.walk(v),m=t}else{var r=n.name.definition();d.add(r.id,n.value),n.name.fixed_value()===n.value&&(l[r.id]=n)}n.value.has_side_effects(e)&&n.value.walk(v)}}),!0}return r.destructuring&&m&&d.add(r.name,m),C(r,o)}});n.walk(v),v=new Pn(C);for(var y=0;y<a.length;y++){var b=d.get(a[y].id);b&&b.forEach(function(e){e.walk(v)})}var A=new yt(function(r,a,p){var d=A.parent();if(i&&(C=o(r))instanceof mn){var m=(v=C.definition()).id in c;if(r instanceof Ue){if(!m||v.id in l&&l[v.id]!==r)return f(d,r,r.right.transform(A))}else if(!m)return s(En,r,{value:0})}if(g===n){var v;if(r.name&&(!e.option("keep_classnames")&&r instanceof Xe||!e.option("keep_fnames")&&r instanceof Q))(v=r.name.definition()).id in c&&!(v.orig.length>1)||(r.name=null);if(r instanceof X&&!(r instanceof Z))for(var y=!e.option("keep_fargs"),b=r.argnames,E=b.length;--E>=0;){var C;(C=b[E])instanceof J&&(C=C.expression),C instanceof qe&&(C=C.left),C instanceof ne||C.definition().id in c?y=!1:(C.__unused=!0,y&&(b.pop(),e[C.unreferenced()?"warn":"info"]("Dropping unused function argument {name} [{file}:{line},{col}]",U(C))))}if((r instanceof ee||r instanceof Je)&&r!==n)if(!((v=r.name.definition()).id in c||!t&&v.global))return e[r.name.unreferenced()?"warn":"info"]("Dropping unused function {name} [{file}:{line},{col}]",U(r.name)),v.eliminated++,s(P,r);if(r instanceof ye&&!(d instanceof H&&d.init===r)){var k=!(d instanceof W||r instanceof be),B=[],S=[],T=[],M=[];switch(r.definitions.forEach(function(n){if(n.value&&(n.value=n.value.transform(A)),n.name instanceof ne)return T.push(n);var t=n.name.definition();if(k&&t.global)return T.push(n);if(!i&&!k||t.id in c){if(n.value&&t.id in l&&l[t.id]!==n&&(n.value=n.value.drop_side_effect_free(e)),n.name instanceof en){var o=h.get(t.id);if(o.length>1&&(!n.value||t.orig.indexOf(n.name)>t.eliminated)){if(e.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]",U(n.name)),n.value){var a=s(mn,n.name,n.name);t.references.push(a);var f=s(Ue,n,{operator:"=",left:a,right:n.value});l[t.id]===n&&(l[t.id]=f),M.push(f.transform(A))}return D(o,n),void t.eliminated++}}n.value?(M.length>0&&(T.length>0?(M.push(n.value),n.value=u(n.value,M)):B.push(s(O,r,{body:u(r,M)})),M=[]),T.push(n)):S.push(n)}else if(t.orig[0]instanceof ln){(p=n.value&&n.value.drop_side_effect_free(e))&&M.push(p),n.value=null,S.push(n)}else{var p;(p=n.value&&n.value.drop_side_effect_free(e))?(e.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]",U(n.name)),M.push(p)):e[n.name.unreferenced()?"warn":"info"]("Dropping unused variable {name} [{file}:{line},{col}]",U(n.name)),t.eliminated++}}),(S.length>0||T.length>0)&&(r.definitions=S.concat(T),B.push(r)),M.length>0&&B.push(s(O,r,{body:u(r,M)})),B.length){case 0:return p?_.skip:s(P,r);case 1:return B[0];default:return p?_.splice(B):s($,r,{body:B})}}if(r instanceof j)return a(r,this),r.init instanceof $&&(R=r.init,r.init=R.body.pop(),R.body.push(r)),r.init instanceof O?r.init=r.init.body:F(r.init)&&(r.init=null),R?p?_.splice(R.body):R:r;if(r instanceof z&&r.body instanceof j){if(a(r,this),r.body instanceof $){var R=r.body;return r.body=R.body.pop(),R.body.push(r),p?_.splice(R.body):R}return r}if(r instanceof $)return a(r,this),p&&w(r.body,x)?_.splice(r.body):r;if(r instanceof G){var L=g;return g=r,a(r,this),g=L,r}}function U(e){return{name:e.name,file:e.start.file,line:e.start.line,col:e.start.col}}});n.transform(A)}}function C(e,t){var i,s=o(e);if(s instanceof mn&&!r(e.left,nn)&&n.variables.get(s.name)===(i=s.definition()))return e instanceof Ue&&(e.right.walk(v),e.left.fixed_value()===e.right&&(l[i.id]=e)),!0;if(e instanceof mn)return(i=e.definition()).id in c||(c[i.id]=!0,a.push(i),(i=i.redefined())&&(c[i.id]=!0,a.push(i))),!0;if(e instanceof G){var u=g;return g=e,t(),g=u,!0}}}),G.DEFMETHOD("hoist_declarations",function(e){var n=this;if(e.has_directive("use asm"))return n;if(!Array.isArray(n.body))return n;var t=e.option("hoist_funs"),r=e.option("hoist_vars");if(t||r){var i=[],o=[],c=new E,f=0,l=0;n.walk(new Pn(function(e){return e instanceof G&&e!==n||(e instanceof be?(++l,!0):void 0)})),r=r&&l>1;var p=new yt(function(a){if(a!==n){if(a instanceof T)return i.push(a),s(P,a);if(t&&a instanceof ee&&!(p.parent()instanceof Fe)&&p.parent()===n)return o.push(a),s(P,a);if(r&&a instanceof be){a.definitions.forEach(function(e){e.name instanceof ne||(c.set(e.name.name,e),++f)});var u=a.to_assignments(e),l=p.parent();if(l instanceof H&&l.init===a){if(null==u){var h=a.definitions[0].name;return s(mn,h,h)}return u}return l instanceof j&&l.init===a?u:u?s(O,a,{body:u}):s(P,a)}if(a instanceof G)return a}});if(n=n.transform(p),f>0){var h=[];if(c.each(function(e,t){n instanceof X&&a(function(n){return n.name==e.name.name},n.args_as_names())?c.del(t):((e=e.clone()).value=null,h.push(e),c.set(t,e))}),h.length>0){for(var d=0;d<n.body.length;){if(n.body[d]instanceof O){var m,_,g=n.body[d].body;if(g instanceof Ue&&"="==g.operator&&(m=g.left)instanceof Ze&&c.has(m.name)){if((v=c.get(m.name)).value)break;v.value=g.right,D(h,v),h.push(v),n.body.splice(d,1);continue}if(g instanceof Se&&(_=g.expressions[0])instanceof Ue&&"="==_.operator&&(m=_.left)instanceof Ze&&c.has(m.name)){var v;if((v=c.get(m.name)).value)break;v.value=_.right,D(h,v),h.push(v),n.body[d].body=u(g,g.expressions.slice(1));continue}}if(n.body[d]instanceof P)n.body.splice(d,1);else{if(!(n.body[d]instanceof $))break;var y=[d,1].concat(n.body[d].body);n.body.splice.apply(n.body,y)}}h=s(be,n,{definitions:h}),o.push(h)}}n.body=i.concat(o,n.body)}return n}),G.DEFMETHOD("var_names",function(){var e=this._var_names;return e||(this._var_names=e=Object.create(null),this.enclosed.forEach(function(n){e[n.name]=!0}),this.variables.each(function(n,t){e[t]=!0})),e}),G.DEFMETHOD("make_var_name",function(e){for(var n=this.var_names(),t=e=e.replace(/[^a-z_$]+/gi,"_"),r=0;n[t];r++)t=e+"$"+r;return n[t]=!0,t}),G.DEFMETHOD("hoist_properties",function(e){var n=this;if(!e.option("hoist_props")||e.has_directive("use asm"))return n;var t=n instanceof W&&e.top_retain||p,r=Object.create(null),i=new yt(function(o,a){if(o instanceof ye&&i.parent()instanceof Fe)return o;var u;if(o instanceof xe&&((l=o.name).scope===n&&1!=(p=l.definition()).escaped&&!p.single_use&&!p.direct_access&&!e.exposed(p)&&!t(p)&&(u=l.fixed_value())===o.value&&u instanceof Ne)){a(o,this);var c=new E,f=[];return u.properties.forEach(function(e){f.push(s(xe,o,{name:function(e){var t=s(l.CTOR,l,{name:n.make_var_name(l.name+"_"+e),scope:n}),r=n.def_variable(t);return c.set(e,r),n.enclosed.push(r),t}(e.key),value:e.value}))}),r[p.id]=c,_.splice(f)}if(o instanceof Te&&o.expression instanceof mn&&(c=r[o.expression.definition().id])){var l,p=c.get(fn(o.property));return(l=s(mn,o,{name:p.name,scope:o.expression.scope,thedef:p})).reference({}),l}});return n.transform(i)}),function(e){function t(e,n,t){var r=e.length;if(!r)return null;for(var i=[],o=!1,a=0;a<r;a++){var s=e[a].drop_side_effect_free(n,t);o|=s!==e[a],s&&(i.push(s),t=!1)}return o?i.length?i:null:e}e(k,d),e(bn,m),e(Dn,m),e(ke,function(e,r){if(!this.is_expr_pure(e)){if(this.expression.is_call_pure(e)){var i=this.args.slice();return i.unshift(this.expression.expression),(i=t(i,e,r))&&u(this,i)}if(n(this.expression)&&(!this.expression.name||!this.expression.name.definition().references.length)){var o=this.clone();return o.expression.process_expression(!1,e),o}return this}this.pure&&e.warn("Dropping __PURE__ call [{file}:{line},{col}]",this.start);var a=t(this.args,e,r);return a&&u(this,a)}),e(Z,m),e(Q,m),e(K,m),e(Xe,m),e(Le,function(e,n){var t=this.right.drop_side_effect_free(e);if(!t)return this.left.drop_side_effect_free(e,n);if(hn(this.operator)){if(t===this.right)return this;var r=this.clone();return r.right=t,r}var i=this.left.drop_side_effect_free(e,n);return i?u(this,[i,t]):this.right.drop_side_effect_free(e,n)}),e(Ue,function(e){var n=this.left;if(n.has_side_effects(e)||e.has_directive("use strict")&&n instanceof Te&&n.expression.is_constant())return this;for(this.write_only=!0;n instanceof Te;)n=n.expression;return n.is_constant_expression(e.find_parent(G))?this.right.drop_side_effect_free(e):this}),e(ze,function(e){var n=this.consequent.drop_side_effect_free(e),t=this.alternative.drop_side_effect_free(e);if(n===this.consequent&&t===this.alternative)return this;if(!n)return t?s(Le,this,{operator:"||",left:this.condition,right:t}):this.condition.drop_side_effect_free(e);if(!t)return s(Le,this,{operator:"&&",left:this.condition,right:n});var r=this.clone();return r.consequent=n,r.alternative=t,r}),e(Re,function(e,n){if(dn(this.operator))return this.write_only=!this.expression.has_side_effects(e),this;if("typeof"==this.operator&&this.expression instanceof mn)return null;var t=this.expression.drop_side_effect_free(e,n);return n&&t&&Y(t)?t===this.expression&&"!"==this.operator?this:t.negate(e,n):t}),e(mn,function(e){return this.is_declared(e)?null:this}),e(Ne,function(e,n){var r=t(this.properties,e,n);return r&&u(this,r)}),e(je,function(e,n){return this.value.drop_side_effect_free(e,n)}),e(Ie,function(e,n){var r=t(this.elements,e,n);return r&&u(this,r)}),e(Oe,function(e,n){return this.expression.may_throw_on_access(e)?this:this.expression.drop_side_effect_free(e,n)}),e(Me,function(e,n){if(this.expression.may_throw_on_access(e))return this;var t=this.expression.drop_side_effect_free(e,n);if(!t)return this.property.drop_side_effect_free(e,n);var r=this.property.drop_side_effect_free(e);return r?u(this,[t,r]):t}),e(Se,function(e){var n=this.tail_node(),t=n.drop_side_effect_free(e);if(t===n)return this;var r=this.expressions.slice(0,-1);return t&&r.push(t),u(this,r)}),e(J,function(e,n){return this.expression.drop_side_effect_free(e,n)}),e(ie,m),e(re,function(e){var n=t(this.segments,e,C);return n&&u(this,n)})}(function(e,n){e.DEFMETHOD("drop_side_effect_free",n)}),e(O,function(e,n){if(n.option("side_effects")){var t=e.body,r=t.drop_side_effect_free(n,!0);if(!r)return n.warn("Dropping side-effect-free statement [{file}:{line},{col}]",e.start),s(P,e);if(r!==t)return s(O,e,{body:r})}return e}),e(N,function(e,n){return n.option("loops")?s(j,e,e).optimize(n):e}),e(I,function(e,n){if(!n.option("loops"))return e;var t=e.condition.tail_node().evaluate(n);if(!(t instanceof k)){if(t)return s(j,e,{body:s($,e.body,{body:[e.body,s(O,e.condition,{body:e.condition})]})}).optimize(n);var r=!1,i=new Pn(function(n){return!!(n instanceof G||r)||(n instanceof ce&&i.loopcontrol_target(n)===e?r=!0:void 0)}),o=n.parent();if((o instanceof z?o:e).walk(i),!r)return s($,e.body,{body:[e.body,s(O,e.condition,{body:e.condition})]}).optimize(n)}return e}),e(j,function(e,n){if(!n.option("loops"))return e;if(n.option("side_effects")&&e.init&&(e.init=e.init.drop_side_effect_free(n)),e.condition){var t=e.condition.evaluate(n);if(!(t instanceof k))if(t)e.condition=null;else if(!n.option("dead_code")){var r=e.condition;e.condition=c(t,e.condition),e.condition=vn(e.condition.transform(n),r)}if(n.option("dead_code")&&(t instanceof k&&(t=e.condition.tail_node().evaluate(n)),!t)){var i=[];return cn(n,e.body,i),e.init instanceof B?i.push(e.init):e.init&&i.push(s(O,e.init,{body:e.init})),i.push(s(O,e.condition,{body:e.condition})),s($,e,{body:i}).optimize(n)}}return function e(n,t){var r=n.body instanceof $?n.body.body[0]:n.body;if(t.option("dead_code")&&o(r)){var i=[];return n.init instanceof B?i.push(n.init):n.init&&i.push(s(O,n.init,{body:n.init})),n.condition&&i.push(s(O,n.condition,{body:n.condition})),cn(t,n.body,i),s($,n,{body:i})}return r instanceof pe&&(o(r.body)?(n.condition?n.condition=s(Le,n.condition,{left:n.condition,operator:"&&",right:r.condition.negate(t)}):n.condition=r.condition.negate(t),a(r.alternative)):o(r.alternative)&&(n.condition?n.condition=s(Le,n.condition,{left:n.condition,operator:"&&",right:r.condition}):n.condition=r.condition,a(r.body))),n;function o(e){return e instanceof fe&&t.loopcontrol_target(e)===t.self()}function a(r){r=y(r),n.body instanceof $?(n.body=n.body.clone(),n.body.body=r.concat(n.body.body.slice(1)),n.body=n.body.transform(t)):n.body=s($,n.body,{body:r}).transform(t),n=e(n,t)}}(e,n)}),e(pe,function(e,n){if(F(e.alternative)&&(e.alternative=null),!n.option("conditionals"))return e;var t=e.condition.evaluate(n);if(!(n.option("dead_code")||t instanceof k)){var r=e.condition;e.condition=c(t,r),e.condition=vn(e.condition.transform(n),r)}if(n.option("dead_code")){if(t instanceof k&&(t=e.condition.tail_node().evaluate(n)),!t){n.warn("Condition always false [{file}:{line},{col}]",e.condition.start);var i=[];return cn(n,e.body,i),i.push(s(O,e.condition,{body:e.condition})),e.alternative&&i.push(e.alternative),s($,e,{body:i}).optimize(n)}if(!(t instanceof k)){n.warn("Condition always true [{file}:{line},{col}]",e.condition.start);i=[];return e.alternative&&cn(n,e.alternative,i),i.push(s(O,e.condition,{body:e.condition})),i.push(e.body),s($,e,{body:i}).optimize(n)}}var o=e.condition.negate(n),a=e.condition.print_to_string().length,u=o.print_to_string().length,f=u<a;if(e.alternative&&f){f=!1,e.condition=o;var l=e.body;e.body=e.alternative||s(P,e),e.alternative=l}if(F(e.body)&&F(e.alternative))return s(O,e.condition,{body:e.condition.clone()}).optimize(n);if(e.body instanceof O&&e.alternative instanceof O)return s(O,e,{body:s(ze,e,{condition:e.condition,consequent:e.body.body,alternative:e.alternative.body})}).optimize(n);if(F(e.alternative)&&e.body instanceof O)return a===u&&!f&&e.condition instanceof Le&&"||"==e.condition.operator&&(f=!0),f?s(O,e,{body:s(Le,e,{operator:"||",left:o,right:e.body.body})}).optimize(n):s(O,e,{body:s(Le,e,{operator:"&&",left:e.condition,right:e.body.body})}).optimize(n);if(e.body instanceof P&&e.alternative instanceof O)return s(O,e,{body:s(Le,e,{operator:"||",left:e.condition,right:e.alternative.body})}).optimize(n);if(e.body instanceof ae&&e.alternative instanceof ae&&e.body.TYPE==e.alternative.TYPE)return s(e.body.CTOR,e,{value:s(ze,e,{condition:e.condition,consequent:e.body.value||s(kn,e.body),alternative:e.alternative.value||s(kn,e.alternative)}).transform(n)}).optimize(n);if(e.body instanceof pe&&!e.body.alternative&&!e.alternative&&(e=s(pe,e,{condition:s(Le,e.condition,{operator:"&&",left:e.condition,right:e.body.condition}),body:e.body.body,alternative:null})),In(e.body)&&e.alternative){var p=e.alternative;return e.alternative=null,s($,e,{body:[e,p]}).optimize(n)}if(In(e.alternative)){i=e.body;return e.body=e.alternative,e.condition=f?o:e.condition.negate(n),e.alternative=null,s($,e,{body:[e,i]}).optimize(n)}return e}),e(he,function(e,n){if(!n.option("switches"))return e;var t,r=e.expression.evaluate(n);if(!(r instanceof k)){var i=e.expression;e.expression=c(r,i),e.expression=vn(e.expression.transform(n),i)}if(!n.option("dead_code"))return e;r instanceof k&&(r=e.expression.tail_node().evaluate(n));for(var o,a,u=[],f=[],l=0,p=e.body.length;l<p&&!a;l++){if((t=e.body[l])instanceof me)o?y(t,f[f.length-1]):o=t;else if(!(r instanceof k)){if(!((v=t.expression.evaluate(n))instanceof k)&&v!==r){y(t,f[f.length-1]);continue}if(v instanceof k&&(v=t.expression.tail_node().evaluate(n)),v===r&&(a=t,o)){var h=f.indexOf(o);f.splice(h,1),y(o,f[h-1]),o=null}}if(In(t)){var d=f[f.length-1];In(d)&&d.body.length==t.body.length&&s($,d,d).equivalent_to(s($,t,t))&&(d.body=[])}f.push(t)}for(;l<p;)y(e.body[l++],f[f.length-1]);for(f.length>0&&(f[0].body=u.concat(f[0].body)),e.body=f;t=f[f.length-1];){var m=t.body[t.body.length-1];if(m instanceof fe&&n.loopcontrol_target(m)===e&&t.body.pop(),t.body.length||t instanceof _e&&(o||t.expression.has_side_effects(n)))break;f.pop()===o&&(o=null)}if(0==f.length)return s($,e,{body:u.concat(s(O,e.expression,{body:e.expression}))}).optimize(n);if(1==f.length&&(f[0]===a||f[0]===o)){var _=!1,g=new Pn(function(n){if(_||n instanceof X||n instanceof O)return!0;n instanceof fe&&g.loopcontrol_target(n)===e&&(_=!0)});if(e.walk(g),!_){var v,D=f[0].body.slice();return(v=f[0].expression)&&D.unshift(s(O,v,{body:v})),D.unshift(s(O,e.expression,{body:e.expression})),s($,e,{body:D}).optimize(n)}}return e;function y(e,t){t&&!In(t)?t.body=t.body.concat(e.body):cn(n,e,u)}}),e(ge,function(e,n){if(rn(e.body,n),e.bcatch&&e.bfinally&&w(e.bfinally.body,F)&&(e.bfinally=null),n.option("dead_code")&&w(e.body,F)){var t=[];return e.bcatch&&(cn(n,e.bcatch,t),t.forEach(function(e){e instanceof ye&&e.definitions.forEach(function(e){var n=e.name.definition().redefined();n&&(e.name=e.name.clone(),e.name.thedef=n)})})),e.bfinally&&(t=t.concat(e.bfinally.body)),s($,e,{body:t}).optimize(n)}return e}),ye.DEFMETHOD("remove_initializers",function(){var e=[];this.definitions.forEach(function(n){n.name instanceof Ke?(n.value=null,e.push(n)):n.name.walk(new Pn(function(t){t instanceof Ke&&e.push(s(xe,n,{name:t,value:null}))}))}),this.definitions=e}),ye.DEFMETHOD("to_assignments",function(e){var n=e.option("reduce_vars"),t=this.definitions.reduce(function(e,t){if(!t.value||t.name instanceof ne){if(t.value){var r=s(xe,t,{name:t.name,value:t.value}),i=s(be,t,{definitions:[r]});e.push(i)}}else{var o=s(mn,t.name,t.name);e.push(s(Ue,t,{operator:"=",left:o,right:t.value})),n&&(o.definition().fixed=!1)}return(t=t.name.definition()).eliminated++,t.replaced--,e},[]);return 0==t.length?null:u(this,t)}),e(ye,function(e,n){return 0==e.definitions.length?s(P,e):e}),e(Ce,function(e,n){return e}),e(ke,function(e,t){var r=e.expression,i=r,o=w(e.args,function(e){return!(e instanceof J)});t.option("reduce_vars")&&i instanceof mn&&(i=i.fixed_value());var a=i instanceof X;if(t.option("unused")&&o&&a&&!i.uses_arguments&&!i.uses_eval){for(var f=0,l=0,p=0,h=e.args.length;p<h;p++){if(i.argnames[p]instanceof J){if(i.argnames[p].expression.__unused)for(;p<h;){(b=e.args[p++].drop_side_effect_free(t))&&(e.args[f++]=b)}else for(;p<h;)e.args[f++]=e.args[p++];l=f;break}var d=p>=i.argnames.length;if(d||i.argnames[p].__unused){if(b=e.args[p].drop_side_effect_free(t))e.args[f++]=b;else if(!d){e.args[f++]=s(En,e.args[p],{value:0});continue}}else e.args[f++]=e.args[p];l=f}e.args.length=l}if(t.option("unsafe"))if(De(r))switch(r.name){case"Array":if(1!=e.args.length)return s(Ie,e,{elements:e.args}).optimize(t);break;case"Object":if(0==e.args.length)return s(Ne,e,{properties:[]});break;case"String":if(0==e.args.length)return s(wn,e,{value:""});if(e.args.length<=1)return s(Le,e,{left:e.args[0],operator:"+",right:s(wn,e,{value:""})}).optimize(t);break;case"Number":if(0==e.args.length)return s(En,e,{value:0});if(1==e.args.length)return s($e,e,{expression:e.args[0],operator:"+"}).optimize(t);case"Boolean":if(0==e.args.length)return s(On,e);if(1==e.args.length)return s($e,e,{expression:s($e,e,{expression:e.args[0],operator:"!"}),operator:"!"}).optimize(t);break;case"RegExp":var m=[];if(w(e.args,function(e){var n=e.evaluate(t);return m.unshift(n),e!==n}))try{return yn(t,e,s(An,e,{value:RegExp.apply(RegExp,m)}))}catch(n){t.warn("Error converting {expr} [{file}:{line},{col}]",{expr:e.print_to_string(),file:e.start.file,line:e.start.line,col:e.start.col})}break;case"Symbol":return e.args=[],e}else if(r instanceof Oe)switch(r.property){case"toString":if(0==e.args.length&&!r.expression.may_throw_on_access(t))return s(Le,e,{left:s(wn,e,{value:""}),operator:"+",right:r.expression}).optimize(t);break;case"join":if(r.expression instanceof Ie)e:{var _;if(!(e.args.length>0&&(_=e.args[0].evaluate(t))===e.args[0])){var g,v=[],D=[];for(p=0,h=r.expression.elements.length;p<h;p++){var y=r.expression.elements[p];if(y instanceof J)break e;(z=y.evaluate(t))!==y?D.push(z):(D.length>0&&(v.push(s(wn,e,{value:D.join(_)})),D.length=0),v.push(y))}return D.length>0&&v.push(s(wn,e,{value:D.join(_)})),0==v.length?s(wn,e,{value:""}):1==v.length?v[0].is_string(t)?v[0]:s(Le,v[0],{operator:"+",left:s(wn,e,{value:""}),right:v[0]}):""==_?(g=v[0].is_string(t)||v[1].is_string(t)?v.shift():s(wn,e,{value:""}),v.reduce(function(e,n){return s(Le,n,{operator:"+",left:e,right:n})},g).optimize(t)):((b=e.clone()).expression=b.expression.clone(),b.expression.expression=b.expression.expression.clone(),b.expression.expression.elements=v,yn(t,e,b));var b}}break;case"charAt":if(r.expression.is_string(t)){var E=e.args[0],A=E?E.evaluate(t):0;if(A!==E)return s(Me,r,{expression:r.expression,property:c(0|A,E||r)}).optimize(t)}break;case"apply":if(2==e.args.length&&e.args[1]instanceof Ie)return(P=e.args[1].elements.slice()).unshift(e.args[0]),s(ke,e,{expression:s(Oe,r,{expression:r.expression,property:"call"}),args:P}).optimize(t);break;case"call":var C=r.expression;if(C instanceof mn&&(C=C.fixed_value()),C instanceof X&&!C.contains_this())return u(this,[e.args[0],s(ke,e,{expression:r.expression,args:e.args.slice(1)})]).optimize(t)}if(t.option("unsafe_Function")&&De(r)&&"Function"==r.name){if(0==e.args.length)return s(Q,e,{argnames:[],body:[]}).optimize(t);if(w(e.args,function(e){return e instanceof wn}))try{var x=Dt(M="n(function("+e.args.slice(0,-1).map(function(e){return e.value}).join(",")+"){"+e.args[e.args.length-1].value+"})"),B={ie8:t.option("ie8")};x.figure_out_scope(B);var S,T=new xt(t.options);(x=x.transform(T)).figure_out_scope(B),Et.reset(),x.compute_char_frequency(B),x.mangle_names(B),x.walk(new Pn(function(e){return!!S||(n(e)?(S=e,!0):void 0)})),S.body instanceof k&&(S.body=[s(se,S.body,{value:S.body})]);var M=Ft();return $.prototype._codegen.call(S,S,M),e.args=[s(wn,e,{value:S.argnames.map(function(e){return e.print_to_string()}).join(",")}),s(wn,e.args[e.args.length-1],{value:M.get().replace(/^\{|\}$/g,"")})],e}catch(n){if(!(n instanceof ct))throw n;t.warn("Error parsing code passed to new Function [{file}:{line},{col}]",e.args[e.args.length-1].start),t.warn(n.toString())}}var R=a&&i.body;if((R instanceof k?R=s(se,R,{value:R}):R&&(R=R[0]),t.option("inline")&&R instanceof se)&&(!(z=R.value)||z.is_constant_expression())){var P=e.args.concat(z||s(kn,e));return u(e,P).optimize(t)}if(a&&!i.is_generator&&!i.async){var L,z,q,I,N=-1;if(t.option("inline")&&o&&!i.uses_arguments&&!i.uses_eval&&!(i.name&&i instanceof Q)&&(z=function(e){var n=i.body instanceof k?[i.body]:i.body,r=n.length;if(t.option("inline")<3)return 1==r&&V(e);e=null;for(var o=0;o<r;o++){var a=n[o];if(a instanceof be){if(e&&!w(a.definitions,function(e){return!e.value}))return!1}else{if(e)return!1;e=a}}return V(e)}(R))&&(r===i||t.option("unused")&&1==(L=r.definition()).references.length&&!jn(t,L)&&i.is_constant_expression(r.scope))&&!e.pure&&!i.contains_this()&&function(){var e=Object.create(null);do{if((q=t.parent(++N))instanceof ve)e[q.argname.name]=!0;else if(q instanceof U)I=[];else if(q instanceof mn&&q.fixed_value()instanceof G)return!1}while(!(q instanceof G)||q instanceof K);var n=!(q instanceof W)||t.toplevel.vars,r=t.option("inline");return!(!function(e,n){for(var t=i.body.length,r=0;r<t;r++){var o=i.body[r];if(o instanceof be){if(!n)return!1;for(var a=o.definitions.length;--a>=0;){var s=o.definitions[a].name;if(e[s.name]||Ye(s.name)||q.var_names()[s.name])return!1;I&&I.push(s.definition())}}}return!0}(e,r>=3&&n)||!function(e,n){for(var t=0,r=i.argnames.length;t<r;t++){var o=i.argnames[t];if(o instanceof qe){if(o.left.__unused)continue;return!1}if(o instanceof ne)return!1;if(o instanceof J){if(o.expression.__unused)continue;return!1}if(!o.__unused){if(!n||e[o.name]||Ye(o.name)||q.var_names()[o.name])return!1;I&&I.push(o.definition())}}return!0}(e,r>=2&&n)||I&&0!=I.length&&Yn(i,I))}())return u(e,function(){var n=[],r=[];(function(n,t){for(var r=i.argnames.length,o=e.args.length;--o>=r;)t.push(e.args[o]);for(o=r;--o>=0;){var a=i.argnames[o],u=e.args[o];if(a.__unused||!a.name||q.var_names()[a.name])u&&t.push(u);else{var c=s(en,a,a);a.definition().orig.push(c),!u&&I&&(u=s(kn,e)),Z(n,t,c,u)}}n.reverse(),t.reverse()})(n,r),function(e,n){for(var t=n.length,r=0,o=i.body.length;r<o;r++){var a=i.body[r];if(a instanceof be)for(var u=0,c=a.definitions.length;u<c;u++){var f=a.definitions[u],l=f.name;if(Z(e,n,l,f.value),I){var p=l.definition(),h=s(mn,l,l);p.references.push(h),n.splice(t++,0,s(Ue,f,{operator:"=",left:h,right:s(kn,l)}))}}}}(n,r),r.push(z),n.length&&(p=q.body.indexOf(t.parent(N-1))+1,q.body.splice(p,0,s(be,i,{definitions:n})));return r}()).optimize(t);if(t.option("side_effects")&&!(i.body instanceof k)&&w(i.body,F)){P=e.args.concat(s(kn,e));return u(e,P).optimize(t)}}if(t.option("drop_console")&&r instanceof Te){for(var j=r.expression;j.expression;)j=j.expression;if(De(j)&&"console"==j.name)return s(kn,e).optimize(t)}if(t.option("negate_iife")&&t.parent()instanceof O&&Y(e))return e.negate(t,!0);var H=e.evaluate(t);return H!==e?(H=c(H,e).optimize(t),yn(t,H,e)):e;function V(n){return n?n instanceof se?n.value?n.value.clone(!0):s(kn,e):n instanceof O?s($e,n,{operator:"void",expression:n.body.clone(!0)}):void 0:s(kn,e)}function Z(n,t,r,i){var o=r.definition();q.variables.set(r.name,o),q.enclosed.push(o),q.var_names()[r.name]||(q.var_names()[r.name]=!0,n.push(s(xe,r,{name:r,value:null})));var a=s(mn,r,r);o.references.push(a),i&&t.push(s(Ue,e,{operator:"=",left:a,right:i}))}}),e(Be,function(e,n){if(n.option("unsafe")){var t=e.expression;if(De(t))switch(t.name){case"Object":case"RegExp":case"Function":case"Error":case"Array":return s(ke,e,e).transform(n)}}return e}),e(Se,function(e,n){if(!n.option("side_effects"))return e;var t=[];!function(){var r=C(n),i=e.expressions.length-1;e.expressions.forEach(function(e,o){o<i&&(e=e.drop_side_effect_free(n,r)),e&&(g(t,e),r=!1)})}();var r=t.length-1;return function(){for(;r>0&&pn(t[r],n);)r--;r<t.length-1&&(t[r]=s($e,e,{operator:"void",expression:t[r]}),t.length=r+1)}(),0==r?((e=f(n.parent(),n.self(),t[0]))instanceof Se||(e=e.optimize(n)),e):(e.expressions=t,e)}),Re.DEFMETHOD("lift_sequences",function(e){if(e.option("sequences")&&this.expression instanceof Se){var n=this.expression.expressions.slice(),t=this.clone();return t.expression=n.pop(),n.push(t),u(this,n).optimize(e)}return this}),e(Pe,function(e,n){return e.lift_sequences(n)}),e($e,function(e,n){var t=e.expression;if("delete"==e.operator&&!(t instanceof mn||t instanceof Te||Qe(t)))return t instanceof Se?((t=t.expressions.slice()).push(s(Mn,e)),u(e,t).optimize(n)):u(e,[t,s(Mn,e)]).optimize(n);var r=e.lift_sequences(n);if(r!==e)return r;if(n.option("side_effects")&&"void"==e.operator)return(t=t.drop_side_effect_free(n))?(e.expression=t,e):s(kn,e).optimize(n);if(n.in_boolean_context())switch(e.operator){case"!":if(t instanceof $e&&"!"==t.operator)return t.expression;t instanceof Le&&(e=yn(n,e,t.negate(n,C(n))));break;case"typeof":return n.warn("Boolean expression always true [{file}:{line},{col}]",e.start),(t instanceof mn?s(Mn,e):u(e,[t,s(Mn,e)])).optimize(n)}if("-"==e.operator&&t instanceof Sn&&(t=t.transform(n)),t instanceof Le&&("+"==e.operator||"-"==e.operator)&&("*"==t.operator||"/"==t.operator||"%"==t.operator))return s(Le,e,{operator:t.operator,left:s($e,t.left,{operator:e.operator,expression:t.left}),right:t.right});if("-"!=e.operator||!(t instanceof En||t instanceof Sn)){var i=e.evaluate(n);if(i!==e)return yn(n,i=c(i,e).optimize(n),e)}return e}),Le.DEFMETHOD("lift_sequences",function(e){if(e.option("sequences")){if(this.left instanceof Se){var n=this.left.expressions.slice();return(t=this.clone()).left=n.pop(),n.push(t),u(this,n).optimize(e)}if(this.right instanceof Se&&!this.left.has_side_effects(e)){for(var t,r="="==this.operator&&this.left instanceof mn,i=(n=this.right.expressions).length-1,o=0;o<i&&(r||!n[o].has_side_effects(e));o++);if(o==i)return n=n.slice(),(t=this.clone()).right=n.pop(),n.push(t),u(this,n).optimize(e);if(o>0)return(t=this.clone()).right=u(this.right,n.slice(o)),(n=n.slice(0,o)).push(t),u(this,n).optimize(e)}}return this});var Nn=b("== === != !== * & | ^");function jn(e,n){for(var t,r=0;t=e.parent(r);r++)if(t instanceof X){var i=t.name;if(i&&i.definition()===n)break}return t}function Hn(e,n){return e instanceof mn||e.TYPE===n.TYPE}function Yn(e,n){var t=!1,r=new Pn(function(e){return!!t||(e instanceof mn&&o(e.definition(),n)?t=!0:void 0)}),i=new Pn(function(n){if(t)return!0;if(n instanceof G&&n!==e){var o=i.parent();if(o instanceof ke&&o.expression===n)return;return n.walk(r),!0}});return e.walk(i),t}e(Le,function(e,n){function t(){return e.left.is_constant()||e.right.is_constant()||!e.left.has_side_effects(n)&&!e.right.has_side_effects(n)}function r(n){if(t()){n&&(e.operator=n);var r=e.left;e.left=e.right,e.right=r}}if(Nn(e.operator)&&e.right.is_constant()&&!e.left.is_constant()&&(e.left instanceof Le&&gt[e.left.operator]>=gt[e.operator]||r()),e=e.lift_sequences(n),n.option("comparisons"))switch(e.operator){case"===":case"!==":(e.left.is_string(n)&&e.right.is_string(n)||e.left.is_number(n)&&e.right.is_number(n)||e.left.is_boolean()&&e.right.is_boolean()||e.left.equivalent_to(e.right))&&(e.operator=e.operator.substr(0,2));case"==":case"!=":if(n.option("typeofs")&&e.left instanceof wn&&"undefined"==e.left.value&&e.right instanceof $e&&"typeof"==e.right.operator){var i=e.right.expression;(i instanceof mn?!i.is_declared(n):i instanceof Te&&n.option("ie8"))||(e.right=i,e.left=s(kn,e.left).optimize(n),2==e.operator.length&&(e.operator+="="))}else if(e.left instanceof mn&&e.right instanceof mn&&e.left.definition()===e.right.definition()&&function(e){return e instanceof Ie||e instanceof X||e instanceof Ne||e instanceof We}(e.left.fixed_value()))return s("="==e.operator[0]?Mn:On,e)}if("+"==e.operator&&n.in_boolean_context()){var o=e.left.evaluate(n),a=e.right.evaluate(n);if(o&&"string"==typeof o)return n.warn("+ in boolean context always true [{file}:{line},{col}]",e.start),u(e,[e.right,s(Mn,e)]).optimize(n);if(a&&"string"==typeof a)return n.warn("+ in boolean context always true [{file}:{line},{col}]",e.start),u(e,[e.left,s(Mn,e)]).optimize(n)}if(n.option("comparisons")&&e.is_boolean()){if(!(n.parent()instanceof Le)||n.parent()instanceof Ue){var l=s($e,e,{operator:"!",expression:e.negate(n,C(n))});e=yn(n,e,l)}if(n.option("unsafe_comps"))switch(e.operator){case"<":r(">");break;case"<=":r(">=")}}if("+"==e.operator){if(e.right instanceof wn&&""==e.right.getValue()&&e.left.is_string(n))return e.left;if(e.left instanceof wn&&""==e.left.getValue()&&e.right.is_string(n))return e.right;if(e.left instanceof Le&&"+"==e.left.operator&&e.left.left instanceof wn&&""==e.left.left.getValue()&&e.right.is_string(n))return e.left=e.left.right,e.transform(n)}if(n.option("evaluate")){switch(e.operator){case"&&":if(!(o=!!e.left.truthy||!e.left.falsy&&e.left.evaluate(n)))return n.warn("Condition left of && always false [{file}:{line},{col}]",e.start),f(n.parent(),n.self(),e.left).optimize(n);if(!(o instanceof k))return n.warn("Condition left of && always true [{file}:{line},{col}]",e.start),u(e,[e.left,e.right]).optimize(n);if(a=e.right.evaluate(n)){if(!(a instanceof k)){if("&&"==(p=n.parent()).operator&&p.left===n.self()||n.in_boolean_context())return n.warn("Dropping side-effect-free && [{file}:{line},{col}]",e.start),e.left.optimize(n)}}else{if(n.in_boolean_context())return n.warn("Boolean && always false [{file}:{line},{col}]",e.start),u(e,[e.left,s(On,e)]).optimize(n);e.falsy=!0}if("||"==e.left.operator)if(!(h=e.left.right.evaluate(n)))return s(ze,e,{condition:e.left.left,consequent:e.right,alternative:e.left.right}).optimize(n);break;case"||":var p,h;if(!(o=!!e.left.truthy||!e.left.falsy&&e.left.evaluate(n)))return n.warn("Condition left of || always false [{file}:{line},{col}]",e.start),u(e,[e.left,e.right]).optimize(n);if(!(o instanceof k))return n.warn("Condition left of || always true [{file}:{line},{col}]",e.start),f(n.parent(),n.self(),e.left).optimize(n);if(a=e.right.evaluate(n)){if(!(a instanceof k)){if(n.in_boolean_context())return n.warn("Boolean || always true [{file}:{line},{col}]",e.start),u(e,[e.left,s(Mn,e)]).optimize(n);e.truthy=!0}}else if("||"==(p=n.parent()).operator&&p.left===n.self()||n.in_boolean_context())return n.warn("Dropping side-effect-free || [{file}:{line},{col}]",e.start),e.left.optimize(n);if("&&"==e.left.operator)if((h=e.left.right.evaluate(n))&&!(h instanceof k))return s(ze,e,{condition:e.left.left,consequent:e.left.right,alternative:e.right}).optimize(n)}var d=!0;switch(e.operator){case"+":if(e.left instanceof bn&&e.right instanceof Le&&"+"==e.right.operator&&e.right.left instanceof bn&&e.right.is_string(n)&&(e=s(Le,e,{operator:"+",left:s(wn,e.left,{value:""+e.left.getValue()+e.right.left.getValue(),start:e.left.start,end:e.right.left.end}),right:e.right.right})),e.right instanceof bn&&e.left instanceof Le&&"+"==e.left.operator&&e.left.right instanceof bn&&e.left.is_string(n)&&(e=s(Le,e,{operator:"+",left:e.left.left,right:s(wn,e.right,{value:""+e.left.right.getValue()+e.right.getValue(),start:e.left.right.start,end:e.right.end})})),e.left instanceof Le&&"+"==e.left.operator&&e.left.is_string(n)&&e.left.right instanceof bn&&e.right instanceof Le&&"+"==e.right.operator&&e.right.left instanceof bn&&e.right.is_string(n)&&(e=s(Le,e,{operator:"+",left:s(Le,e.left,{operator:"+",left:e.left.left,right:s(wn,e.left.right,{value:""+e.left.right.getValue()+e.right.left.getValue(),start:e.left.right.start,end:e.right.left.end})}),right:e.right.right})),e.right instanceof $e&&"-"==e.right.operator&&e.left.is_number(n)){e=s(Le,e,{operator:"-",left:e.left,right:e.right.expression});break}if(e.left instanceof $e&&"-"==e.left.operator&&t()&&e.right.is_number(n)){e=s(Le,e,{operator:"-",left:e.right,right:e.left.expression});break}case"*":d=n.option("unsafe_math");case"&":case"|":case"^":if(e.left.is_number(n)&&e.right.is_number(n)&&t()&&!(e.left instanceof Le&&e.left.operator!=e.operator&&gt[e.left.operator]>=gt[e.operator])){var m=s(Le,e,{operator:e.operator,left:e.right,right:e.left});e=e.right instanceof bn&&!(e.left instanceof bn)?yn(n,m,e):yn(n,e,m)}d&&e.is_number(n)&&(e.right instanceof Le&&e.right.operator==e.operator&&(e=s(Le,e,{operator:e.operator,left:s(Le,e.left,{operator:e.operator,left:e.left,right:e.right.left,start:e.left.start,end:e.right.left.end}),right:e.right.right})),e.right instanceof bn&&e.left instanceof Le&&e.left.operator==e.operator&&(e.left.left instanceof bn?e=s(Le,e,{operator:e.operator,left:s(Le,e.left,{operator:e.operator,left:e.left.left,right:e.right,start:e.left.left.start,end:e.right.end}),right:e.left.right}):e.left.right instanceof bn&&(e=s(Le,e,{operator:e.operator,left:s(Le,e.left,{operator:e.operator,left:e.left.right,right:e.right,start:e.left.right.start,end:e.right.end}),right:e.left.left}))),e.left instanceof Le&&e.left.operator==e.operator&&e.left.right instanceof bn&&e.right instanceof Le&&e.right.operator==e.operator&&e.right.left instanceof bn&&(e=s(Le,e,{operator:e.operator,left:s(Le,e.left,{operator:e.operator,left:s(Le,e.left.left,{operator:e.operator,left:e.left.right,right:e.right.left,start:e.left.right.start,end:e.right.left.end}),right:e.left.left}),right:e.right.right})))}}if(e.right instanceof Le&&e.right.operator==e.operator&&(hn(e.operator)||"+"==e.operator&&(e.right.left.is_string(n)||e.left.is_string(n)&&e.right.right.is_string(n))))return e.left=s(Le,e.left,{operator:e.operator,left:e.left,right:e.right.left}),e.right=e.right.right,e.transform(n);var _=e.evaluate(n);return _!==e?(_=c(_,e).optimize(n),yn(n,_,e)):e}),e(_n,function(e,n){return e}),e(mn,function(e,t){var r=e.resolve_defines(t);if(r)return r.optimize(t);if(!t.option("ie8")&&De(e)&&(!e.scope.uses_with||!t.find_parent(V)))switch(e.name){case"undefined":return s(kn,e).optimize(t);case"NaN":return s(xn,e).optimize(t);case"Infinity":return s(Sn,e).optimize(t)}if(t.option("reduce_vars")&&gn(e,t.parent())!==e){var i=e.definition(),o=e.fixed_value(),a=i.single_use;if(a&&(o instanceof X||o instanceof We))if(i.scope!==e.scope&&(!t.option("reduce_funcs")&&o instanceof X||1==i.escaped||o.inlined))a=!1;else if(jn(t,i))a=!1;else if((i.scope!==e.scope||i.orig[0]instanceof on)&&"f"==(a=o.is_constant_expression(e.scope))){var u=e.scope;do{(u instanceof ee||n(u))&&(u.inlined=!0)}while(u=u.parent_scope)}if(a&&o){var f;if(o instanceof Je&&(o=s(Xe,o,o)),o instanceof ee&&(o._squeezed=!0,o=s(Q,o,o)),i.recursive_refs>0&&o.name instanceof an){var l=(f=o.clone(!0)).name.definition(),p=f.variables.get(f.name.name),h=p&&p.orig[0];h instanceof un||((h=s(un,f.name,f.name)).scope=f,f.name=h,p=f.def_function(h)),f.walk(new Pn(function(e){e instanceof mn&&e.definition()===l&&(e.thedef=p,p.references.push(e))}))}else(f=o.optimize(t))===o&&(f=o.clone(!0));return f}if(o&&void 0===i.should_replace){var d;if(o instanceof Dn)i.orig[0]instanceof on||!w(i.references,function(e){return i.scope===e.scope})||(d=o);else{var m=o.evaluate(t);m===o||!t.option("unsafe_regexp")&&m instanceof RegExp||(d=c(m,o))}if(d){var _,g=d.optimize(t).print_to_string().length;!function(e){var n;return e.walk(new Pn(function(e){if(e instanceof mn&&(n=!0),n)return!0})),n}(o)?(g=Math.min(g,o.print_to_string().length),_=function(){var e=vn(d.optimize(t),o);return e===d||e===o?e.clone(!0):e}):_=function(){var e=d.optimize(t);return e===d?e.clone(!0):e};var v=i.name.length,D=0;t.option("unused")&&!t.exposed(i)&&(D=(v+2+g)/i.references.length),i.should_replace=g<=v+D&&_}else i.should_replace=!1}if(i.should_replace)return i.should_replace()}return e}),e(kn,function(e,n){if(n.option("unsafe_undefined")){var t=i(n,"undefined");if(t){var r=s(mn,e,{name:"undefined",scope:t.scope,thedef:t});return r.is_undefined=!0,r}}var o=gn(n.self(),n.parent());return o&&Hn(o,e)?e:s($e,e,{operator:"void",expression:s(En,e,{value:0})})}),e(Sn,function(e,n){var t=gn(n.self(),n.parent());return t&&Hn(t,e)?e:!n.option("keep_infinity")||t&&!Hn(t,e)||i(n,"Infinity")?s(Le,e,{operator:"/",left:s(En,e,{value:1}),right:s(En,e,{value:0})}):e}),e(xn,function(e,n){var t=gn(n.self(),n.parent());return t&&!Hn(t,e)||i(n,"NaN")?s(Le,e,{operator:"/",left:s(En,e,{value:0}),right:s(En,e,{value:0})}):e});var Vn=["+","-","/","*","%",">>","<<",">>>","|","^","&"],Gn=["*","|","^","&"];function Wn(e,n){return n.in_boolean_context()?yn(n,e,u(e,[e,s(Mn,e)]).optimize(n)):e}function Jn(e,n){if(!n.option("computed_props"))return e;if(!(e.key instanceof bn))return e;if(e.key instanceof wn||e.key instanceof En){if("constructor"==e.key.value&&n.parent()instanceof We)return e;e.key=e instanceof He?e.key.value:s(sn,e.key,{name:e.key.value})}return e}e(Ue,function(e,n){var t;if(n.option("dead_code")&&e.left instanceof mn&&(t=e.left.definition()).scope===n.find_parent(X)){var r,i=0,a=e;do{if(r=a,(a=n.parent(i++))instanceof ae){if(u(i,a instanceof ue))break;if(Yn(t.scope,[t]))break;return"="==e.operator?e.right:s(Le,e,{operator:e.operator.slice(0,-1),left:e.left,right:e.right}).optimize(n)}}while(a instanceof Le&&a.right===r||a instanceof Se&&a.tail_node()===r)}return"="==(e=e.lift_sequences(n)).operator&&e.left instanceof mn&&e.right instanceof Le&&(e.right.left instanceof mn&&e.right.left.name==e.left.name&&o(e.right.operator,Vn)?(e.operator=e.right.operator+"=",e.right=e.right.right):e.right.right instanceof mn&&e.right.right.name==e.left.name&&o(e.right.operator,Gn)&&!e.right.left.has_side_effects(n)&&(e.operator=e.right.operator+"=",e.right=e.right.left)),e;function u(t,r){for(var i,o=e.left.definition().scope;(i=n.parent(t++))!==o;)if(i instanceof ge){if(i.bfinally)return!0;if(r&&i.bcatch)return!0}}}),e(qe,function(e,n){if(!n.option("evaluate"))return e;var t=e.right.evaluate(n);return void 0===t?e=e.left:t!==e.right&&(t=c(t,e.right),e.right=vn(t,e.right)),e}),e(ze,function(e,n){if(!n.option("conditionals"))return e;if(e.condition instanceof Se){var t=e.condition.expressions.slice();return e.condition=t.pop(),t.push(e),u(e,t)}var r=e.condition.evaluate(n);if(r!==e.condition)return r?(n.warn("Condition always true [{file}:{line},{col}]",e.start),f(n.parent(),n.self(),e.consequent)):(n.warn("Condition always false [{file}:{line},{col}]",e.start),f(n.parent(),n.self(),e.alternative));var i=r.negate(n,C(n));yn(n,r,i)===i&&(e=s(ze,e,{condition:i,consequent:e.alternative,alternative:e.consequent}));var o,a=e.condition,c=e.consequent,l=e.alternative;if(a instanceof mn&&c instanceof mn&&a.definition()===c.definition())return s(Le,e,{operator:"||",left:a,right:l});if(c instanceof Ue&&l instanceof Ue&&c.operator==l.operator&&c.left.equivalent_to(l.left)&&(!e.condition.has_side_effects(n)||"="==c.operator&&!c.left.has_side_effects(n)))return s(Ue,e,{operator:c.operator,left:c.left,right:s(ze,e,{condition:e.condition,consequent:c.right,alternative:l.right})});if(c instanceof ke&&l.TYPE===c.TYPE&&c.args.length>0&&c.args.length==l.args.length&&c.expression.equivalent_to(l.expression)&&!e.condition.has_side_effects(n)&&!c.expression.has_side_effects(n)&&"number"==typeof(o=function(){for(var e=c.args,n=l.args,t=0,r=e.length;t<r;t++){if(e[t]instanceof J)return;if(!e[t].equivalent_to(n[t])){if(n[t]instanceof J)return;for(var i=t+1;i<r;i++){if(e[i]instanceof J)return;if(!e[i].equivalent_to(n[i]))return}return t}}}())){var p=c.clone();return p.args[o]=s(ze,e,{condition:e.condition,consequent:c.args[o],alternative:l.args[o]}),p}if(c instanceof ze&&c.alternative.equivalent_to(l))return s(ze,e,{condition:s(Le,e,{left:e.condition,operator:"&&",right:c.condition}),consequent:c.consequent,alternative:l});if(c.equivalent_to(l))return u(e,[e.condition,c]).optimize(n);if(c instanceof Le&&"||"==c.operator&&c.right.equivalent_to(l))return s(Le,e,{operator:"||",left:s(Le,e,{operator:"&&",left:e.condition,right:c.left}),right:l}).optimize(n);var h=n.in_boolean_context();return m(e.consequent)?_(e.alternative)?d(e.condition):s(Le,e,{operator:"||",left:d(e.condition),right:e.alternative}):_(e.consequent)?m(e.alternative)?d(e.condition.negate(n)):s(Le,e,{operator:"&&",left:d(e.condition.negate(n)),right:e.alternative}):m(e.alternative)?s(Le,e,{operator:"||",left:d(e.condition.negate(n)),right:e.consequent}):_(e.alternative)?s(Le,e,{operator:"&&",left:d(e.condition),right:e.consequent}):e;function d(e){return e.is_boolean()?e:s($e,e,{operator:"!",expression:e.negate(n)})}function m(e){return e instanceof Mn||h&&e instanceof bn&&e.getValue()||e instanceof $e&&"!"==e.operator&&e.expression instanceof bn&&!e.expression.getValue()}function _(e){return e instanceof On||h&&e instanceof bn&&!e.getValue()||e instanceof $e&&"!"==e.operator&&e.expression instanceof bn&&e.expression.getValue()}}),e(Tn,function(e,n){if(n.in_boolean_context())return s(En,e,{value:+e.value});if(n.option("booleans")){var t=n.parent();return t instanceof Le&&("=="==t.operator||"!="==t.operator)?(n.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]",{operator:t.operator,value:e.value,file:t.start.file,line:t.start.line,col:t.start.col}),s(En,e,{value:+e.value})):s($e,e,{operator:"!",expression:s(En,e,{value:1-e.value})})}return e}),e(Me,function(e,n){var t=e.expression,r=e.property;if(n.option("properties")){var i=r.evaluate(n);if(i!==r){if("string"==typeof i)if("undefined"==i)i=void 0;else(_=parseFloat(i)).toString()==i&&(i=_);r=e.property=vn(r,c(i,r).transform(n));var o=""+i;if(ut(o)&&o.length<=r.print_to_string().length+1)return s(Oe,e,{expression:t,property:o}).optimize(n)}}if(gn(e,n.parent()))return e;if(i!==r){var a=e.flatten_object(o,n);a&&(t=e.expression=a.expression,r=e.property=a.property)}if(n.option("properties")&&n.option("side_effects")&&r instanceof En&&t instanceof Ie){var f=r.getValue(),l=t.elements;e:if(f in l){for(var p=!0,h=[],d=l.length;--d>f;){(_=l[d].drop_side_effect_free(n))&&(h.unshift(_),p&&_.has_side_effects(n)&&(p=!1))}var m=l[f];if(m instanceof J)break e;for(m=m instanceof Bn?s(kn,m):m,p||h.unshift(m);--d>=0;){var _;if((_=l[d])instanceof J)break e;(_=_.drop_side_effect_free(n))?h.unshift(_):f--}return p?(h.push(m),u(e,h).optimize(n)):s(Me,e,{expression:s(Ie,t,{elements:h}),property:s(En,r,{value:f})})}}var g=e.evaluate(n);return g!==e?yn(n,g=c(g,e).optimize(n),e):e}),X.DEFMETHOD("contains_this",function(){var e,n=this;return n.walk(new Pn(function(t){return!!e||(t instanceof Dn?e=!0:t!==n&&t instanceof G&&!(t instanceof K)||void 0)})),e}),Te.DEFMETHOD("flatten_object",function(e,n){if(n.option("properties")){var t=n.option("unsafe_arrows")&&n.option("ecma")>=6,r=this.expression;if(r instanceof Ne)for(var i=r.properties,o=i.length;--o>=0;){var a=i[o];if(""+(a instanceof Ge?a.key.name:a.key)==e){if(!w(i,function(e){return e instanceof He||t&&e instanceof Ge&&!e.is_generator}))break;var c=a.value;if((c instanceof Z||c instanceof Q)&&!(n.parent()instanceof Be)&&c.contains_this())break;return s(Me,this,{expression:s(Ie,r,{elements:i.map(function(e){var n=e.value;n instanceof Z&&(n=s(Q,n,n));var t=e.key;return t instanceof k&&!(t instanceof sn)?u(e,[t,n]):n})}),property:s(En,this,{value:o})})}}}}),e(Oe,function(e,n){"arguments"!=e.property&&"caller"!=e.property||n.warn("Function.protoype.{prop} not supported [{file}:{line},{col}]",{prop:e.property,file:e.start.file,line:e.start.line,col:e.start.col});var t=e.resolve_defines(n);if(t)return t.optimize(n);if(gn(e,n.parent()))return e;if(n.option("unsafe_proto")&&e.expression instanceof Oe&&"prototype"==e.expression.property){var r=e.expression.expression;if(De(r))switch(r.name){case"Array":e.expression=s(Ie,e.expression,{elements:[]});break;case"Function":e.expression=s(Q,e.expression,{argnames:[],body:[]});break;case"Number":e.expression=s(En,e.expression,{value:0});break;case"Object":e.expression=s(Ne,e.expression,{properties:[]});break;case"RegExp":e.expression=s(An,e.expression,{value:/t/});break;case"String":e.expression=s(wn,e.expression,{value:""})}}var i=e.flatten_object(e.property,n);if(i)return i.optimize(n);var o=e.evaluate(n);return o!==e?yn(n,o=c(o,e).optimize(n),e):e}),e(Ie,Wn),e(Ne,Wn),e(An,Wn),e(se,function(e,n){return e.value&&pn(e.value,n)&&(e.value=null),e}),e(K,function(e,n){if(e.body instanceof k||rn(e.body,n),n.option("arrows")&&1==e.body.length&&e.body[0]instanceof se){var t=e.body[0].value;e.body=t||[]}return e}),e(Q,function(e,n){if(rn(e.body,n),n.option("unsafe_arrows")&&n.option("ecma")>=6&&!e.name&&!e.is_generator&&!e.uses_arguments&&!e.uses_eval){var t=!1;if(e.walk(new Pn(function(e){return!!t||(e instanceof Dn?(t=!0,!0):void 0)})),!t)return s(K,e,e).optimize(n)}return e}),e(We,function(e,n){return e}),e($n,function(e,n){return e.expression&&!e.is_star&&pn(e.expression,n)&&(e.expression=null),e}),e(xe,function(e,n){var t=n.option("global_defs");return t&&A(t,e.name.name)&&n.warn("global_defs "+e.name.name+" redefined [{file}:{line},{col}]",e.start),e}),e(re,function(e,n){if(!n.option("evaluate")||n.parent()instanceof te)return e;for(var t=[],r=0;r<e.segments.length;r++){var i=e.segments[r];if(i instanceof k){var o=i.evaluate(n);if(o!==i&&(o+"").length<=i.print_to_string().length+"${}".length){t[t.length-1].value=t[t.length-1].value+o+e.segments[++r].value;continue}}t.push(i)}return e.segments=t,1==t.length?s(wn,e,t[0]):e}),e(te,function(e,n){return e}),e(je,Jn),e(Ge,function(e,n){if(Jn(e,n),n.option("arrows")&&n.parent()instanceof Ne&&!e.value.uses_arguments&&!e.value.uses_eval&&1==e.value.body.length&&e.value.body[0]instanceof se&&e.value.body[0].value&&!e.value.contains_this()){var t=s(K,e.value,e.value);return t.async=e.async,t.is_generator=e.is_generator,s(He,e,{key:e.key instanceof sn?e.key.name:e.key,value:t,quote:e.quote})}return e}),e(He,function(e,n){Jn(e,n);var t=n.option("unsafe_methods");if(t&&n.option("ecma")>=6&&(!(t instanceof RegExp)||t.test(e.key+""))){var r=e.key,i=e.value;if((i instanceof K&&Array.isArray(i.body)&&!i.contains_this()||i instanceof Q)&&!i.name)return s(Ge,e,{async:i.async,is_generator:i.is_generator,key:r instanceof k?r:s(sn,e,{name:r}),value:s(Z,i,i),quote:e.quote})}return e})}(),function(){var e=function(e){for(var n=!0,t=0;t<e.length;t++)n&&e[t]instanceof B&&e[t].body instanceof wn?e[t]=new T({start:e[t].start,end:e[t].end,value:e[t].body.value}):!n||e[t]instanceof B&&e[t].body instanceof wn||(n=!1);return e},n={Program:function(n){return new W({start:i(n),end:o(n),body:e(n.body.map(u))})},FunctionDeclaration:function(n){return new ee({start:i(n),end:o(n),name:u(n.id),argnames:n.params.map(u),body:e(u(n.body).body)})},FunctionExpression:function(n){return new Q({start:i(n),end:o(n),name:u(n.id),argnames:n.params.map(u),body:e(u(n.body).body)})},ExpressionStatement:function(e){return new O({start:i(e),end:o(e),body:u(e.expression)})},TryStatement:function(e){var n=e.handlers||[e.handler];if(n.length>1||e.guardedHandlers&&e.guardedHandlers.length)throw new Error("Multiple catch clauses are not supported.");return new ge({start:i(e),end:o(e),body:u(e.block).body,bcatch:u(n[0]),bfinally:e.finalizer?new De(u(e.finalizer)):null})},Property:function(e){var n=e.key,t={start:i(n),end:o(e.value),key:"Identifier"==n.type?n.name:n.value,value:u(e.value)};return"init"==e.kind?new He(t):(t.key=new sn({name:t.key}),t.value=new Z(t.value),"get"==e.kind?new Ve(t):"set"==e.kind?new Ye(t):void 0)},ArrayExpression:function(e){return new Ie({start:i(e),end:o(e),elements:e.elements.map(function(e){return null===e?new Bn:u(e)})})},ObjectExpression:function(e){return new Ne({start:i(e),end:o(e),properties:e.properties.map(function(e){return e.type="Property",u(e)})})},SequenceExpression:function(e){return new Se({start:i(e),end:o(e),expressions:e.expressions.map(u)})},MemberExpression:function(e){return new(e.computed?Me:Oe)({start:i(e),end:o(e),property:e.computed?u(e.property):e.property.name,expression:u(e.object)})},SwitchCase:function(e){return new(e.test?_e:me)({start:i(e),end:o(e),expression:u(e.test),body:e.consequent.map(u)})},VariableDeclaration:function(e){return new("const"===e.kind?Ee:be)({start:i(e),end:o(e),definitions:e.declarations.map(u)})},Literal:function(e){var n=e.value,t={start:i(e),end:o(e)};if(null===n)return new Fn(t);switch(typeof n){case"string":return t.value=n,new wn(t);case"number":return t.value=n,new En(t);case"boolean":return new(n?Mn:On)(t);default:var r=e.regex;return r&&r.pattern?t.value=new RegExp(r.pattern,r.flags).toString():t.value=e.regex&&e.raw?e.raw:n,new An(t)}},Identifier:function(e){var n=s[s.length-2];return new("LabeledStatement"==n.type?dn:"VariableDeclarator"==n.type&&n.id===e?"const"==n.kind?tn:en:"FunctionExpression"==n.type?n.id===e?un:on:"FunctionDeclaration"==n.type?n.id===e?an:on:"CatchClause"==n.type?ln:"BreakStatement"==n.type||"ContinueStatement"==n.type?vn:mn)({start:i(e),end:o(e),name:e.name})}};function r(e){if("Literal"==e.type)return null!=e.raw?e.raw:e.value+""}function i(e){var n=e.loc,t=n&&n.start,i=e.range;return new x({file:n&&n.source,line:t&&t.line,col:t&&t.column,pos:i?i[0]:e.start,endline:t&&t.line,endcol:t&&t.column,endpos:i?i[0]:e.start,raw:r(e)})}function o(e){var n=e.loc,t=n&&n.end,i=e.range;return new x({file:n&&n.source,line:t&&t.line,col:t&&t.column,pos:i?i[1]:e.end,endline:t&&t.line,endcol:t&&t.column,endpos:i?i[1]:e.end,raw:r(e)})}function a(e,r,a){var s="function From_Moz_"+e+"(M){\n";s+="return new U2."+r.name+"({\nstart: my_start_token(M),\nend: my_end_token(M)";var h="function To_Moz_"+e+"(M){\n";h+="return {\ntype: "+JSON.stringify(e),a&&a.split(/\s*,\s*/).forEach(function(e){var n=/([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);if(!n)throw new Error("Can't understand property map: "+e);var t=n[1],r=n[2],i=n[3];switch(s+=",\n"+i+": ",h+=",\n"+t+": ",r){case"@":s+="M."+t+".map(from_moz)",h+="M."+i+".map(to_moz)";break;case">":s+="from_moz(M."+t+")",h+="to_moz(M."+i+")";break;case"=":s+="M."+t,h+="M."+i;break;case"%":s+="from_moz(M."+t+").body",h+="to_moz_block(M)";break;default:throw new Error("Can't understand operator in propmap: "+e)}}),s+="\n})\n}",h+="\n}\n}",s=new Function("U2","my_start_token","my_end_token","from_moz","return("+s+")")(t,i,o,u),h=new Function("to_moz","to_moz_block","to_moz_scope","return("+h+")")(f,l,p),n[e]=s,c(r,h)}n.UpdateExpression=n.UnaryExpression=function(e){return new(("prefix"in e?e.prefix:"UnaryExpression"==e.type)?$e:Pe)({start:i(e),end:o(e),operator:e.operator,expression:u(e.argument)})},a("EmptyStatement",P),a("BlockStatement",$,"body@body"),a("IfStatement",pe,"test>condition, consequent>body, alternate>alternative"),a("LabeledStatement",z,"label>label, body>body"),a("BreakStatement",fe,"label>label"),a("ContinueStatement",le,"label>label"),a("WithStatement",V,"object>expression, body>body"),a("SwitchStatement",he,"discriminant>expression, cases@body"),a("ReturnStatement",se,"argument>value"),a("ThrowStatement",ue,"argument>value"),a("WhileStatement",N,"test>condition, body>body"),a("DoWhileStatement",I,"test>condition, body>body"),a("ForStatement",j,"init>init, test>condition, update>step, body>body"),a("ForInStatement",H,"left>init, right>object, body>body"),a("DebuggerStatement",S),a("VariableDeclarator",xe,"id>name, init>value"),a("CatchClause",ve,"param>argname, body%body"),a("ThisExpression",Dn),a("BinaryExpression",Le,"operator=operator, left>left, right>right"),a("LogicalExpression",Le,"operator=operator, left>left, right>right"),a("AssignmentExpression",Ue,"operator=operator, left>left, right>right"),a("ConditionalExpression",ze,"test>condition, consequent>consequent, alternate>alternative"),a("NewExpression",Be,"callee>expression, arguments@args"),a("CallExpression",ke,"callee>expression, arguments@args"),c(W,function(e){return p("Program",e)}),c(ee,function(e){return{type:"FunctionDeclaration",id:f(e.name),params:e.argnames.map(f),body:p("BlockStatement",e)}}),c(Q,function(e){return{type:"FunctionExpression",id:f(e.name),params:e.argnames.map(f),body:p("BlockStatement",e)}}),c(T,function(e){return{type:"ExpressionStatement",expression:{type:"Literal",value:e.value}}}),c(O,function(e){return{type:"ExpressionStatement",expression:f(e.body)}}),c(de,function(e){return{type:"SwitchCase",test:f(e.expression),consequent:e.body.map(f)}}),c(ge,function(e){return{type:"TryStatement",block:l(e),handler:f(e.bcatch),guardedHandlers:[],finalizer:f(e.bfinally)}}),c(ve,function(e){return{type:"CatchClause",param:f(e.argname),guard:null,body:l(e)}}),c(ye,function(e){return{type:"VariableDeclaration",kind:e instanceof Ee?"const":"var",declarations:e.definitions.map(f)}}),c(Se,function(e){return{type:"SequenceExpression",expressions:e.expressions.map(f)}}),c(Te,function(e){var n=e instanceof Me;return{type:"MemberExpression",object:f(e.expression),computed:n,property:n?f(e.property):{type:"Identifier",name:e.property}}}),c(Re,function(e){return{type:"++"==e.operator||"--"==e.operator?"UpdateExpression":"UnaryExpression",operator:e.operator,prefix:e instanceof $e,argument:f(e.expression)}}),c(Le,function(e){return{type:"&&"==e.operator||"||"==e.operator?"LogicalExpression":"BinaryExpression",left:f(e.left),operator:e.operator,right:f(e.right)}}),c(Ie,function(e){return{type:"ArrayExpression",elements:e.elements.map(f)}}),c(Ne,function(e){return{type:"ObjectExpression",properties:e.properties.map(f)}}),c(je,function(e){var n,t={type:"Literal",value:e.key instanceof sn?e.key.name:e.key};return e instanceof He?n="init":e instanceof Ve?n="get":e instanceof Ye&&(n="set"),{type:"Property",kind:n,key:t,value:f(e.value)}}),c(Ze,function(e){var n=e.definition();return{type:"Identifier",name:n?n.mangled_name||n.name:e.name}}),c(An,function(e){var n=e.value;return{type:"Literal",value:n,raw:n.toString(),regex:{pattern:n.source,flags:n.toString().match(/[gimuy]*$/)[0]}}}),c(bn,function(e){var n=e.value;return"number"==typeof n&&(n<0||0===n&&1/n<0)?{type:"UnaryExpression",operator:"-",prefix:!0,argument:{type:"Literal",value:-n,raw:e.start.raw}}:{type:"Literal",value:n,raw:e.start.raw}}),c(Cn,function(e){return{type:"Identifier",name:String(e.value)}}),Tn.DEFMETHOD("to_mozilla_ast",bn.prototype.to_mozilla_ast),Fn.DEFMETHOD("to_mozilla_ast",bn.prototype.to_mozilla_ast),Bn.DEFMETHOD("to_mozilla_ast",function(){return null}),R.DEFMETHOD("to_mozilla_ast",$.prototype.to_mozilla_ast),X.DEFMETHOD("to_mozilla_ast",Q.prototype.to_mozilla_ast);var s=null;function u(e){s.push(e);var t=null!=e?n[e.type](e):null;return s.pop(),t}function c(e,n){e.DEFMETHOD("to_mozilla_ast",function(){return function(e,n,t){var r=e.start,i=e.end;return null!=r.pos&&null!=i.endpos&&(n.range=[r.pos,i.endpos]),r.line&&(n.loc={start:{line:r.line,column:r.col},end:i.endline?{line:i.endline,column:i.endcol}:null},r.file&&(n.loc.source=r.file)),n}(this,n(this))})}function f(e){return null!=e?e.to_mozilla_ast():null}function l(e){return{type:"BlockStatement",body:e.body.map(f)}}function p(e,n){var t=n.body.map(f);return n.body[0]instanceof O&&n.body[0].body instanceof wn&&t.unshift(f(new P(n.body[0]))),{type:e,body:t}}k.from_mozilla_ast=function(e){var n=s;s=[];var t=u(e);return s=n,t}}();var St="undefined"==typeof atob?function(e){return new r(e,"base64").toString()}:atob,Tt="undefined"==typeof btoa?function(e){return new r(e).toString("base64")}:btoa;function Ot(e){var n=/\n\/\/# sourceMappingURL=data:application\/json(;.*?)?;base64,(.*)/.exec(e);return n?St(n[2]):(k.warn("inline source map not found"),null)}function Mt(e,n,t){n[e]&&t.forEach(function(t){n[t]&&("object"!=typeof n[t]&&(n[t]={}),e in n[t]||(n[t][e]=n[e]))})}function Rt(e){e&&("props"in e?e.props instanceof E||(e.props=E.fromObject(e.props)):e.props=new E)}function $t(e){return{props:e.props.toObject()}}t.Dictionary=E,t.TreeWalker=Pn,t.TreeTransformer=yt,t.minify=function(e,t){var r=k.warn_function;try{var i,o=(t=c(t,{compress:{},ecma:void 0,ie8:!1,keep_classnames:void 0,keep_fnames:!1,mangle:{},nameCache:null,output:{},parse:{},rename:void 0,safari10:!1,sourceMap:!1,timings:!1,toplevel:!1,warnings:!1,wrap:!1},!0)).timings&&{start:Date.now()};void 0===t.keep_classnames&&(t.keep_classnames=t.keep_fnames),void 0===t.rename&&(t.rename=t.compress&&t.mangle),Mt("ecma",t,["parse","compress","output"]),Mt("ie8",t,["compress","mangle","output"]),Mt("keep_classnames",t,["compress","mangle"]),Mt("keep_fnames",t,["compress","mangle"]),Mt("safari10",t,["mangle","output"]),Mt("toplevel",t,["compress","mangle"]),Mt("warnings",t,["compress"]),t.mangle&&(t.mangle=c(t.mangle,{cache:t.nameCache&&(t.nameCache.vars||{}),eval:!1,ie8:!1,keep_classnames:!1,keep_fnames:!1,properties:!1,reserved:[],safari10:!1,toplevel:!1},!0),t.mangle.properties&&("object"!=typeof t.mangle.properties&&(t.mangle.properties={}),t.mangle.properties.keep_quoted&&(i=t.mangle.properties.reserved,Array.isArray(i)||(i=[]),t.mangle.properties.reserved=i),!t.nameCache||"cache"in t.mangle.properties||(t.mangle.properties.cache=t.nameCache.props||{})),Rt(t.mangle.cache),Rt(t.mangle.properties.cache)),t.sourceMap&&(t.sourceMap=c(t.sourceMap,{content:null,filename:null,includeSources:!1,root:null,url:null},!0));var a,s=[];if(t.warnings&&!k.warn_function&&(k.warn_function=function(e){s.push(e)}),o&&(o.parse=Date.now()),e instanceof W)a=e;else{for(var u in"string"==typeof e&&(e=[e]),t.parse=t.parse||{},t.parse.toplevel=null,e)if(A(e,u)&&(t.parse.filename=u,t.parse.toplevel=Dt(e[u],t.parse),t.sourceMap&&"inline"==t.sourceMap.content)){if(Object.keys(e).length>1)throw new Error("inline source map only works with singular input");t.sourceMap.content=Ot(e[u])}a=t.parse.toplevel}i&&function(e,n){function t(e){g(n,e)}e.walk(new Pn(function(e){e instanceof He&&e.quote?t(e.key):e instanceof je&&e.quote?t(e.key.name):e instanceof Me&&kt(e.property,t)}))}(a,i),t.wrap&&(a=a.wrap_commonjs(t.wrap)),o&&(o.rename=Date.now()),o&&(o.compress=Date.now()),t.compress&&(a=new xt(t.compress).compress(a)),o&&(o.scope=Date.now()),t.mangle&&a.figure_out_scope(t.mangle),o&&(o.mangle=Date.now()),t.mangle&&(Et.reset(),a.compute_char_frequency(t.mangle),a.mangle_names(t.mangle)),o&&(o.properties=Date.now()),t.mangle&&t.mangle.properties&&(a=Bt(a,t.mangle.properties)),o&&(o.output=Date.now());var f={};if(t.output.ast&&(f.ast=a),!A(t.output,"code")||t.output.code){if(t.sourceMap&&("string"==typeof t.sourceMap.content&&(t.sourceMap.content=JSON.parse(t.sourceMap.content)),t.output.source_map=function(e){e=c(e,{file:null,root:null,orig:null,orig_line_diff:0,dest_line_diff:0});var t=new n.SourceMapGenerator({file:e.file,sourceRoot:e.root}),r=e.orig&&new n.SourceMapConsumer(e.orig);return r&&Array.isArray(e.orig.sources)&&r._sources.toArray().forEach(function(e){var n=r.sourceContentFor(e,!0);n&&t.setSourceContent(e,n)}),{add:function(n,i,o,a,s,u){if(r){var c=r.originalPositionFor({line:a,column:s});if(null===c.source)return;n=c.source,a=c.line,s=c.column,u=c.name||u}t.addMapping({generated:{line:i+e.dest_line_diff,column:o},original:{line:a+e.orig_line_diff,column:s},source:n,name:u})},get:function(){return t},toString:function(){return JSON.stringify(t.toJSON())}}}({file:t.sourceMap.filename,orig:t.sourceMap.content,root:t.sourceMap.root}),t.sourceMap.includeSources)){if(e instanceof W)throw new Error("original source content unavailable");for(var u in e)A(e,u)&&t.output.source_map.get().setSourceContent(u,e[u])}delete t.output.ast,delete t.output.code;var l=Ft(t.output);a.print(l),f.code=l.get(),t.sourceMap&&(f.map=t.output.source_map.toString(),"inline"==t.sourceMap.url?f.code+="\n//# sourceMappingURL=data:application/json;charset=utf-8;base64,"+Tt(f.map):t.sourceMap.url&&(f.code+="\n//# sourceMappingURL="+t.sourceMap.url))}return t.nameCache&&t.mangle&&(t.mangle.cache&&(t.nameCache.vars=$t(t.mangle.cache)),t.mangle.properties&&t.mangle.properties.cache&&(t.nameCache.props=$t(t.mangle.properties.cache))),o&&(o.end=Date.now(),f.timings={parse:.001*(o.rename-o.parse),rename:.001*(o.compress-o.rename),compress:.001*(o.scope-o.compress),scope:.001*(o.mangle-o.scope),mangle:.001*(o.properties-o.mangle),properties:.001*(o.output-o.properties),output:.001*(o.end-o.output),total:.001*(o.end-o.start)}),s.length&&(f.warnings=s),f}catch(e){return{error:e}}finally{k.warn_function=r}},t.parse=Dt,t._push_uniq=g}(t(10),n)}).call(this,t(1),t(6).Buffer)},function(e,n,t){"use strict";(function(e){
/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 * @license  MIT
 */
var r=t(7),i=t(8),o=t(9);function a(){return u.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function s(e,n){if(a()<n)throw new RangeError("Invalid typed array length");return u.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(n)).__proto__=u.prototype:(null===e&&(e=new u(n)),e.length=n),e}function u(e,n,t){if(!(u.TYPED_ARRAY_SUPPORT||this instanceof u))return new u(e,n,t);if("number"==typeof e){if("string"==typeof n)throw new Error("If encoding is specified then the first argument must be a string");return l(this,e)}return c(this,e,n,t)}function c(e,n,t,r){if("number"==typeof n)throw new TypeError('"value" argument must not be a number');return"undefined"!=typeof ArrayBuffer&&n instanceof ArrayBuffer?function(e,n,t,r){if(n.byteLength,t<0||n.byteLength<t)throw new RangeError("'offset' is out of bounds");if(n.byteLength<t+(r||0))throw new RangeError("'length' is out of bounds");n=void 0===t&&void 0===r?new Uint8Array(n):void 0===r?new Uint8Array(n,t):new Uint8Array(n,t,r);u.TYPED_ARRAY_SUPPORT?(e=n).__proto__=u.prototype:e=p(e,n);return e}(e,n,t,r):"string"==typeof n?function(e,n,t){"string"==typeof t&&""!==t||(t="utf8");if(!u.isEncoding(t))throw new TypeError('"encoding" must be a valid string encoding');var r=0|d(n,t),i=(e=s(e,r)).write(n,t);i!==r&&(e=e.slice(0,i));return e}(e,n,t):function(e,n){if(u.isBuffer(n)){var t=0|h(n.length);return 0===(e=s(e,t)).length?e:(n.copy(e,0,0,t),e)}if(n){if("undefined"!=typeof ArrayBuffer&&n.buffer instanceof ArrayBuffer||"length"in n)return"number"!=typeof n.length||function(e){return e!=e}(n.length)?s(e,0):p(e,n);if("Buffer"===n.type&&o(n.data))return p(e,n.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}(e,n)}function f(e){if("number"!=typeof e)throw new TypeError('"size" argument must be a number');if(e<0)throw new RangeError('"size" argument must not be negative')}function l(e,n){if(f(n),e=s(e,n<0?0:0|h(n)),!u.TYPED_ARRAY_SUPPORT)for(var t=0;t<n;++t)e[t]=0;return e}function p(e,n){var t=n.length<0?0:0|h(n.length);e=s(e,t);for(var r=0;r<t;r+=1)e[r]=255&n[r];return e}function h(e){if(e>=a())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+a().toString(16)+" bytes");return 0|e}function d(e,n){if(u.isBuffer(e))return e.length;if("undefined"!=typeof ArrayBuffer&&"function"==typeof ArrayBuffer.isView&&(ArrayBuffer.isView(e)||e instanceof ArrayBuffer))return e.byteLength;"string"!=typeof e&&(e=""+e);var t=e.length;if(0===t)return 0;for(var r=!1;;)switch(n){case"ascii":case"latin1":case"binary":return t;case"utf8":case"utf-8":case void 0:return q(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*t;case"hex":return t>>>1;case"base64":return I(e).length;default:if(r)return q(e).length;n=(""+n).toLowerCase(),r=!0}}function m(e,n,t){var r=e[n];e[n]=e[t],e[t]=r}function _(e,n,t,r,i){if(0===e.length)return-1;if("string"==typeof t?(r=t,t=0):t>2147483647?t=2147483647:t<-2147483648&&(t=-2147483648),t=+t,isNaN(t)&&(t=i?0:e.length-1),t<0&&(t=e.length+t),t>=e.length){if(i)return-1;t=e.length-1}else if(t<0){if(!i)return-1;t=0}if("string"==typeof n&&(n=u.from(n,r)),u.isBuffer(n))return 0===n.length?-1:g(e,n,t,r,i);if("number"==typeof n)return n&=255,u.TYPED_ARRAY_SUPPORT&&"function"==typeof Uint8Array.prototype.indexOf?i?Uint8Array.prototype.indexOf.call(e,n,t):Uint8Array.prototype.lastIndexOf.call(e,n,t):g(e,[n],t,r,i);throw new TypeError("val must be string, number or Buffer")}function g(e,n,t,r,i){var o,a=1,s=e.length,u=n.length;if(void 0!==r&&("ucs2"===(r=String(r).toLowerCase())||"ucs-2"===r||"utf16le"===r||"utf-16le"===r)){if(e.length<2||n.length<2)return-1;a=2,s/=2,u/=2,t/=2}function c(e,n){return 1===a?e[n]:e.readUInt16BE(n*a)}if(i){var f=-1;for(o=t;o<s;o++)if(c(e,o)===c(n,-1===f?0:o-f)){if(-1===f&&(f=o),o-f+1===u)return f*a}else-1!==f&&(o-=o-f),f=-1}else for(t+u>s&&(t=s-u),o=t;o>=0;o--){for(var l=!0,p=0;p<u;p++)if(c(e,o+p)!==c(n,p)){l=!1;break}if(l)return o}return-1}function v(e,n,t,r){t=Number(t)||0;var i=e.length-t;r?(r=Number(r))>i&&(r=i):r=i;var o=n.length;if(o%2!=0)throw new TypeError("Invalid hex string");r>o/2&&(r=o/2);for(var a=0;a<r;++a){var s=parseInt(n.substr(2*a,2),16);if(isNaN(s))return a;e[t+a]=s}return a}function D(e,n,t,r){return N(q(n,e.length-t),e,t,r)}function y(e,n,t,r){return N(function(e){for(var n=[],t=0;t<e.length;++t)n.push(255&e.charCodeAt(t));return n}(n),e,t,r)}function b(e,n,t,r){return y(e,n,t,r)}function w(e,n,t,r){return N(I(n),e,t,r)}function E(e,n,t,r){return N(function(e,n){for(var t,r,i,o=[],a=0;a<e.length&&!((n-=2)<0);++a)t=e.charCodeAt(a),r=t>>8,i=t%256,o.push(i),o.push(r);return o}(n,e.length-t),e,t,r)}function A(e,n,t){return 0===n&&t===e.length?r.fromByteArray(e):r.fromByteArray(e.slice(n,t))}function C(e,n,t){t=Math.min(e.length,t);for(var r=[],i=n;i<t;){var o,a,s,u,c=e[i],f=null,l=c>239?4:c>223?3:c>191?2:1;if(i+l<=t)switch(l){case 1:c<128&&(f=c);break;case 2:128==(192&(o=e[i+1]))&&(u=(31&c)<<6|63&o)>127&&(f=u);break;case 3:o=e[i+1],a=e[i+2],128==(192&o)&&128==(192&a)&&(u=(15&c)<<12|(63&o)<<6|63&a)>2047&&(u<55296||u>57343)&&(f=u);break;case 4:o=e[i+1],a=e[i+2],s=e[i+3],128==(192&o)&&128==(192&a)&&128==(192&s)&&(u=(15&c)<<18|(63&o)<<12|(63&a)<<6|63&s)>65535&&u<1114112&&(f=u)}null===f?(f=65533,l=1):f>65535&&(f-=65536,r.push(f>>>10&1023|55296),f=56320|1023&f),r.push(f),i+=l}return function(e){var n=e.length;if(n<=F)return String.fromCharCode.apply(String,e);var t="",r=0;for(;r<n;)t+=String.fromCharCode.apply(String,e.slice(r,r+=F));return t}(r)}n.Buffer=u,n.SlowBuffer=function(e){+e!=e&&(e=0);return u.alloc(+e)},n.INSPECT_MAX_BYTES=50,u.TYPED_ARRAY_SUPPORT=void 0!==e.TYPED_ARRAY_SUPPORT?e.TYPED_ARRAY_SUPPORT:function(){try{var e=new Uint8Array(1);return e.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===e.foo()&&"function"==typeof e.subarray&&0===e.subarray(1,1).byteLength}catch(e){return!1}}(),n.kMaxLength=a(),u.poolSize=8192,u._augment=function(e){return e.__proto__=u.prototype,e},u.from=function(e,n,t){return c(null,e,n,t)},u.TYPED_ARRAY_SUPPORT&&(u.prototype.__proto__=Uint8Array.prototype,u.__proto__=Uint8Array,"undefined"!=typeof Symbol&&Symbol.species&&u[Symbol.species]===u&&Object.defineProperty(u,Symbol.species,{value:null,configurable:!0})),u.alloc=function(e,n,t){return function(e,n,t,r){return f(n),n<=0?s(e,n):void 0!==t?"string"==typeof r?s(e,n).fill(t,r):s(e,n).fill(t):s(e,n)}(null,e,n,t)},u.allocUnsafe=function(e){return l(null,e)},u.allocUnsafeSlow=function(e){return l(null,e)},u.isBuffer=function(e){return!(null==e||!e._isBuffer)},u.compare=function(e,n){if(!u.isBuffer(e)||!u.isBuffer(n))throw new TypeError("Arguments must be Buffers");if(e===n)return 0;for(var t=e.length,r=n.length,i=0,o=Math.min(t,r);i<o;++i)if(e[i]!==n[i]){t=e[i],r=n[i];break}return t<r?-1:r<t?1:0},u.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},u.concat=function(e,n){if(!o(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return u.alloc(0);var t;if(void 0===n)for(n=0,t=0;t<e.length;++t)n+=e[t].length;var r=u.allocUnsafe(n),i=0;for(t=0;t<e.length;++t){var a=e[t];if(!u.isBuffer(a))throw new TypeError('"list" argument must be an Array of Buffers');a.copy(r,i),i+=a.length}return r},u.byteLength=d,u.prototype._isBuffer=!0,u.prototype.swap16=function(){var e=this.length;if(e%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var n=0;n<e;n+=2)m(this,n,n+1);return this},u.prototype.swap32=function(){var e=this.length;if(e%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var n=0;n<e;n+=4)m(this,n,n+3),m(this,n+1,n+2);return this},u.prototype.swap64=function(){var e=this.length;if(e%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var n=0;n<e;n+=8)m(this,n,n+7),m(this,n+1,n+6),m(this,n+2,n+5),m(this,n+3,n+4);return this},u.prototype.toString=function(){var e=0|this.length;return 0===e?"":0===arguments.length?C(this,0,e):function(e,n,t){var r=!1;if((void 0===n||n<0)&&(n=0),n>this.length)return"";if((void 0===t||t>this.length)&&(t=this.length),t<=0)return"";if((t>>>=0)<=(n>>>=0))return"";for(e||(e="utf8");;)switch(e){case"hex":return B(this,n,t);case"utf8":case"utf-8":return C(this,n,t);case"ascii":return x(this,n,t);case"latin1":case"binary":return k(this,n,t);case"base64":return A(this,n,t);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return S(this,n,t);default:if(r)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),r=!0}}.apply(this,arguments)},u.prototype.equals=function(e){if(!u.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e||0===u.compare(this,e)},u.prototype.inspect=function(){var e="",t=n.INSPECT_MAX_BYTES;return this.length>0&&(e=this.toString("hex",0,t).match(/.{2}/g).join(" "),this.length>t&&(e+=" ... ")),"<Buffer "+e+">"},u.prototype.compare=function(e,n,t,r,i){if(!u.isBuffer(e))throw new TypeError("Argument must be a Buffer");if(void 0===n&&(n=0),void 0===t&&(t=e?e.length:0),void 0===r&&(r=0),void 0===i&&(i=this.length),n<0||t>e.length||r<0||i>this.length)throw new RangeError("out of range index");if(r>=i&&n>=t)return 0;if(r>=i)return-1;if(n>=t)return 1;if(n>>>=0,t>>>=0,r>>>=0,i>>>=0,this===e)return 0;for(var o=i-r,a=t-n,s=Math.min(o,a),c=this.slice(r,i),f=e.slice(n,t),l=0;l<s;++l)if(c[l]!==f[l]){o=c[l],a=f[l];break}return o<a?-1:a<o?1:0},u.prototype.includes=function(e,n,t){return-1!==this.indexOf(e,n,t)},u.prototype.indexOf=function(e,n,t){return _(this,e,n,t,!0)},u.prototype.lastIndexOf=function(e,n,t){return _(this,e,n,t,!1)},u.prototype.write=function(e,n,t,r){if(void 0===n)r="utf8",t=this.length,n=0;else if(void 0===t&&"string"==typeof n)r=n,t=this.length,n=0;else{if(!isFinite(n))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");n|=0,isFinite(t)?(t|=0,void 0===r&&(r="utf8")):(r=t,t=void 0)}var i=this.length-n;if((void 0===t||t>i)&&(t=i),e.length>0&&(t<0||n<0)||n>this.length)throw new RangeError("Attempt to write outside buffer bounds");r||(r="utf8");for(var o=!1;;)switch(r){case"hex":return v(this,e,n,t);case"utf8":case"utf-8":return D(this,e,n,t);case"ascii":return y(this,e,n,t);case"latin1":case"binary":return b(this,e,n,t);case"base64":return w(this,e,n,t);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return E(this,e,n,t);default:if(o)throw new TypeError("Unknown encoding: "+r);r=(""+r).toLowerCase(),o=!0}},u.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var F=4096;function x(e,n,t){var r="";t=Math.min(e.length,t);for(var i=n;i<t;++i)r+=String.fromCharCode(127&e[i]);return r}function k(e,n,t){var r="";t=Math.min(e.length,t);for(var i=n;i<t;++i)r+=String.fromCharCode(e[i]);return r}function B(e,n,t){var r=e.length;(!n||n<0)&&(n=0),(!t||t<0||t>r)&&(t=r);for(var i="",o=n;o<t;++o)i+=U(e[o]);return i}function S(e,n,t){for(var r=e.slice(n,t),i="",o=0;o<r.length;o+=2)i+=String.fromCharCode(r[o]+256*r[o+1]);return i}function T(e,n,t){if(e%1!=0||e<0)throw new RangeError("offset is not uint");if(e+n>t)throw new RangeError("Trying to access beyond buffer length")}function O(e,n,t,r,i,o){if(!u.isBuffer(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(n>i||n<o)throw new RangeError('"value" argument is out of bounds');if(t+r>e.length)throw new RangeError("Index out of range")}function M(e,n,t,r){n<0&&(n=65535+n+1);for(var i=0,o=Math.min(e.length-t,2);i<o;++i)e[t+i]=(n&255<<8*(r?i:1-i))>>>8*(r?i:1-i)}function R(e,n,t,r){n<0&&(n=4294967295+n+1);for(var i=0,o=Math.min(e.length-t,4);i<o;++i)e[t+i]=n>>>8*(r?i:3-i)&255}function $(e,n,t,r,i,o){if(t+r>e.length)throw new RangeError("Index out of range");if(t<0)throw new RangeError("Index out of range")}function P(e,n,t,r,o){return o||$(e,0,t,4),i.write(e,n,t,r,23,4),t+4}function L(e,n,t,r,o){return o||$(e,0,t,8),i.write(e,n,t,r,52,8),t+8}u.prototype.slice=function(e,n){var t,r=this.length;if(e=~~e,n=void 0===n?r:~~n,e<0?(e+=r)<0&&(e=0):e>r&&(e=r),n<0?(n+=r)<0&&(n=0):n>r&&(n=r),n<e&&(n=e),u.TYPED_ARRAY_SUPPORT)(t=this.subarray(e,n)).__proto__=u.prototype;else{var i=n-e;t=new u(i,void 0);for(var o=0;o<i;++o)t[o]=this[o+e]}return t},u.prototype.readUIntLE=function(e,n,t){e|=0,n|=0,t||T(e,n,this.length);for(var r=this[e],i=1,o=0;++o<n&&(i*=256);)r+=this[e+o]*i;return r},u.prototype.readUIntBE=function(e,n,t){e|=0,n|=0,t||T(e,n,this.length);for(var r=this[e+--n],i=1;n>0&&(i*=256);)r+=this[e+--n]*i;return r},u.prototype.readUInt8=function(e,n){return n||T(e,1,this.length),this[e]},u.prototype.readUInt16LE=function(e,n){return n||T(e,2,this.length),this[e]|this[e+1]<<8},u.prototype.readUInt16BE=function(e,n){return n||T(e,2,this.length),this[e]<<8|this[e+1]},u.prototype.readUInt32LE=function(e,n){return n||T(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},u.prototype.readUInt32BE=function(e,n){return n||T(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},u.prototype.readIntLE=function(e,n,t){e|=0,n|=0,t||T(e,n,this.length);for(var r=this[e],i=1,o=0;++o<n&&(i*=256);)r+=this[e+o]*i;return r>=(i*=128)&&(r-=Math.pow(2,8*n)),r},u.prototype.readIntBE=function(e,n,t){e|=0,n|=0,t||T(e,n,this.length);for(var r=n,i=1,o=this[e+--r];r>0&&(i*=256);)o+=this[e+--r]*i;return o>=(i*=128)&&(o-=Math.pow(2,8*n)),o},u.prototype.readInt8=function(e,n){return n||T(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},u.prototype.readInt16LE=function(e,n){n||T(e,2,this.length);var t=this[e]|this[e+1]<<8;return 32768&t?4294901760|t:t},u.prototype.readInt16BE=function(e,n){n||T(e,2,this.length);var t=this[e+1]|this[e]<<8;return 32768&t?4294901760|t:t},u.prototype.readInt32LE=function(e,n){return n||T(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},u.prototype.readInt32BE=function(e,n){return n||T(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},u.prototype.readFloatLE=function(e,n){return n||T(e,4,this.length),i.read(this,e,!0,23,4)},u.prototype.readFloatBE=function(e,n){return n||T(e,4,this.length),i.read(this,e,!1,23,4)},u.prototype.readDoubleLE=function(e,n){return n||T(e,8,this.length),i.read(this,e,!0,52,8)},u.prototype.readDoubleBE=function(e,n){return n||T(e,8,this.length),i.read(this,e,!1,52,8)},u.prototype.writeUIntLE=function(e,n,t,r){(e=+e,n|=0,t|=0,r)||O(this,e,n,t,Math.pow(2,8*t)-1,0);var i=1,o=0;for(this[n]=255&e;++o<t&&(i*=256);)this[n+o]=e/i&255;return n+t},u.prototype.writeUIntBE=function(e,n,t,r){(e=+e,n|=0,t|=0,r)||O(this,e,n,t,Math.pow(2,8*t)-1,0);var i=t-1,o=1;for(this[n+i]=255&e;--i>=0&&(o*=256);)this[n+i]=e/o&255;return n+t},u.prototype.writeUInt8=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,1,255,0),u.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),this[n]=255&e,n+1},u.prototype.writeUInt16LE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,2,65535,0),u.TYPED_ARRAY_SUPPORT?(this[n]=255&e,this[n+1]=e>>>8):M(this,e,n,!0),n+2},u.prototype.writeUInt16BE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,2,65535,0),u.TYPED_ARRAY_SUPPORT?(this[n]=e>>>8,this[n+1]=255&e):M(this,e,n,!1),n+2},u.prototype.writeUInt32LE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,4,4294967295,0),u.TYPED_ARRAY_SUPPORT?(this[n+3]=e>>>24,this[n+2]=e>>>16,this[n+1]=e>>>8,this[n]=255&e):R(this,e,n,!0),n+4},u.prototype.writeUInt32BE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,4,4294967295,0),u.TYPED_ARRAY_SUPPORT?(this[n]=e>>>24,this[n+1]=e>>>16,this[n+2]=e>>>8,this[n+3]=255&e):R(this,e,n,!1),n+4},u.prototype.writeIntLE=function(e,n,t,r){if(e=+e,n|=0,!r){var i=Math.pow(2,8*t-1);O(this,e,n,t,i-1,-i)}var o=0,a=1,s=0;for(this[n]=255&e;++o<t&&(a*=256);)e<0&&0===s&&0!==this[n+o-1]&&(s=1),this[n+o]=(e/a>>0)-s&255;return n+t},u.prototype.writeIntBE=function(e,n,t,r){if(e=+e,n|=0,!r){var i=Math.pow(2,8*t-1);O(this,e,n,t,i-1,-i)}var o=t-1,a=1,s=0;for(this[n+o]=255&e;--o>=0&&(a*=256);)e<0&&0===s&&0!==this[n+o+1]&&(s=1),this[n+o]=(e/a>>0)-s&255;return n+t},u.prototype.writeInt8=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,1,127,-128),u.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),e<0&&(e=255+e+1),this[n]=255&e,n+1},u.prototype.writeInt16LE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,2,32767,-32768),u.TYPED_ARRAY_SUPPORT?(this[n]=255&e,this[n+1]=e>>>8):M(this,e,n,!0),n+2},u.prototype.writeInt16BE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,2,32767,-32768),u.TYPED_ARRAY_SUPPORT?(this[n]=e>>>8,this[n+1]=255&e):M(this,e,n,!1),n+2},u.prototype.writeInt32LE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,4,2147483647,-2147483648),u.TYPED_ARRAY_SUPPORT?(this[n]=255&e,this[n+1]=e>>>8,this[n+2]=e>>>16,this[n+3]=e>>>24):R(this,e,n,!0),n+4},u.prototype.writeInt32BE=function(e,n,t){return e=+e,n|=0,t||O(this,e,n,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),u.TYPED_ARRAY_SUPPORT?(this[n]=e>>>24,this[n+1]=e>>>16,this[n+2]=e>>>8,this[n+3]=255&e):R(this,e,n,!1),n+4},u.prototype.writeFloatLE=function(e,n,t){return P(this,e,n,!0,t)},u.prototype.writeFloatBE=function(e,n,t){return P(this,e,n,!1,t)},u.prototype.writeDoubleLE=function(e,n,t){return L(this,e,n,!0,t)},u.prototype.writeDoubleBE=function(e,n,t){return L(this,e,n,!1,t)},u.prototype.copy=function(e,n,t,r){if(t||(t=0),r||0===r||(r=this.length),n>=e.length&&(n=e.length),n||(n=0),r>0&&r<t&&(r=t),r===t)return 0;if(0===e.length||0===this.length)return 0;if(n<0)throw new RangeError("targetStart out of bounds");if(t<0||t>=this.length)throw new RangeError("sourceStart out of bounds");if(r<0)throw new RangeError("sourceEnd out of bounds");r>this.length&&(r=this.length),e.length-n<r-t&&(r=e.length-n+t);var i,o=r-t;if(this===e&&t<n&&n<r)for(i=o-1;i>=0;--i)e[i+n]=this[i+t];else if(o<1e3||!u.TYPED_ARRAY_SUPPORT)for(i=0;i<o;++i)e[i+n]=this[i+t];else Uint8Array.prototype.set.call(e,this.subarray(t,t+o),n);return o},u.prototype.fill=function(e,n,t,r){if("string"==typeof e){if("string"==typeof n?(r=n,n=0,t=this.length):"string"==typeof t&&(r=t,t=this.length),1===e.length){var i=e.charCodeAt(0);i<256&&(e=i)}if(void 0!==r&&"string"!=typeof r)throw new TypeError("encoding must be a string");if("string"==typeof r&&!u.isEncoding(r))throw new TypeError("Unknown encoding: "+r)}else"number"==typeof e&&(e&=255);if(n<0||this.length<n||this.length<t)throw new RangeError("Out of range index");if(t<=n)return this;var o;if(n>>>=0,t=void 0===t?this.length:t>>>0,e||(e=0),"number"==typeof e)for(o=n;o<t;++o)this[o]=e;else{var a=u.isBuffer(e)?e:q(new u(e,r).toString()),s=a.length;for(o=0;o<t-n;++o)this[o+n]=a[o%s]}return this};var z=/[^+\/0-9A-Za-z-_]/g;function U(e){return e<16?"0"+e.toString(16):e.toString(16)}function q(e,n){var t;n=n||1/0;for(var r=e.length,i=null,o=[],a=0;a<r;++a){if((t=e.charCodeAt(a))>55295&&t<57344){if(!i){if(t>56319){(n-=3)>-1&&o.push(239,191,189);continue}if(a+1===r){(n-=3)>-1&&o.push(239,191,189);continue}i=t;continue}if(t<56320){(n-=3)>-1&&o.push(239,191,189),i=t;continue}t=65536+(i-55296<<10|t-56320)}else i&&(n-=3)>-1&&o.push(239,191,189);if(i=null,t<128){if((n-=1)<0)break;o.push(t)}else if(t<2048){if((n-=2)<0)break;o.push(t>>6|192,63&t|128)}else if(t<65536){if((n-=3)<0)break;o.push(t>>12|224,t>>6&63|128,63&t|128)}else{if(!(t<1114112))throw new Error("Invalid code point");if((n-=4)<0)break;o.push(t>>18|240,t>>12&63|128,t>>6&63|128,63&t|128)}}return o}function I(e){return r.toByteArray(function(e){if((e=function(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}(e).replace(z,"")).length<2)return"";for(;e.length%4!=0;)e+="=";return e}(e))}function N(e,n,t,r){for(var i=0;i<r&&!(i+t>=n.length||i>=e.length);++i)n[i+t]=e[i];return i}}).call(this,t(1))},function(e,n,t){"use strict";n.byteLength=function(e){var n=c(e),t=n[0],r=n[1];return 3*(t+r)/4-r},n.toByteArray=function(e){for(var n,t=c(e),r=t[0],a=t[1],s=new o(function(e,n,t){return 3*(n+t)/4-t}(0,r,a)),u=0,f=a>0?r-4:r,l=0;l<f;l+=4)n=i[e.charCodeAt(l)]<<18|i[e.charCodeAt(l+1)]<<12|i[e.charCodeAt(l+2)]<<6|i[e.charCodeAt(l+3)],s[u++]=n>>16&255,s[u++]=n>>8&255,s[u++]=255&n;2===a&&(n=i[e.charCodeAt(l)]<<2|i[e.charCodeAt(l+1)]>>4,s[u++]=255&n);1===a&&(n=i[e.charCodeAt(l)]<<10|i[e.charCodeAt(l+1)]<<4|i[e.charCodeAt(l+2)]>>2,s[u++]=n>>8&255,s[u++]=255&n);return s},n.fromByteArray=function(e){for(var n,t=e.length,i=t%3,o=[],a=0,s=t-i;a<s;a+=16383)o.push(l(e,a,a+16383>s?s:a+16383));1===i?(n=e[t-1],o.push(r[n>>2]+r[n<<4&63]+"==")):2===i&&(n=(e[t-2]<<8)+e[t-1],o.push(r[n>>10]+r[n>>4&63]+r[n<<2&63]+"="));return o.join("")};for(var r=[],i=[],o="undefined"!=typeof Uint8Array?Uint8Array:Array,a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s=0,u=a.length;s<u;++s)r[s]=a[s],i[a.charCodeAt(s)]=s;function c(e){var n=e.length;if(n%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var t=e.indexOf("=");return-1===t&&(t=n),[t,t===n?0:4-t%4]}function f(e){return r[e>>18&63]+r[e>>12&63]+r[e>>6&63]+r[63&e]}function l(e,n,t){for(var r,i=[],o=n;o<t;o+=3)r=(e[o]<<16&16711680)+(e[o+1]<<8&65280)+(255&e[o+2]),i.push(f(r));return i.join("")}i["-".charCodeAt(0)]=62,i["_".charCodeAt(0)]=63},function(e,n){n.read=function(e,n,t,r,i){var o,a,s=8*i-r-1,u=(1<<s)-1,c=u>>1,f=-7,l=t?i-1:0,p=t?-1:1,h=e[n+l];for(l+=p,o=h&(1<<-f)-1,h>>=-f,f+=s;f>0;o=256*o+e[n+l],l+=p,f-=8);for(a=o&(1<<-f)-1,o>>=-f,f+=r;f>0;a=256*a+e[n+l],l+=p,f-=8);if(0===o)o=1-c;else{if(o===u)return a?NaN:1/0*(h?-1:1);a+=Math.pow(2,r),o-=c}return(h?-1:1)*a*Math.pow(2,o-r)},n.write=function(e,n,t,r,i,o){var a,s,u,c=8*o-i-1,f=(1<<c)-1,l=f>>1,p=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,h=r?0:o-1,d=r?1:-1,m=n<0||0===n&&1/n<0?1:0;for(n=Math.abs(n),isNaN(n)||n===1/0?(s=isNaN(n)?1:0,a=f):(a=Math.floor(Math.log(n)/Math.LN2),n*(u=Math.pow(2,-a))<1&&(a--,u*=2),(n+=a+l>=1?p/u:p*Math.pow(2,1-l))*u>=2&&(a++,u/=2),a+l>=f?(s=0,a=f):a+l>=1?(s=(n*u-1)*Math.pow(2,i),a+=l):(s=n*Math.pow(2,l-1)*Math.pow(2,i),a=0));i>=8;e[t+h]=255&s,h+=d,s/=256,i-=8);for(a=a<<i|s,c+=i;c>0;e[t+h]=255&a,h+=d,a/=256,c-=8);e[t+h-d]|=128*m}},function(e,n){var t={}.toString;e.exports=Array.isArray||function(e){return"[object Array]"==t.call(e)}},function(e,n,t){n.SourceMapGenerator=t(2).SourceMapGenerator,n.SourceMapConsumer=t(13).SourceMapConsumer,n.SourceNode=t(16).SourceNode},function(e,n){var t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");n.encode=function(e){if(0<=e&&e<t.length)return t[e];throw new TypeError("Must be between 0 and 63: "+e)},n.decode=function(e){return 65<=e&&e<=90?e-65:97<=e&&e<=122?e-97+26:48<=e&&e<=57?e-48+52:43==e?62:47==e?63:-1}},function(e,n,t){var r=t(0);function i(){this._array=[],this._sorted=!0,this._last={generatedLine:-1,generatedColumn:0}}i.prototype.unsortedForEach=function(e,n){this._array.forEach(e,n)},i.prototype.add=function(e){!function(e,n){var t=e.generatedLine,i=n.generatedLine,o=e.generatedColumn,a=n.generatedColumn;return i>t||i==t&&a>=o||r.compareByGeneratedPositionsInflated(e,n)<=0}(this._last,e)?(this._sorted=!1,this._array.push(e)):(this._last=e,this._array.push(e))},i.prototype.toArray=function(){return this._sorted||(this._array.sort(r.compareByGeneratedPositionsInflated),this._sorted=!0),this._array},n.MappingList=i},function(e,n,t){var r=t(0),i=t(14),o=t(4).ArraySet,a=t(3),s=t(15).quickSort;function u(e,n){var t=e;return"string"==typeof e&&(t=r.parseSourceMapInput(e)),null!=t.sections?new l(t,n):new c(t,n)}function c(e,n){var t=e;"string"==typeof e&&(t=r.parseSourceMapInput(e));var i=r.getArg(t,"version"),a=r.getArg(t,"sources"),s=r.getArg(t,"names",[]),u=r.getArg(t,"sourceRoot",null),c=r.getArg(t,"sourcesContent",null),f=r.getArg(t,"mappings"),l=r.getArg(t,"file",null);if(i!=this._version)throw new Error("Unsupported version: "+i);u&&(u=r.normalize(u)),a=a.map(String).map(r.normalize).map(function(e){return u&&r.isAbsolute(u)&&r.isAbsolute(e)?r.relative(u,e):e}),this._names=o.fromArray(s.map(String),!0),this._sources=o.fromArray(a,!0),this._absoluteSources=this._sources.toArray().map(function(e){return r.computeSourceURL(u,e,n)}),this.sourceRoot=u,this.sourcesContent=c,this._mappings=f,this._sourceMapURL=n,this.file=l}function f(){this.generatedLine=0,this.generatedColumn=0,this.source=null,this.originalLine=null,this.originalColumn=null,this.name=null}function l(e,n){var t=e;"string"==typeof e&&(t=r.parseSourceMapInput(e));var i=r.getArg(t,"version"),a=r.getArg(t,"sections");if(i!=this._version)throw new Error("Unsupported version: "+i);this._sources=new o,this._names=new o;var s={line:-1,column:0};this._sections=a.map(function(e){if(e.url)throw new Error("Support for url field in sections not implemented.");var t=r.getArg(e,"offset"),i=r.getArg(t,"line"),o=r.getArg(t,"column");if(i<s.line||i===s.line&&o<s.column)throw new Error("Section offsets must be ordered and non-overlapping.");return s=t,{generatedOffset:{generatedLine:i+1,generatedColumn:o+1},consumer:new u(r.getArg(e,"map"),n)}})}u.fromSourceMap=function(e,n){return c.fromSourceMap(e,n)},u.prototype._version=3,u.prototype.__generatedMappings=null,Object.defineProperty(u.prototype,"_generatedMappings",{configurable:!0,enumerable:!0,get:function(){return this.__generatedMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__generatedMappings}}),u.prototype.__originalMappings=null,Object.defineProperty(u.prototype,"_originalMappings",{configurable:!0,enumerable:!0,get:function(){return this.__originalMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__originalMappings}}),u.prototype._charIsMappingSeparator=function(e,n){var t=e.charAt(n);return";"===t||","===t},u.prototype._parseMappings=function(e,n){throw new Error("Subclasses must implement _parseMappings")},u.GENERATED_ORDER=1,u.ORIGINAL_ORDER=2,u.GREATEST_LOWER_BOUND=1,u.LEAST_UPPER_BOUND=2,u.prototype.eachMapping=function(e,n,t){var i,o=n||null;switch(t||u.GENERATED_ORDER){case u.GENERATED_ORDER:i=this._generatedMappings;break;case u.ORIGINAL_ORDER:i=this._originalMappings;break;default:throw new Error("Unknown order of iteration.")}var a=this.sourceRoot;i.map(function(e){var n=null===e.source?null:this._sources.at(e.source);return{source:n=r.computeSourceURL(a,n,this._sourceMapURL),generatedLine:e.generatedLine,generatedColumn:e.generatedColumn,originalLine:e.originalLine,originalColumn:e.originalColumn,name:null===e.name?null:this._names.at(e.name)}},this).forEach(e,o)},u.prototype.allGeneratedPositionsFor=function(e){var n=r.getArg(e,"line"),t={source:r.getArg(e,"source"),originalLine:n,originalColumn:r.getArg(e,"column",0)};if(t.source=this._findSourceIndex(t.source),t.source<0)return[];var o=[],a=this._findMapping(t,this._originalMappings,"originalLine","originalColumn",r.compareByOriginalPositions,i.LEAST_UPPER_BOUND);if(a>=0){var s=this._originalMappings[a];if(void 0===e.column)for(var u=s.originalLine;s&&s.originalLine===u;)o.push({line:r.getArg(s,"generatedLine",null),column:r.getArg(s,"generatedColumn",null),lastColumn:r.getArg(s,"lastGeneratedColumn",null)}),s=this._originalMappings[++a];else for(var c=s.originalColumn;s&&s.originalLine===n&&s.originalColumn==c;)o.push({line:r.getArg(s,"generatedLine",null),column:r.getArg(s,"generatedColumn",null),lastColumn:r.getArg(s,"lastGeneratedColumn",null)}),s=this._originalMappings[++a]}return o},n.SourceMapConsumer=u,c.prototype=Object.create(u.prototype),c.prototype.consumer=u,c.prototype._findSourceIndex=function(e){var n,t=e;if(null!=this.sourceRoot&&(t=r.relative(this.sourceRoot,t)),this._sources.has(t))return this._sources.indexOf(t);for(n=0;n<this._absoluteSources.length;++n)if(this._absoluteSources[n]==e)return n;return-1},c.fromSourceMap=function(e,n){var t=Object.create(c.prototype),i=t._names=o.fromArray(e._names.toArray(),!0),a=t._sources=o.fromArray(e._sources.toArray(),!0);t.sourceRoot=e._sourceRoot,t.sourcesContent=e._generateSourcesContent(t._sources.toArray(),t.sourceRoot),t.file=e._file,t._sourceMapURL=n,t._absoluteSources=t._sources.toArray().map(function(e){return r.computeSourceURL(t.sourceRoot,e,n)});for(var u=e._mappings.toArray().slice(),l=t.__generatedMappings=[],p=t.__originalMappings=[],h=0,d=u.length;h<d;h++){var m=u[h],_=new f;_.generatedLine=m.generatedLine,_.generatedColumn=m.generatedColumn,m.source&&(_.source=a.indexOf(m.source),_.originalLine=m.originalLine,_.originalColumn=m.originalColumn,m.name&&(_.name=i.indexOf(m.name)),p.push(_)),l.push(_)}return s(t.__originalMappings,r.compareByOriginalPositions),t},c.prototype._version=3,Object.defineProperty(c.prototype,"sources",{get:function(){return this._absoluteSources.slice()}}),c.prototype._parseMappings=function(e,n){for(var t,i,o,u,c,l=1,p=0,h=0,d=0,m=0,_=0,g=e.length,v=0,D={},y={},b=[],w=[];v<g;)if(";"===e.charAt(v))l++,v++,p=0;else if(","===e.charAt(v))v++;else{for((t=new f).generatedLine=l,u=v;u<g&&!this._charIsMappingSeparator(e,u);u++);if(o=D[i=e.slice(v,u)])v+=i.length;else{for(o=[];v<u;)a.decode(e,v,y),c=y.value,v=y.rest,o.push(c);if(2===o.length)throw new Error("Found a source, but no line and column");if(3===o.length)throw new Error("Found a source and line, but no column");D[i]=o}t.generatedColumn=p+o[0],p=t.generatedColumn,o.length>1&&(t.source=m+o[1],m+=o[1],t.originalLine=h+o[2],h=t.originalLine,t.originalLine+=1,t.originalColumn=d+o[3],d=t.originalColumn,o.length>4&&(t.name=_+o[4],_+=o[4])),w.push(t),"number"==typeof t.originalLine&&b.push(t)}s(w,r.compareByGeneratedPositionsDeflated),this.__generatedMappings=w,s(b,r.compareByOriginalPositions),this.__originalMappings=b},c.prototype._findMapping=function(e,n,t,r,o,a){if(e[t]<=0)throw new TypeError("Line must be greater than or equal to 1, got "+e[t]);if(e[r]<0)throw new TypeError("Column must be greater than or equal to 0, got "+e[r]);return i.search(e,n,o,a)},c.prototype.computeColumnSpans=function(){for(var e=0;e<this._generatedMappings.length;++e){var n=this._generatedMappings[e];if(e+1<this._generatedMappings.length){var t=this._generatedMappings[e+1];if(n.generatedLine===t.generatedLine){n.lastGeneratedColumn=t.generatedColumn-1;continue}}n.lastGeneratedColumn=1/0}},c.prototype.originalPositionFor=function(e){var n={generatedLine:r.getArg(e,"line"),generatedColumn:r.getArg(e,"column")},t=this._findMapping(n,this._generatedMappings,"generatedLine","generatedColumn",r.compareByGeneratedPositionsDeflated,r.getArg(e,"bias",u.GREATEST_LOWER_BOUND));if(t>=0){var i=this._generatedMappings[t];if(i.generatedLine===n.generatedLine){var o=r.getArg(i,"source",null);null!==o&&(o=this._sources.at(o),o=r.computeSourceURL(this.sourceRoot,o,this._sourceMapURL));var a=r.getArg(i,"name",null);return null!==a&&(a=this._names.at(a)),{source:o,line:r.getArg(i,"originalLine",null),column:r.getArg(i,"originalColumn",null),name:a}}}return{source:null,line:null,column:null,name:null}},c.prototype.hasContentsOfAllSources=function(){return!!this.sourcesContent&&(this.sourcesContent.length>=this._sources.size()&&!this.sourcesContent.some(function(e){return null==e}))},c.prototype.sourceContentFor=function(e,n){if(!this.sourcesContent)return null;var t=this._findSourceIndex(e);if(t>=0)return this.sourcesContent[t];var i,o=e;if(null!=this.sourceRoot&&(o=r.relative(this.sourceRoot,o)),null!=this.sourceRoot&&(i=r.urlParse(this.sourceRoot))){var a=o.replace(/^file:\/\//,"");if("file"==i.scheme&&this._sources.has(a))return this.sourcesContent[this._sources.indexOf(a)];if((!i.path||"/"==i.path)&&this._sources.has("/"+o))return this.sourcesContent[this._sources.indexOf("/"+o)]}if(n)return null;throw new Error('"'+o+'" is not in the SourceMap.')},c.prototype.generatedPositionFor=function(e){var n=r.getArg(e,"source");if((n=this._findSourceIndex(n))<0)return{line:null,column:null,lastColumn:null};var t={source:n,originalLine:r.getArg(e,"line"),originalColumn:r.getArg(e,"column")},i=this._findMapping(t,this._originalMappings,"originalLine","originalColumn",r.compareByOriginalPositions,r.getArg(e,"bias",u.GREATEST_LOWER_BOUND));if(i>=0){var o=this._originalMappings[i];if(o.source===t.source)return{line:r.getArg(o,"generatedLine",null),column:r.getArg(o,"generatedColumn",null),lastColumn:r.getArg(o,"lastGeneratedColumn",null)}}return{line:null,column:null,lastColumn:null}},n.BasicSourceMapConsumer=c,l.prototype=Object.create(u.prototype),l.prototype.constructor=u,l.prototype._version=3,Object.defineProperty(l.prototype,"sources",{get:function(){for(var e=[],n=0;n<this._sections.length;n++)for(var t=0;t<this._sections[n].consumer.sources.length;t++)e.push(this._sections[n].consumer.sources[t]);return e}}),l.prototype.originalPositionFor=function(e){var n={generatedLine:r.getArg(e,"line"),generatedColumn:r.getArg(e,"column")},t=i.search(n,this._sections,function(e,n){var t=e.generatedLine-n.generatedOffset.generatedLine;return t||e.generatedColumn-n.generatedOffset.generatedColumn}),o=this._sections[t];return o?o.consumer.originalPositionFor({line:n.generatedLine-(o.generatedOffset.generatedLine-1),column:n.generatedColumn-(o.generatedOffset.generatedLine===n.generatedLine?o.generatedOffset.generatedColumn-1:0),bias:e.bias}):{source:null,line:null,column:null,name:null}},l.prototype.hasContentsOfAllSources=function(){return this._sections.every(function(e){return e.consumer.hasContentsOfAllSources()})},l.prototype.sourceContentFor=function(e,n){for(var t=0;t<this._sections.length;t++){var r=this._sections[t].consumer.sourceContentFor(e,!0);if(r)return r}if(n)return null;throw new Error('"'+e+'" is not in the SourceMap.')},l.prototype.generatedPositionFor=function(e){for(var n=0;n<this._sections.length;n++){var t=this._sections[n];if(-1!==t.consumer._findSourceIndex(r.getArg(e,"source"))){var i=t.consumer.generatedPositionFor(e);if(i)return{line:i.line+(t.generatedOffset.generatedLine-1),column:i.column+(t.generatedOffset.generatedLine===i.line?t.generatedOffset.generatedColumn-1:0)}}}return{line:null,column:null}},l.prototype._parseMappings=function(e,n){this.__generatedMappings=[],this.__originalMappings=[];for(var t=0;t<this._sections.length;t++)for(var i=this._sections[t],o=i.consumer._generatedMappings,a=0;a<o.length;a++){var u=o[a],c=i.consumer._sources.at(u.source);c=r.computeSourceURL(i.consumer.sourceRoot,c,this._sourceMapURL),this._sources.add(c),c=this._sources.indexOf(c);var f=null;u.name&&(f=i.consumer._names.at(u.name),this._names.add(f),f=this._names.indexOf(f));var l={source:c,generatedLine:u.generatedLine+(i.generatedOffset.generatedLine-1),generatedColumn:u.generatedColumn+(i.generatedOffset.generatedLine===u.generatedLine?i.generatedOffset.generatedColumn-1:0),originalLine:u.originalLine,originalColumn:u.originalColumn,name:f};this.__generatedMappings.push(l),"number"==typeof l.originalLine&&this.__originalMappings.push(l)}s(this.__generatedMappings,r.compareByGeneratedPositionsDeflated),s(this.__originalMappings,r.compareByOriginalPositions)},n.IndexedSourceMapConsumer=l},function(e,n){n.GREATEST_LOWER_BOUND=1,n.LEAST_UPPER_BOUND=2,n.search=function(e,t,r,i){if(0===t.length)return-1;var o=function e(t,r,i,o,a,s){var u=Math.floor((r-t)/2)+t,c=a(i,o[u],!0);return 0===c?u:c>0?r-u>1?e(u,r,i,o,a,s):s==n.LEAST_UPPER_BOUND?r<o.length?r:-1:u:u-t>1?e(t,u,i,o,a,s):s==n.LEAST_UPPER_BOUND?u:t<0?-1:t}(-1,t.length,e,t,r,i||n.GREATEST_LOWER_BOUND);if(o<0)return-1;for(;o-1>=0&&0===r(t[o],t[o-1],!0);)--o;return o}},function(e,n){function t(e,n,t){var r=e[n];e[n]=e[t],e[t]=r}function r(e,n,i,o){if(i<o){var a=i-1;t(e,function(e,n){return Math.round(e+Math.random()*(n-e))}(i,o),o);for(var s=e[o],u=i;u<o;u++)n(e[u],s)<=0&&t(e,a+=1,u);t(e,a+1,u);var c=a+1;r(e,n,i,c-1),r(e,n,c+1,o)}}n.quickSort=function(e,n){r(e,n,0,e.length-1)}},function(e,n,t){var r=t(2).SourceMapGenerator,i=t(0),o=/(\r?\n)/,a="$$$isSourceNode$$$";function s(e,n,t,r,i){this.children=[],this.sourceContents={},this.line=null==e?null:e,this.column=null==n?null:n,this.source=null==t?null:t,this.name=null==i?null:i,this[a]=!0,null!=r&&this.add(r)}s.fromStringWithSourceMap=function(e,n,t){var r=new s,a=e.split(o),u=0,c=function(){return e()+(e()||"");function e(){return u<a.length?a[u++]:void 0}},f=1,l=0,p=null;return n.eachMapping(function(e){if(null!==p){if(!(f<e.generatedLine)){var n=(t=a[u]||"").substr(0,e.generatedColumn-l);return a[u]=t.substr(e.generatedColumn-l),l=e.generatedColumn,h(p,n),void(p=e)}h(p,c()),f++,l=0}for(;f<e.generatedLine;)r.add(c()),f++;if(l<e.generatedColumn){var t=a[u]||"";r.add(t.substr(0,e.generatedColumn)),a[u]=t.substr(e.generatedColumn),l=e.generatedColumn}p=e},this),u<a.length&&(p&&h(p,c()),r.add(a.splice(u).join(""))),n.sources.forEach(function(e){var o=n.sourceContentFor(e);null!=o&&(null!=t&&(e=i.join(t,e)),r.setSourceContent(e,o))}),r;function h(e,n){if(null===e||void 0===e.source)r.add(n);else{var o=t?i.join(t,e.source):e.source;r.add(new s(e.originalLine,e.originalColumn,o,n,e.name))}}},s.prototype.add=function(e){if(Array.isArray(e))e.forEach(function(e){this.add(e)},this);else{if(!e[a]&&"string"!=typeof e)throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+e);e&&this.children.push(e)}return this},s.prototype.prepend=function(e){if(Array.isArray(e))for(var n=e.length-1;n>=0;n--)this.prepend(e[n]);else{if(!e[a]&&"string"!=typeof e)throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+e);this.children.unshift(e)}return this},s.prototype.walk=function(e){for(var n,t=0,r=this.children.length;t<r;t++)(n=this.children[t])[a]?n.walk(e):""!==n&&e(n,{source:this.source,line:this.line,column:this.column,name:this.name})},s.prototype.join=function(e){var n,t,r=this.children.length;if(r>0){for(n=[],t=0;t<r-1;t++)n.push(this.children[t]),n.push(e);n.push(this.children[t]),this.children=n}return this},s.prototype.replaceRight=function(e,n){var t=this.children[this.children.length-1];return t[a]?t.replaceRight(e,n):"string"==typeof t?this.children[this.children.length-1]=t.replace(e,n):this.children.push("".replace(e,n)),this},s.prototype.setSourceContent=function(e,n){this.sourceContents[i.toSetString(e)]=n},s.prototype.walkSourceContents=function(e){for(var n=0,t=this.children.length;n<t;n++)this.children[n][a]&&this.children[n].walkSourceContents(e);var r=Object.keys(this.sourceContents);for(n=0,t=r.length;n<t;n++)e(i.fromSetString(r[n]),this.sourceContents[r[n]])},s.prototype.toString=function(){var e="";return this.walk(function(n){e+=n}),e},s.prototype.toStringWithSourceMap=function(e){var n={code:"",line:1,column:0},t=new r(e),i=!1,o=null,a=null,s=null,u=null;return this.walk(function(e,r){n.code+=e,null!==r.source&&null!==r.line&&null!==r.column?(o===r.source&&a===r.line&&s===r.column&&u===r.name||t.addMapping({source:r.source,original:{line:r.line,column:r.column},generated:{line:n.line,column:n.column},name:r.name}),o=r.source,a=r.line,s=r.column,u=r.name,i=!0):i&&(t.addMapping({generated:{line:n.line,column:n.column}}),o=null,i=!1);for(var c=0,f=e.length;c<f;c++)10===e.charCodeAt(c)?(n.line++,n.column=0,c+1===f?(o=null,i=!1):i&&t.addMapping({source:r.source,original:{line:r.line,column:r.column},generated:{line:n.line,column:n.column},name:r.name})):n.column++}),this.walkSourceContents(function(e,n){t.setSourceContent(e,n)}),{code:n.code,map:t}},n.SourceNode=s}]);